//===========================================================================
// script.js
// Steampunk Media Player Widget  2.0.2
// Written and Steampunked by: Dean Beedell
// Dean.beedell@lightquick.co.uk
//===========================================================================
// |||||||
// widget.WindowZPosition = 2 (keep topmost) / 1 (topmost) / 0 (normal) / -1 (bottom)
// 
// revisit the countDirContents to test the filecount and why it is different
// scrolling beyond the last page should be prevented
// print statements
// function descriptions
// checks CD drive present
// fixed bug with using own trim Function
// added deletion buttons
// changed red tap to a hints toggle
// added sounds for the chain pull and the keypresses
// added the menu option to install the font
// bug when cancelling after pressing the F to read an XML file - fixed
// grouped the bottom keys, to allow the button fade needs to stop when the keys are being used
// modify the drop position to take into account the page number
// added the ability to delete a track from the playlist
// 
// moved the bottom keys down a tadge
// added the ability to stop the keys from fading via a click on the keyframe
// added code to better handle the prefsFileName
// added read from default ini file in Xwidget folder
// added write to new ini file in user documents folder due to Win10 protection of the program files folders
// saves the chosen folders to the main menu
// key fade bug seems to require a widget restart
// add confirm dialog on delete
// fixed bug in displaying the wrong track to delete
// added more information to the delete hint
// menus - sort them to sub-menus
// automatic play and the autoplay lug, when it is switched off the automatic play should stop
// add the clear playlist functionality via a physical switch
// add some pipes/cables to the play list to connect the player
// when the tracklist is short (less than one page) only the tracks that are present should display delete buttons
// add controls to open folders/files   - easy
// add controls for external player     - easy
// add code for the controls to open folders/files   - easy
// add code for controls for external player     - easy
// new prefs page for videos
// add code to play videos   - complex
// add efficiency code in loops for all multiple elements - abandoned the idea as foreach is not implemeneted in jscript
// change all foreach loops to for loopsfor compatibility with Xwidget - abandoned as Xwidgets is crippled,
//     does not allow functions to be assigned to objects in code
//     does not allow an array to alias an existing object of the same name
// added keyd image and associated code
// added keyf image and associated code
// added keyFullScreen image and associated code
// added keyViewScreen image and associated code
//
//===========================================================================

var mdx,mdy,ndx,ndy,pdx,pdy;
var sliderMouseWheelClicked = false;
var wheelX = 10;
var size = 1,
         maxLength = 100,
         minLength = 10,
         ticks = 18
         var Scale = 1;

var perc=0;
var fontDefault = preferencesPopupPanelFontSizePrefValue.text;

var windowPos = 0;

var buzzer = "buzzer.wav";
var zzzz = "zzzz.wav";
var tingingSound = "ting.wav";
var currIcon = "speaker.png";
var lock = "lock.wav";
var winding = "winding.wav";
var creturn = "creturn.wav";
var keypress = "keypress.wav";
var steamSound = "steamsound.wav";
var slidingClunk = "slidingclunk.wav";
var mistake = "mistake.wav";
var thhhh = "thhhh.wav";

var originalCableWidth = cable.width;

//  ActiveX access to the windows media player
var WMPlayer = new ActiveXObject("WMPlayer.OCX.7");
WMPlayer.settings.setMode("loop", false);
WMPlayer.settings.autoStart = false;

var thePlayList;
var IsPlaylist;
var playIndex = 0;
var trackIndex = 0;

var CDROM = WMPlayer.cdromCollection;
var cdRomNo = 0;
var CDROMcount = CDROM.count;

var isAudioCD = false;
var isFolder = false;
var filePlayList = 0;
var currentFile;
var playListfileCount = 0;
var sliderSetClicked = false;
var positionSliderClicked = false;
var playlistSliderClicked = false;
var drvCnt = 0;
var playerState = "none";

var storedWMPpos = 0;
var stuckCycleCount = 0;
var zeroCycleCount = 0;
var playOverride = false;


var trackNumber = [];   // new Array(11);
var trackName = [];     // new Array(11);
var fullTrackName = []; // new Array(11);
var chunkSize = 12;
var chunkIndex = 0;
var debugFlg = preferencesDebugflgPrefValue.text;
var idxFile = 0;
var chosenFolder = "";
var fileCountLimit = 10000;
var path = null;
var dragPosition = 99999999;

// this list has to be doubled to take into account accidental renaming of suffixes to capitalised state
// the list is passed to in-built functions where the input filename cannot be handled by js code
// so the list is simply uppercase-d and doubled up.

var validTypesLcase = ["mpeg","mp4","m4a","mpg","flv","mp3","aac","wav","wma","aif","aiff","au","snd"];  //array
var validTypesUcase =  String.prototype.toUpperCase.apply(validTypesLcase).split(",");
var validTypes =  validTypesLcase + "," + validTypesUcase;   // validTypes is now a string and not an array

var videoTypesLcase = ["mpeg", "mp4", "mpg", "flv"];
var videoTypesUcase =  String.prototype.toUpperCase.apply(videoTypesLcase).split(",");
var videoTypes =  videoTypesLcase + "," + videoTypesUcase;   // videoTypes is now a string and not an array

// this is the YWE code that does not work on xwidget
//var validTypesLcase = [".mpeg", ".mp4", ".m4a", ".mpg", ".flv", ".mp3", ".aac", ".wav", ".wma", ".aif", ".aiff", ".au", ".snd"];
//var validTypesUcase = validTypesLcase.join(",").toUpperCase().split(",");
//var validTypes = validTypesLcase.concat(validTypesUcase);

var file_extension = "";

// active X variables for font extraction
var fontArray ;
var currentFontPos = 0;
var HKLM = 0x80000002;

var createNewList = 0; // this determines whether you can drag/drop or not.
var trackFailCnt = 0;
var filePlayedWell = 0;
preferencesErrorMessagesPrefValue.text = "enabled"; // at the mo' reset whenever the widget is restarted

var busyCounter = 1;
startupTimeout = 1;

var ctrlPressed = 0;
var searchString = "";
var searchStringPosition = 0;

//drag and drop vars
var dragDropFlg = 0;
var trackClickedFlg = 0;
var savedReplacedTrack = "";
var partlySelectedTrack = "";

var partlySelectedFullTrack = "";
var playlistSliderDragged = false;
var savFullTrackName = "";
var fullTrackNameToDrop = "";

var wmpAllowApp = (preferencesWmpAllowPrefValue.text === "1");

var currentButtonStatus;
var trackListFileFormat = "xspf";

var time = new Date();
var savedTime = time;
var prefsFileName = "Xmedia_player_prefs.ini";

wsc=new ActiveXObject("WScript.Shell");
widget.WindowZPosition = 0;

//===========================================
// this function runs on startup
//===========================================
function widgetOnLoad() {
    dprint ("%-I-INFO, startup");
    startupFlg = 1;
    widget.MagneticBorders=0;
    checkPrefs();
    getPrefs();                       // set the preferences - required by Xwidget as it has no native prefs
    createLicence();
    mainScreen();                     // check the widget is on-screen
    resize();                         // resize if required               

    lockWidget();
    checkPath();
    startVolume();                    // check the start volume levels
    setmenu();                        // build the menu
    settooltip();                     // build the tooltips

    checkLocked();       // set the widget lock status if pinned
    
    // the saved shuffle status is set during the check of the ply state below
    checkStartupPlayState(); // set the autoplay state - if autoplay then reads the default folder
    checkAutoPlayState();
    if (preferencesPlayListPrefValue.text == "enabled") {
       playlistFrame.visible = true;
     } else {
        playlistFrame.visible = false;
    }
    // update the playlist only when not shuffled as the same routine is called after the re-shuffling
    if (preferencesShuffleStatePrefValue.text != "enabled") {
		updatePlayList();
    }
    setFont();
    ShowFontList();   // gets the font list from the registry
    checkFullScreen();             // Function to check the fullScreen value and set the toggle
    checkViewScreen();             // Function to check the keyViewScreen value and set the toggle
 
    checkFadeState();

    busyStop();
    }
//=====================
//End function
//=====================



//===========================================
// Function to set the media player volume
//===========================================
function checkFadeState() {
    if (preferencesPlayListKeysPrefValue.text === "solid") {
        fadeTimer.enabled = false;
    } else {
        fadeTimer.enabled = true;
    }
}
//=====================
//End function
//=====================

//===========================================
// Function
//===========================================
function busyStop() {
    dprint("%busyStop - stopping the busy timer ");
    busyTimer.enabled=false;
    busy.visible=false;
    busyBlur.visible=false;
}
//=====================
//End function
//=====================


//===========================================
// Function
//===========================================
function setFont() {
    dprint ("%-I-INFO, setFont");
    playListTitle.Font.Family = preferencesPopupPanelFont.text;
    playListPage.Font.Family = preferencesPopupPanelFont.text;
    playListText0.Font.Family = preferencesPopupPanelFont.text;
    playListText1.Font.Family = preferencesPopupPanelFont.text;
    playListText2.Font.Family = preferencesPopupPanelFont.text;
    playListText3.Font.Family = preferencesPopupPanelFont.text;
    playListText4.Font.Family = preferencesPopupPanelFont.text;
    playListText5.Font.Family = preferencesPopupPanelFont.text;
    playListText6.Font.Family = preferencesPopupPanelFont.text;
    playListText7.Font.Family = preferencesPopupPanelFont.text;
    playListText8.Font.Family = preferencesPopupPanelFont.text;
    playListText9.Font.Family = preferencesPopupPanelFont.text;
    playListText10.Font.Family = preferencesPopupPanelFont.text;
    playListText11.Font.Family = preferencesPopupPanelFont.text;
    
    playListTitle.font.size = fontDefault;
    playListPage.font.size = fontDefault;
    playListText0.font.size = fontDefault;
    playListText1.font.size = fontDefault;
    playListText2.font.size = fontDefault;
    playListText3.font.size = fontDefault;
    playListText4.font.size = fontDefault;
    playListText5.font.size = fontDefault;
    playListText6.font.size = fontDefault;
    playListText7.font.size = fontDefault;
    playListText8.font.size = fontDefault;
    playListText9.font.size = fontDefault;
    playListText10.font.size = fontDefault;
    playListText11.font.size = fontDefault;
}
//=====================
//End function
//=====================


//===========================================
// Functions for use with runCommand
//===========================================
function quotePath(path) {
	//return "\"" + convertPathToPlatform(path).replace(/\"/g, "\\\"") + "\"";   //nyi
	return "\"" + path.replace(/\"/g, "\\\"") + "\"";
}
//=====================
//End functions
//=====================

//===========================================
// Functions for use with runCommand
//===========================================
function escapePath(path) {
	return path.replace(/([\W])/g, '\\$1');
}
//=====================
//End functions
//=====================



//=========================================================
// Function to stretch the cable
//=========================================================
 function stretchCable() {
    var scaleamount,
    cableWidth;

    //now calculate the stretch of the cable
    cable.left = sliderSet.left + sliderSet.width - 2 ;
    cableWidth = (cableWheelSet.left + cableWheelSet.width) - (cable.left);

    // Xwidgets do not handle width in the same way as YWE so cannot be used for resizing
    // we use the Xwidgets scaleto function instead
    // now actually stretch or scale the cable
    scaleamount = cableWidth / originalCableWidth;
    cable.scaleto(scaleamount,1,0.0000000001,"");        //resizing function
    cable.left = sliderSet.left + sliderSet.width - 2 ;  //must be here after the scaleto
}
//=====================
//End function
//=====================


//===========================================
// function to test whether the media player is muted
//===========================================
function testmute() {
    dprint ("%-I-INFO, testmute");
    log("running start volume " + WMPlayer.settings.mute);
    if (WMPlayer.settings.mute) {
        indicatorRed.src = "indicatorRed.png";
    } else {
        indicatorRed.src = "indicatorGreen.png";
    }
}
//=====================
//End function
//=====================


//=========================================================
// Function to determine the system sound levels at startup
//=========================================================
function startVolume() {

    dprint ("%-I-INFO, startVolume");
    testmute();
    //autoplay levels
    //set the last used volume level in percent from the slider.
    preferencesVolumePrefValue.text = preferencesAutoPlayVolumePrefValue.text;
    //default levels (stored)
    WMPlayer.settings.volume = preferencesVolumePrefValue.text;
    //dprint("WMPlayer.settings.volume "+ WMPlayer.settings.volume);
    sliderSet.left = ((bar.left + 25) + (WMPlayer.settings.volume));
    perc = parseInt(WMPlayer.settings.volume, 10);
    //percentTextShadow.data = perc + "%";
    percentText.text = perc + "%";
    stretchCable();

}
//=====================
//End function
//=====================



//===========================================
// Function to set the media player volume
//===========================================
function setVol() {
    //dprint ("%-I-INFO, setVol");

    WMPlayer.settings.volume = perc;
    oldVol = WMPlayer.settings.volume;
    preferencesVolumePrefValue.text = perc;
}
//=====================
//End function
//=====================

//===========================================
// Function to slide the volume slider
//===========================================
function sliderSetOnMouseMove(Sender,Shift,X,Y,Dx,Dy) {
  var rightmost,
        leftmost,
        sliderwidth,
        currpos;
  if(sliderSetClicked)
  {
    Sender.left = Sender.left + X - mdx;
    //determine slider travel limits
    rightmost = bar.left + bar.width - (100 ); // limit
    leftmost = bar.left + (25 ); //  limit
    if (sliderSet.left >= rightmost) {
        sliderSet.left = rightmost;
    }
    if (sliderSet.left <= leftmost) {
        sliderSet.left = leftmost;
    }
    stretchCable();

    //calculate the percentage
    sliderwidth = rightmost - leftmost;
    currpos = sliderSet.left - leftmost;
    perc = parseInt((currpos / sliderwidth) * 100);
    if (perc < 0) {
        perc = 0;
    }

    setVol();

    percentText.text = perc + "%";     //achieved automatically by binding the text control to the volumecore
    //log ("system.volume = " + system.volume);
  }
}
//=====================
//End function
//=====================

//===========================================
// Function to determine what happens when the mouse is pressed on the size slider
//===========================================
function sliderSetOnMouseDown(Sender,Button,Shift,X,Y)
{
   //checkTimer.enabled = false;
   sliderSetClicked = true;
   mdx = X;
   mdy = Y;
   //if (preferencesHintsPrefValue.text == "enabled") { 
      //sliderSet.hint.enabled = false;   // the hint gets in the way on the Xwidget
   //}
}
//=====================
//End function
//=====================



//===========================================
// Function to determine what happens when the mouse is lifted from the size slider
//===========================================
function sliderSetOnMouseUp(Sender,Button,Shift,X,Y)
{
    setVol();
    if (sliderSetClicked === true) {
        sliderSetClicked = false;
        //checkTimer.enabled = true;
        //if (preferencesHintsPrefValue.text == "enabled") {
              //sliderSet.Hint.enabled = true;
        //}
    }
    if (preferencesSoundprefValue.text === "enabled") {
              //dprint("1. Playing the sound");
              PlaySound(zzzz);
    }
    //log("Running function sizeSliderMouseUp clicked is now "+ clicked);
}
//=====================
//End function
//=====================







//===========================================
// Function to set the media player volume
//===========================================
function setVol() {
    //dprint ("%-I-INFO, setVol");

    WMPlayer.settings.volume = perc;
    oldVol = WMPlayer.settings.volume;
    preferencesVolumePrefValue.text = perc;
}
//=====================
//End function
//=====================


//===========================================
// Function to determine what happens when the mouse is pressed on the position slider
//===========================================
function positionSliderOnMouseDown(Sender,Button,Shift,X,Y) {
//      log("Running function sliderSetOnMouseDown");
   positionSliderSetClicked = true;
   ndx = X;
   ndy = Y;
   currentButtonStatus = "positionslider";
   positionSliderClicked = true;
//      log("Leaving function sliderSetOnMouseDown " +clicked);
}
//=====================
//End function
//=====================

//===========================================
// Function to determine what happens when the mouse is lifted from the position slider
//===========================================
function positionSliderOnMouseUp() {
    currentButtonStatus = "";
    if (positionSliderClicked === true) {
        positionSliderClicked = false;
        //positionSlider.onMouseMove = null;  //nn
    }
//log("Running function sliderSetOnMouseUp clicked is now "+ clicked);
}
//=====================
//End function
//=====================

//===========================================
// Function to slide the graphical position slider
//===========================================
function positionSliderOnMouseMove(Sender,Shift,X,Y,Dx,Dy) {
  if(positionSliderClicked)
  {
    Sender.left = Sender.left + X - ndx;
    constrainPositionSlider();
  }
}
//=====================
//End function
//=====================


//===================================
// function to move/constrain the track position slider
//===================================
function constrainPositionSlider() {
    var positionSliderRightmost,
        positionSliderLeftMost,
        positionSliderSliderwidth,
        positionSliderCurrpos,
        positionSliderperc;

//determine slider travel limits
    positionSliderRightmost = (120) + positionSlider.width ; //positionSliderLeftMost limit
    //dprint("positionSliderRightmost "+positionSliderRightmost);
    //dprint("positionSlider.width "+positionSlider.width);
    positionSliderLeftMost = (55) ; // positionSliderRightmost limit
    //dprint("positionSliderLeftMost "+positionSliderLeftMost);
    if (positionSlider.left >= positionSliderRightmost) { //568
        positionSlider.left = positionSliderRightmost;
    }
    if (positionSlider.left <= positionSliderLeftMost) { //262
        positionSlider.left = positionSliderLeftMost;
    }
//calculate the percentage
    positionSliderSliderwidth = positionSliderRightmost - positionSliderLeftMost;
    positionSliderCurrpos = positionSlider.left - positionSliderLeftMost;
    positionSliderperc = parseInt((positionSliderCurrpos / positionSliderSliderwidth) * 100, 10);
    if (positionSliderperc < 0) {
        positionSliderperc = 0;
    }
    WMPlayer.controls.currentPosition = (positionSliderperc * WMPlayer.currentMedia.duration) /100;
}
//=====================
//End function
//=====================

//===================================
// function called by the sliderTimer on a small interval, it sets the graphical slider position automatically to correspond with the Windows Media player actual position
//===================================
function setSliderPosition() {
    var positionSliderRightmost,
        positionSliderLeftMost,
        positionSliderSliderwidth,
        positionSliderCurrpos,
        positionSliderperc,
        wmplayerPerc;
    //dprint ("setSliderPosition counting");

	if(!positionSliderClicked && WMPlayer.currentMedia )
        {
            positionSliderRightmost = (120 ) + positionSlider.width ; //positionSliderLeftMost limit
            positionSliderLeftMost = (55 ) ; // positionSliderRightmost limit
            positionSliderSliderwidth = positionSliderRightmost - positionSliderLeftMost;

            wmplayerPerc =  (WMPlayer.controls.currentPosition / WMPlayer.currentMedia.duration) *100;
            positionSlider.left = ((positionSliderSliderwidth * wmplayerPerc)/100) + positionSliderLeftMost;
            // dprint ("positionSliderSliderwidth " +positionSliderSliderwidth);
            // dprint ("positionSliderLeftMost " +positionSliderLeftMost);
            // dprint ("wmplayerPerc " +wmplayerPerc);
            // dprint ("positionSlider.hOffset " +positionSlider.hOffset);
        }
}
//=====================
//End function
//=====================

//===================================
// function called by the position timer every 2 secs to check the current media player position and select the next track when this track ends
//===================================
function checkPosition() {
    var answer;
    var triggerNext = 0;
    // To allow for WMP's bad handling of flv files.
    // if the currentPosition value has not changed for two cycles, select the next track
    // dprint("checking position");

    // increment the stuck count
    if (storedWMPpos === WMPlayer.controls.currentPosition) {
        dprint("incrementing the stuck cycle count");
        stuckCycleCount = stuckCycleCount + 1;
    }

    if (filePlayedWell === 0 && WMPlayer.controls.currentPosition === 0) {
        dprint("Found Beginning of Track");
        busyTimer.enabled = true;
    }

    if (filePlayedWell === 1 && WMPlayer.controls.currentPosition === 0) {
        dprint("Found End of Track");
        if (preferencesAutoPlayStatePrefValue.text === "enabled") {
           busyTimer.enabled = true;
        } else {
             positionTimer.enabled = false;
             playButton.visible = true;
             pauseButton.visible = false;
                busyStop();
        }
    }
    //dean
    // if the file has been successfully played but the file is stuck at the beginning of the track
    if (filePlayedWell === 1 && stuckCycleCount >= 2) {
        dprint("file played so incrementing the stuck cycle count");

        triggerNext = 1;
        stuckCycleCount = 0;
        if (!isAudioCD) {
            // something later
            //throw new Error("checkPosition");
            dprint("checkPosition: empty block");
        }
    }

    // if the file hasn't yet been played and the cycle is stuck then the codec isn't installed
    if (storedWMPpos === WMPlayer.controls.currentPosition && filePlayedWell === 0 && stuckCycleCount >= 2) {
        dprint("file hasn't yet been played and the cycle is stuck ");
        if ((WMPlayer.currentMedia.duration <= 6) && (WMPlayer.currentMedia.duration >= 0)) {
            // when a track is less than six seconds long do not roll the timer
            triggerNext = 1;
            stuckCycleCount = 0;
        } else {
            positionTimer.enabled = false; // pause the position timer to prevent multiple messages
            triggerNext = 1;
            stuckCycleCount = 0;
            if (!isAudioCD) {
                if (preferencesErrorMessagesPrefValue.text === "enabled") {
	                      if (confirm2("Trying to play this file " + WMPlayer.URL + String.fromCharCode(13) + String.fromCharCode(13) + "However, your version of Windows does not recognise this type of file ." + file_extension + String.fromCharCode(13) + "Search internet for codecs that will support this file type? "))
                              {
		               openURL("https://www.google.co.uk/?gws_rd=ssl#q=windows+media+player+codecs+for+"+file_extension);
                               }
                }
                trackFailCnt = trackFailCnt + 1;
                if ((preferencesErrorMessagesPrefValue.text === "enabled") && (trackFailCnt >= 2)) {
	                      if (confirm2("Do you want me to stop these annoying error messages? "))
                              {
		                 preferencesErrorMessagesPrefValue.text = "disabled";
                              } else {
                                 trackFailCnt = 0;
                              }
                }
            }
            positionTimer.enabled = true;  // restart the position timer to allow future checks
        }
    } else {
        //dprint("storedWMPpos " + storedWMPpos);
        //dprint("WMPlayer.controls.currentPosition " + WMPlayer.controls.currentPosition);
        //dprint("stuckCycleCount " + stuckCycleCount);
        //dprint("filePlayedWell " + filePlayedWell);
        //dprint("checkPosition: empty block");
    }
    // check the value of the WMP current position and store it
    storedWMPpos = WMPlayer.controls.currentPosition;
    if (storedWMPpos > 0) {
        filePlayedWell = 1;
    }

    //if (debugFlg === "1") {dprint("checking every 2 secs ");}

    // the WMP end of track is indicated by a zero position but obviously the start is too -
    // so we have a short delay before we select the next track
    // if the trigger has been set then select the next track
    //only automati1cally play the next track when the autoplay lug is set


    if (triggerNext === 1) {
        if (preferencesAutoPlayStatePrefValue.text === "enabled") {
            dprint("WMPlayer.controls.currentPosition " + WMPlayer.controls.currentPosition);
            dprint("zeroCycleCount " + zeroCycleCount);
            dprint("triggerNext " + triggerNext);

            zeroCycleCount = 0;
            WMPlayer.controls.currentPosition = 0;
            positionTimer.enabled = true;
            //if playing a single track set the buttons
            if (playerState === "single") {
                playButton.visible = true;
                pauseButton.visible = false;
            } else {
                // only skip the track if not a CD, CDs can be slow to initialise
                if (!isAudioCD) {
                    // cause the next track to play if a folder selected
                    if (playIndex + 1 < playListfileCount) {
                        playIndex += 1;
                        if (playIndex % chunkSize === 0) {
                            chunkIndex = Math.floor(playIndex / chunkSize);
                            updatePlayList();
                        }
                    } else {
                        playIndex = 0;
                        chunkIndex = 0;
                        updatePlayList();
                    }
                    filePlayedWell = 0;
                    dprint("Automatically playing next track ");
                }
                dprint("checkpostion - playMedia - playIndex = " + playIndex);

                arse(playIndex);

                positionTimer.enabled = true;
                busyStop();
            }
        } else {
            stuckcyclecount = 0;
        }
    } else {
        stuckcyclecount = 0;
        //busyStop();
    }
    zeroCycleCount = zeroCycleCount + 1;
}
//=====================
//End function
//=====================



//=================================================================
// Function - when the mouse is released when over the volumeDevice or the sliderSet
//=================================================================
function sliderSetOnMouseWheelUp(Sender)
{
        sliderMouseWheelClicked = true;
        //dprint ("Wheel up Sender.left " + Sender.left);
        if ( preferencesMouseWheelVolumePrefValue.text == "right" ) {
               sliderSet.left = sliderSet.left + wheelX;
        } else {
               sliderSet.left = sliderSet.left - wheelX;
        }

        limitSliderSet();
}
//=====================
//End function
//=====================


//================================================================
// Function - when the mouse is pressed when over the volumeDevice or the sliderSet
//================================================================
function sliderSetOnMouseWheelDown(Sender){
        //dprint ("Wheel down Sender.left " + Sender.left);
        sliderMouseWheelClicked = true;
        if ( preferencesMouseWheelVolumePrefValue.text == "right" ) {
               sliderSet.left = sliderSet.left - wheelX;
        } else {
               sliderSet.left = sliderSet.left + wheelX;
        }

        limitSliderSet();
}
//=====================
//End function
//=====================



//===========================================
// Function to slide the volume slider
//===========================================
function limitSliderSet() {
  var rightmost,
        leftmost,
        sliderwidth,
        currpos;


    //determine slider travel limits
    //dprint("sliderMouseWheelClicked Clicked " + sliderMouseWheelClicked);
    rightmost = bar.left + bar.width - (100 ); // limit
    leftmost = bar.left + (25 ); //  limit
    if (sliderSet.left >= rightmost) {
        sliderSet.left = rightmost;
    }
    if (sliderSet.left <= leftmost) {
        sliderSet.left = leftmost;
    }
    stretchCable();

    //calculate the percentage
    sliderwidth = rightmost - leftmost;
    currpos = sliderSet.left - leftmost;
    perc = parseInt((currpos / sliderwidth) * 100);
    if (perc < 0) {
        perc = 0;
    }
    setVol();
    percentText.text = perc + "%";     //achieved automatically by binding the text control to the volumecore
    //log ("system.volume = " + system.volume);

  if (preferencesSoundprefValue.text === "enabled") {
              dprint("2. Playing the sound");
              PlaySound(zzzz);
  }
  sliderMouseWheelClicked = false;

}
//=====================
//End function
//=====================



//==============================
// pins the widget in place
//==============================
function lockAreaOnMouseDown(Sender,Button,Shift,X,Y){
   toggleLock();
}


//===================================
// function to toggle the lock state
//===================================
function toggleLock() {
        if (!widget.lockposition) {
               //dprint("ere 1.");
		widget.lockposition = true;
                preferencesWidgetLockPrefValue.text = "1";
		lockAreaFree.visible = false;
		lockAreaLocked.visible = true;
                preferenceshoffsetprefvalue.text = widget.left;
                preferencesvoffsetprefvalue.text = widget.top;
	} else {
                //dprint("ere 2.");
                widget.lockposition = false;
                preferencesWidgetLockPrefValue.text = "0";
		lockAreaFree.visible = true;
		lockAreaLocked.visible = false;
                preferenceshoffsetprefvalue.text = "";
                preferencesvoffsetprefvalue.text = "";
        }

	if (preferencesSoundprefValue.text === "enabled") {
		PlaySound(lock);
	}
}
//=====================
//End function
//=====================


//==============================
// pins the widget in place
//==============================
function lockWidget() {
	if (widget.lockposition) {
               //dprint("ere 1.");
		lockAreaFree.visible = false;
		lockAreaLocked.visible = true;

	} else {
                //dprint("ere 2.");
		lockAreaFree.visible = true;
		lockAreaLocked.visible = false;

        }

	if (preferencesSoundprefValue.text === "enabled") {
		PlaySound(lock);
	}
};


//===================================
// set the widget lock status if pinned
//===================================
function checkLocked() {
    dprint ("%-I-INFO, checkLocked");
    if (preferencesWidgetLockPrefValue.text === "1") {
		widget.lockposition = true;
                //dprint ( "Setting the locking pin ",lockAreaFree.top);
		lockAreaFree.visible=false;
		lockAreaLocked.visible=true;
      	        if (preferencesSoundprefValue.text === "enabled") {
      		   PlaySound(lock);
      	        }
    }
};
//=====================
//End function
//=====================



//======================================================================================
// END script volume.js
//======================================================================================


//===========================================================================
// functions.js
// Steampunk Volume Xwidget  1.0.0
// Written and Steampunked by: Dean Beedell
// Dean.beedell@lightquick.co.uk
//===========================================================================

//======================================================================================
// Function to move the main_window onto the main screen
//======================================================================================
function mainScreen() {
    // if the widget is off screen then move into the viewable window

    if ( preferenceshoffsetprefvalue.text !="" ) {
              widget.left= preferenceshoffsetprefvalue.text;
    }
    if (preferencesvoffsetprefvalue.text !="" ) {
              widget.top=preferencesvoffsetprefvalue.text;
    }
    if (widget.left < 0) {
        widget.left = 10;
    }
    if (widget.top < 0) {
        widget.top = 10;
    }
}
//=====================
//End function
//=====================

//==============================================================
// function to resize all images using the volumeDevice single layer
//==============================================================
function resize() {
    var Scale = Number(preferencessizePrefvalue.percent) / 100;
    volumeDevice.scaleto(Scale,Scale,0.0000000001,"topleft");
    volumeDevice.visible = true;
}
//=====================
//End function
//=====================


//===========================================
// this function opens the online help file
//===========================================
function menuitem1OnClick(Sender)
{
          if (confirm2("This button opens a browser window and connects to the help page for this widget. Will you proceed?"))
          {
              OpenURL("http://lightquick.co.uk/instructions-for-the-steampunk-media-player-xwidget.html");
          }
}
//=====================
//End function
//=====================

//=========================================================================
// this function
//=========================================================================
function menuitem2OnClick(Sender)
{
          if (confirm2("Help support the creation of more widgets like this, send us a beer! This button opens a browser window and connects to the Paypal donate page for this widget). Will you be kind and proceed?"))
          {
                openURL("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=info@lightquick.co.uk&currency_code=GBP&amount=2.50&return=&item_name=Donate%20a%20Beer");
		if (preferencesSoundprefValue.text === "enabled") {
			PlaySound(winding);
		}
           }
}
//=====================
//End function
//=====================

//=========================================================================
// this function
//=========================================================================
function menuitem3OnClick(Sender)
{
          if (confirm2("Help support the creation of more widgets like this. Buy me a small item on my Amazon wishlist! This button opens a browser window and connects to my Amazon wish list page). Will you be kind and proceed?"))
          {
               openURL("http://www.amazon.co.uk/gp/registry/registry.html?ie=UTF8&id=A3OBFB6ZN4F7&type=wishlist");
          }
}
//=====================
//End function
//=====================

//=========================================================================
// this function
//=========================================================================
function menuitem4OnClick(Sender)
{
          if (confirm2("Log in and vote for the widget on Rocketdock. This button opens a browser window and connects to the Rocketdock page where you can give the widget a 5 star rating... Will you be kind and proceed?"))
          {
		openURL("http://rocketdock.com/addon/icons/46779");
		if (preferencesSoundprefValue.text === "enabled") {
			PlaySound(winding);
		}
          }
}
//=====================
//End function
//=====================
//===========================================
// this function opens other widgets URL
//===========================================
function menuitem5OnClick(Sender)
{
          if (confirm2("This button opens a browser window and connects to the Steampunk widgets page on my site. Do you wish to proceed?"))
          {
                 openURL("http://lightquick.co.uk/steampunk-widgets.html?Itemid=264");
          }
}
//=====================
//End function
//=====================
//===========================================
// this function opens the download URL
//===========================================
function menuitem6OnClick(Sender)
{
          if (confirm2("Download latest version of the widget - this button opens a browser window and connects to the widget download page where you can check and download the latest zipped .WIDGET file). Proceed?"))
          {
              openURL("http://lightquick.co.uk/downloads/steampunk-media-player-xwidget.html?Itemid=264");
          }
}
//=====================
//End function
//=====================

//===========================================
// this function opens the browser at the contact URL
//===========================================
function menuitem7OnClick(Sender)
{
if (confirm2("Visiting the support page - this button opens a browser window and connects to our contact us page where you can send us a support query or just have a chat. Proceed?"))
          {
              openURL("http://lightquick.co.uk/contact.html?Itemid=3");
          }
}
//=====================
//End function
//=====================


//===========================================
// this function opens the browser at the contact URL
//===========================================
function facebookChat() {
if (confirm2("Visiting the Facebook chat page - this button opens a browser window and connects to our Facebook chat page. Proceed?"))
    {
        openURL("http://www.facebook.com/profile.php?id=100012278951649");
    }
}
//=====================
//End function
//=====================



//==============================================================
// this function sets the tooltip hints
//==============================================================
function settooltip() {
    if (preferencesHintsPrefValue.text == "enabled") {
    	cableWheelSet.hint = "";
	lockAreaFree.hint = "Click here to lock";
	lockAreaLocked.hint = "Click here to unlock";
	playListSlider.hint = "Slide this lug to the very bottom to clear the playlist.";
        endPipe.hint = "Click here to select a single file for playing";
        keyf.hint = "Click here to select a single file for playing.";
        keyu.hint = "Click here to enter the URL of a remote media file.";
        //helpLug.hint = "Click on me for help";
        autoPlayLug.hint = "Auto-playing next track is disabled";
        autoPlayLugEnabled.hint = "Auto-play next track is enabled";

        pipesRight.hint = "Shuffle the tracks";
        pipes.hint = "Double click on me to assign a double-click function to this widget";
        speaker.hint = "Click here to select a whole folder for playing";
        keyd.hint = "Click here to select a whole folder for playing. You can also drag/drop onto the playlist.";
        sliderSet.hint = "slide me to change the media player sound levels...";
        nextButton.hint = "Click me to select the next track";
        prevButton.hint = "Click me to select the preceding track";
        playButton.hint = "Click me to play the current track";
        pauseButton.hint = "Click me to pause the current track";
        positionSlider.hint = "Slide me to select any part of the track";
        firstChunk.hint = "Click to view first page of the playlist";
        lastChunk.hint = "Click to view last page of the playlist";
        nextChunk.hint = "Click to view next page of the playlist";
        prevChunk.hint = "Click to view the previous page of the playlist";
        if (preferencesPlaylistFormatPrefValue.text === "xml") {
            oButton.hint = "Open an XML formatted playlist.";
            sButton.hint = "Save a playlist in XML format.";
            playListTap.hint = "Click to change the playlist format to XSPF.";
        } else {
            oButton.hint = "Open an XSPF formatted playlist.";
            sButton.hint = "Save a playlist in XSPF format.";
            playListTap.hint = "Click to change the playlist format to XML.";
        }
        ovalButton.hint = "Search for a track here";
        tap.hint = "Toggle Hints on/off";
        chain.hint = "Pull me to toggle the playlist";
        bar.hint = preferenceswidgetTooltipvalue.text;
        busy.hint = "The player is doing something - Click to close early";
        deleteButton0.hint = "Click to delete";
        deleteButton1.hint = "Click to delete";
        deleteButton2.hint = "Click to delete";
        deleteButton3.hint = "Click to delete";
        deleteButton4.hint = "Click to delete";
        deleteButton5.hint = "Click to delete";
        deleteButton6.hint = "Click to delete";
        deleteButton7.hint = "Click to delete";
        deleteButton8.hint = "Click to delete";
        deleteButton9.hint = "Click to delete";
        deleteButton10.hint = "Click to delete";
        deleteButton11.hint = "Click to delete";
        playListTitle.hint =  "Double click here to open selected folder";
        if (preferencesFullscreenPrefValue.text === "1") {
            keyFullScreen.hint = "pulled out - external player full screen mode is enabled";
        } else {
            keyFullScreen.hint = "external player full screen mode is disabled";
        }
        if (preferencesWmpAllowPrefValue.text === "1") {
            keyViewScreen.hint = "pulled out - external player is enabled";
        } else {
            keyViewScreen.hint = "external player is disabled";
        }

    } else {
        cableWheelSet.hint = "";
        lockAreaFree.hint = "";
        lockAreaLocked.hint = "";
        endPipe.hint = "";
        //helpLug.hint = "";
        autoPlayLug.hint = "";
        autoPlayLugEnabled.hint = "";

	playListSlider.hint = "";
        keyf.hint = "";
        keyd.hint = "";
        keyu.hint = "";
        keyFullScreen.hint = "";
        keyViewScreen.hint = "";

        pipesRight.hint = "";
        pipes.hint = "";
        speaker.hint = "";
        sliderSet.hint = "";
        nextButton.hint = "";
        prevButton.hint = "";
        playButton.hint = "";
        pauseButton.hint = "";
        positionSlider.hint = "";
                firstChunk.hint = "";
                lastChunk.hint = "";
        nextChunk.hint = "";
        prevChunk.hint = "";
        oButton.hint = "";
        ovalButton.hint = "";
        sButton.hint = "";
        tap.hint = "";
        chain.hint = "";
        bar.hint = "";
        busy.hint = "";
        deleteButton0.hint = "";
        deleteButton1.hint = "";
        deleteButton2.hint = "";
        deleteButton3.hint = "";
        deleteButton4.hint = "";
        deleteButton5.hint = "";
        deleteButton6.hint = "";
        deleteButton7.hint = "";
        deleteButton8.hint = "";
        deleteButton9.hint = "";
        deleteButton10.hint = "";
        deleteButton11.hint = "";
        playListTitle.hint =  "";
    }
}
//=====================
//End function
//=====================

//======================================================================================
// Function to perform commands
//======================================================================================
function performCommand() {
    if ( preferencesimageCmdPrefvalue.text == "" )
    {
        if (confirm2("This widget has not been assigned a double-click function yet - You need to open the preferences and set a function for this widget. Do you wish to proceed?"))
        {
          fontPreferences.visible = false;
          musicPreferences.visible = false;
          commandsPreferences.visible = false;
          configPreferences.visible = true;
          soundPreferences.visible = false;
          prefsButtons.visible=true;
        }
    } else {
        if (preferencesSoundprefValue.text === "enabled") {
                PlaySound(tingingSound);
        }
        run(preferencesimageCmdPrefvalue.text);
    }
}
//=====================
//End function
//=====================


//===================================
// function to set the lock state
//===================================
function OpenMediaLocation() {
        if (fileExists(partlySelectedFullTrack) )   {
            var dosCommand = "Explorer.exe /e, /select," + partlySelectedFullTrack;
            //filesystem.reveal(partlySelectedFullTrack);
            run(dosCommand);
        }
}
//=====================
//End function
//=====================

//======================================================================================
// END script functions.js
//======================================================================================









//===========================================================================
// vitality.js
// Steampunk Volume Xwidget  1.0.0
// Written and Steampunked by: Dean Beedell
// Dean.beedell@lightquick.co.uk
//===========================================================================

//=========================================================================
// this function builds vitality for the dock
//=========================================================================
function buildVitality(bg, perc)
{

}
//=====================
//End function
//=====================



//======================================================================================
// END script vitality.js
//======================================================================================
















//===========================================================================
// kon.js  - this the file that corresponds roughly to the YWE .kon file
// Steampunk Volume Xwidget  1.0.0
// Written and Steampunked by: Dean Beedell
// Dean.beedell@lightquick.co.uk
//===========================================================================



//=========================================================================
// this function simply buzzes when
//=========================================================================
function button1OnMouseDown(Sender,Button,Shift,X,Y)
{
  if (preferencesSoundprefValue.text === "enabled" ) {
      PlaySound(buzzer);    //this won't sound when the mute is set
  }
      preferencesLicenceHideValue.text = "1";
      Licence.visible = false;
      SavePrefs();
}
//=====================
//End function
//=====================

//=====================
// this function calls the user-specified command on a double click on the speaker
//=====================
function playlistAreaOnDblClick(Sender)
{
  performCommand();
}
//=====================
//End function
//=====================

//==================================================
// this function calls the user-specified command on a double click on the speaker
//==================================================
function speakerOnDblClick(Sender)
{
  performCommand();
}
//=====================
//End function
//=====================

//==================================================
// this function calls the user-specified command on a double click on the pipes
//==================================================
function pipesOnDblClick(Sender)
{
  performCommand();
}
//=====================
//End function
//=====================

//==================================================
// this function calls the user-specified command on a double click on the slider bar
//==================================================
function barOnDblClick(Sender)
{
  performCommand();
}
//=====================
//End function
//=====================


//=========================================================================
// this function
//=========================================================================
function button1OnClick(Sender)
{
  button1OnMouseDown.click;
}
//=====================
//End function
//=====================

//=========================================================================
// this function shows the preferences when the first menu option is chosen
//=========================================================================
function menuitem8OnClick(Sender)
{
     keytimer.enabled=false;
     windowPos = widget.WindowZPosition;
     //configPreferences.top =  volumeDevice.top + 50;
     fontPreferences.visible = false;
     musicPreferences.visible = false;
     commandsPreferences.visible = false;
     configPreferences.visible = true;
     soundPreferences.visible = false;
     prefsButtons.visible=true;
     fontSquare.visible = false;
     musicSquare.visible = false;
     commandSquare.visible = false;
     configSquare.visible = true;
     soundSquare.visible = false;
     widget.WindowZPosition=1;
}
//=====================
//End function
//=====================

//=========================================================================
// this function saves the preferences to an ini file for later use
//=========================================================================
function saveButtonOnClick(Sender)
{       
        fontPreferences.visible = false;
        musicPreferences.visible = false;
        commandsPreferences.visible = false;
        configPreferences.visible = false;
        soundPreferences.visible = false;
        videoPreferences.visible = false;
         prefsButtons.visible=false;
         widget.WindowZPosition=windowPos;
         
         //dprint("preferencessizePrefvalue.percent "+ preferencessizePrefvalue.percent);
         SavePrefs();
         widget.WindowZPosition=windowPos;
         keytimer.enabled=true;
         widgetOnLoad();
}
//=====================
//End function
//=====================


//=========================================================================
// this function saves the preferences to an ini file for later use
//=========================================================================
function SavePrefs()
{
  // if the prefs file is currently pointing to the widget folder save it to the app data path
  if (prefsPath == WidgetPath) {
      prefsPath = MyDocumentPath;
  }



  //dprint(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>PrefsPath"+prefsPath);
  //dprint("preferencesMusicFolderPrefValue.text  "+preferencesMusicFolderPrefValue.text);
  //dprint(" "+ prefsPath+prefsFileName);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferenceshoffsetprefvalue",preferenceshoffsetprefvalue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesvoffsetprefvalue",preferencesvoffsetprefvalue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesSoundprefValue",preferencesSoundprefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferenceswidgetTooltipvalue",preferenceswidgetTooltipvalue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesimageCmdPrefvalue",preferencesimageCmdPrefvalue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencessizePrefvalue",preferencessizePrefvalue.percent);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesLicenceHideValue",preferencesLicenceHideValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMouseWheelResizingPrefValue",preferencesMouseWheelResizingPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMouseWheelScrollingPrefValue",preferencesMouseWheelScrollingPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMouseWheelVolumePrefValue",preferencesMouseWheelVolumePrefValue.text);

         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesPlayStatePrefValue",preferencesPlayStatePrefValue.text);

         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesHintsPrefValue", preferencesHintsPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesPopupPanelFontSizePrefValue", preferencesPopupPanelFontSizePrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","fontProgressbar", fontProgressbar.percent);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesPopupPanelFont", preferencesPopupPanelFont.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesTitlePrefValue", preferencesTitlePrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesRecurseFoldersPrefValue", preferencesRecurseFoldersPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref5Value", preferencesMusicFolderPref5Value.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref4Value",preferencesMusicFolderPref4Value.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref3Value",preferencesMusicFolderPref3Value.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref2Value",preferencesMusicFolderPref2Value.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPrefValue",preferencesMusicFolderPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesDebugflgPrefValue",preferencesDebugflgPrefValue.text);
         
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMinLengthValue",preferencesMinLengthValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMaxLengthValue",preferencesMaxLengthValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesMaxWidthPrefValue",preferencesMaxWidthPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesPlayListPrefValue",preferencesPlayListPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesWidgetLockPrefValue",preferencesWidgetLockPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesShuffleStatePrefValue",preferencesShuffleStatePrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesAutoPlayVolumePrefValue",preferencesAutoPlayVolumePrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","volumeProgressbar",volumeProgressbar.percent);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesVolumePrefValue",preferencesVolumePrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesScrollingPrefValue",preferencesScrollingPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesStartupPlayStatePrefValue",preferencesStartupPlayStatePrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesAutoPlayStatePrefValue",preferencesAutoPlayStatePrefValue.text);

         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesWMPApplicationPrefValue",preferencesWMPApplicationPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesFullscreenPrefValue",preferencesFullscreenPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesWmpAllowPrefValue",preferencesWmpAllowPrefValue.text);
         Setinivalue(prefsPath+prefsFileName,"prefs","preferencesPlayListKeysPrefValue",preferencesPlayListKeysPrefValue.text);

}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the preference values to the defaults for this widget
//=========================================================================
function defaultbuttonOnClick(Sender)
{
         preferenceshoffsetprefvalue.text= "";
         preferencesvoffsetprefvalue.text= "";
         preferenceswidgetTooltipvalue.text= "Double-Click on me to set the widget command";
         preferencesimageCmdPrefvalue.text= "control mmsys.cpl sounds";
         preferencessizePrefvalue.percent= 100;
         preferencesSoundprefValue.text="enabled";
}
//=====================
//End function
//=====================


//=========================================================================
// this function sets the preference values to saved values
//=========================================================================
function checkPrefs() {
  // if a prefs file exists in the appdata folder then use it
  dprint(" Checking "+ MyDocumentPath+prefsFileName);

  if (fileExists(MyDocumentPath+prefsFileName)) {
      prefsPath = MyDocumentPath;
      dprint(" Exists "+ MyDocumentPath+prefsFileName);
  } else {
      prefsPath = WidgetPath;
      dprint(" Using "+ WidgetPath+prefsFileName);
  }
  // if not then use the prefs file in the widget default folder
}
//=====================
//End function
//=====================

//=========================================================================
// this function sets the preference values to saved values
//=========================================================================
function getPrefs() {
    preferenceshoffsetprefvalue.text =     Getinivalue(prefsPath+prefsFileName,"prefs","preferenceshoffsetprefvalue","");
    preferencesvoffsetprefvalue.text =     Getinivalue(prefsPath+prefsFileName,"prefs","preferencesvoffsetprefvalue","");
    preferencesSoundprefValue.text =       Getinivalue(prefsPath+prefsFileName,"prefs","preferencesSoundprefValue","enabled");
    preferenceswidgetTooltipvalue.text =   Getinivalue(prefsPath+prefsFileName,"prefs","preferenceswidgetTooltipvalue","arseburgers");
    preferencesimageCmdPrefvalue.text =    Getinivalue(prefsPath+prefsFileName,"prefs","preferencesimageCmdPrefvalue","arseburgers");
    preferencessizePrefvalue.percent =     Getinivalue(prefsPath+prefsFileName,"prefs","preferencessizePrefvalue",100);
    preferencesLicenceHideValue.text =     Getinivalue(prefsPath+prefsFileName,"prefs","preferencesLicenceHideValue",0);
    preferencesMouseWheelResizingPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMouseWheelResizingPrefValue","");

    preferencesMouseWheelScrollingPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMouseWheelScrollingPrefValue","");
    preferencesMouseWheelVolumePrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMouseWheelVolumePrefValue","");

    preferencesPlayStatePrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesPlayStatePrefValue","right");
    preferencesHintsPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesHintsPrefValue","enabled");
    preferencesPopupPanelFontSizePrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesPopupPanelFontSizePrefValue","17");
    fontProgressbar.percent =  Getinivalue(prefsPath+prefsFileName,"prefs","fontProgressbar","17");

    preferencesPopupPanelFont.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesPopupPanelFont","times new roman");
    preferencesTitlePrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesTitlePrefValue","right");         //nyi
    preferencesRecurseFoldersPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesRecurseFoldersPrefValue","enabled");
    preferencesMusicFolderPref5Value.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref5Value","");
    preferencesMusicFolderPref4Value.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref4Value","");
    preferencesMusicFolderPref3Value.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref3Value","");
    preferencesMusicFolderPref2Value.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPref2Value","");
    preferencesMusicFolderPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMusicFolderPrefValue","");
    preferencesDebugflgPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesDebugflgPrefValue","1");

    preferencesMinLengthValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMinLengthValue","");      //nyi
    preferencesMaxLengthValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMaxLengthValue","");       //nyi
    preferencesMaxWidthPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesMaxWidthPrefValue","");  //nyi
    preferencesPlayListPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesPlayListPrefValue","enabled");
    preferencesWidgetLockPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesWidgetLockPrefValue","disabled");
    preferencesShuffleStatePrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesShuffleStatePrefValue","disabled");
    preferencesAutoPlayVolumePrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesAutoPlayVolumePrefValue","15");
    volumeProgressbar.percent =  Getinivalue(prefsPath+prefsFileName,"prefs","volumeProgressbar","15");
    preferencesVolumePrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesVolumePrefValue","15");
    preferencesScrollingPrefValue.text =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesScrollingPrefValue","enabled");
    preferencesStartupPlayStatePrefValue.text  =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesStartupPlayStatePrefValue","enabled");
    preferencesAutoPlayStatePrefValue.text  =  Getinivalue(prefsPath+prefsFileName,"prefs","preferencesAutoPlayStatePrefValue","enabled");
    if (preferencesSoundprefValue.text === "enabled") {
        soundbutton.src="bellpushed.png";         // this in place of a checkbutton which I could not get to work correctly
    } else {
        soundbutton.src="bell.png";
    }

  //dprint(" incoming >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>PrefsPath"+prefsPath);
  //dprint("preferencesMusicFolderPrefValue.text  "+preferencesMusicFolderPrefValue.text);
  //dprint(" "+ prefsPath+prefsFileName);


     preferencesWMPApplicationPrefValue.text =      Getinivalue(prefsPath+prefsFileName,"prefs","preferencesWMPApplicationPrefValue","");
     preferencesFullscreenPrefValue.text =      Getinivalue(prefsPath+prefsFileName,"prefs","preferencesFullscreenPrefValue","");
     preferencesWmpAllowPrefValue.text =      Getinivalue(prefsPath+prefsFileName,"prefs","preferencesWmpAllowPrefValue","");
     preferencesPlayListKeysPrefValue.text =      Getinivalue(prefsPath+prefsFileName,"prefs","preferencesPlayListKeysPrefValue","");


}
//=====================
//End function
//=====================



//=========================================================================
// this function links the URL on the top of the preferences page
//=========================================================================
function linkOnClick(Sender)
{
          if (confirm2("Visiting the widgets page - this button opens a browser window and connects to our widgets page where you can view the other widgets. Proceed?"))
          {
                   openURL("http://lightquick.co.uk/steampunk-widgets.html?Itemid=264");
          }
}
//=====================
//End function
//=====================

//=========================================================================
// this function states the slider size in percentage in the little box on the prefs page
//=========================================================================
function preferencessizePrefvalueOnChange(Sender)
{
     var  adjustedVal =      preferencessizePrefvalue.percent + 30;
     preferencessizePrefvalue.hint =     "The widget size will be "  + adjustedVal + "%";
     widgetSize.text =     adjustedVal +"%";
}
//=====================
//End function
//=====================

//=========================================================================
// this function stops the slider from following the mouse all the time
// and it acts as a flag to allow the checktimer to restart again.
//=========================================================================
function sliderSetOnMouseLeave(Sender)
{
  //sliderSetClicked=false;
}
//=====================
//End function
//=====================



//=========================================================================
// this function replicates the function of a checkbox because Xwidget checkbox
// logic did not always work.
//=========================================================================
function soundbuttonOnMouseDown(Sender,Button,Shift,X,Y)
{
  if (preferencesSoundprefValue.text === "enabled")
  {
      preferencesSoundprefValue.text = "disabled";
      soundbutton.src="bell.png";
  }
  else
  {
      preferencesSoundprefValue.text = "enabled";
      soundbutton.src="bellpushed.png";
  }
  PlaySound(buzzer);    //no test required - this won't sound when the mute is set
}
//=====================
//End function
//=====================



//======================================================================================
// END script kon.js
//======================================================================================






//=========================================================================
// this function closes the preferences
//=========================================================================
function button2OnClick()
{

}
//=====================
//End function
//=====================








//=========================================================================
// this function reloads the widget - but it doesn't...
//=========================================================================
function menuitem13OnClick(Sender)
{
         //widget.cmd("!Reload");

         widget.ForceToFround();
         wsc.SendKeys("{f5}");       
         
         //alert("You can reload all Xwidgets simply by pressing F5 when the widget is running.");
}


//============================
//
//============================
function menuitem14OnClick(Sender)
{
    Licence.Visible = true;
}
//============================
// End Function
//============================


//============================
//
//============================
function button4OnMouseDown(Sender,Button,Shift,X,Y)
{
        preferencesLicenceHideValue.text = "0";
        SavePrefs();
        widget.close
}
//============================
// End Function
//============================


//============================
//
//============================
function createLicence() {
	if (preferencesLicenceHideValue.text === "0") {
		Licence.visible = true;
	} else {
		Licence.visible   = false;
	}
}
//============================
// End Function
//============================


//============================
//
//============================
function button5OnMouseDown(Sender,Button,Shift,X,Y)
{
        if (preferencesMouseWheelVolumePrefValue.text === "right" ) {
               displayVolumeControl.text = "backward to increase volume";
               preferencesMouseWheelVolumePrefValue.text = "left" ;
        } else {
               displayVolumeControl.text = "forward to increase volume";
               preferencesMouseWheelVolumePrefValue.text = "right"  ;
        }
}
//============================
// End Function
//============================




//============================
//
//============================
function autoPlayLugOnMouseUp(Sender,Button,Shift,X,Y)
{
	toggleAutoPlay();     
}
//============================
// End Function
//============================



//===========================================
// this function opens the online help file
//===========================================
function helpScreen() {

  //if (playlistFrame.visible == "0") {  works
  //if (playlistFrame.visible == 0) {  works  
  //if (playlistFrame.visible === 0) {  works  
  //if (playlistFrame.visible === false) {  FAILS

  //if (playlistFrame.visible == "-1") {  works
  //if (playlistFrame.visible == -1) {  works
  //if (playlistFrame.visible === -1) {  works
  //if (playlistFrame.visible === true) {  FAILS
  if (playlistFrame.visible === -1) {
	helpLayer2.visible = true;
  } else {
  	helpLayer1.visible = true;
  }
  if (preferencesSoundprefValue.text === "enabled") {
      playSound(lock);
  }
 }
//=====================
//End function
//=====================


//============================
// Function that closes the help image
//============================
function helpImageOnClick(Sender)
{
         widget.WindowZPosition=windowPos;
         helpLayer1.visible = false;
         if (preferencesSoundprefValue.text === "enabled") {
                PlaySound(steamSound);
         }
         widget.WindowZPosition=0;
}
//============================
// End Function
//============================


//============================
// Function that allows the end pipe to make a sound
//============================
function endPipeOnClick(Sender)
{
  		if (preferencesSoundprefValue.text === "enabled") {
			PlaySound(winding);
		}
}
//============================
// End Function
//============================




//===========================================
// this function opens the browser to the LQ instructions URL
//===========================================
function helpUrlOnMouseDown(Sender,Button,Shift,X,Y)
{
          if (confirm2("This button opens a browser window and connects to the help page for this widget. Will you proceed?"))
          {
              OpenURL("http://lightquick.co.uk/instructions-for-the-panzer-clock-widget.html");
          }

}
//=====================
//End function
//=====================



//=========================================================================
// this function closes the about us image
//=========================================================================
function aboutUsImageOnMouseDown(Sender,Button,Shift,X,Y)
{
         aboutUs.FadeTo(0,1); // minimum fade time 1 second
         setTimeout("fadeDone",1000);

         //aboutUs.visible = false;     // not required
         if (preferencesSoundprefValue.text === "enabled") {
                PlaySound(tingingSound);
         }
}
//=====================
//End function
//=====================


//=========================================================================
// this function closes the about us image
//=========================================================================
function fadeDone () {
         aboutUs.opacity = 0;
         aboutUs.visible = false;  // otherwise the image is still clickable
         
}
//=====================
//End function
//=====================



function speakerOnMouseUp(Sender,Button,Shift,X,Y)
{
  openFolderToPlay();    
}
//=================================
// end function
//=================================

function endPipeOnMouseUp(Sender,Button,Shift,X,Y)
{
  //!OpenAddSongDialog     // used to be entered directly as a function
  addSingleTrack("local");

}




//===================================
// function to play a single music file
//===================================
function PlayFile(fileName) {
	isFolder = false;	//	var isFolder = false;

	dprint("%-I-INFO, PlayFile");

	if (fileName === "" || fileName === null) {
		return;
	}
	playListfileCount = 1;
	playIndex = 1;
	playerState = "single";
	isAudioCD = false;

        //<< DB01 STARTS
        WMPlayer.URL = fileName;
	sliderTimer.enabled = true;
	if (preferencesTitlePrefValue.text === "filename only") {
			trackNameText.text = "	 " + getFileOnly(WMPlayer.URL);
	} else {
			trackNameText.text = "	 " + WMPlayer.URL;
	}

	dprint("Playmedia Call no. 2");
        //<< DB01 ENDS

        //<< DB02 STARTS
	dropPosition = 0;
        catchFileDrop(fileName);
	//playMedia(0);
        //<< DB02 ENDS

	//setVolume();
	playIndex = 0;
	playButton.visible = false;
	pauseButton.visible = true;
	dprint("%-I-INFO, PlayFile finished");

}
//=====================
//End function
//=====================


//===================================
// function to select the URL for WMP given a path
//===================================
function FileMedia(path) {
	this.sourceURL = path;
}
//=====================
//End function
//=====================




//===================================
// function to open a folder and recursively read its contents into a playlist
//===================================
function readFolderRecursively(path) {
    var i;
    var convertedPath;
    var tmfilePlayList;
    var idxFile;
    var IsSong;
    
    dprint ("%-I-INFO, readFolderRecursively");
    isFolder = true;
	chunkIndex = 0;
	isAudioCD = false;
	IsPlaylist = false;
// 	chosenFolder = path;
	var fs = null;

        busyIconStartupTimer.enabled = true;  // show the busy timer

	//mediapopupplaque.visible = true;
	//sleep (350);
	
	//dprint("preferencesRecurseFoldersPrefValue.text "+preferencesRecurseFoldersPrefValue.text);
	if (preferencesRecurseFoldersPrefValue.text =="enabled") {
                // In the yahoo widget the getDirectoryContents when performed recursively can hang the widget in a loop until resources are used up
		// Instead the countDirContents function does that but when it reaches a limit of 10000 it aborts and generates an error.
                // This does not appear to be needed in the Xwidget implementation
                // The code here is retained for compatibility reasons and just in case there
                // is a top limit.
                
		// countDirContents does the recursive count manually but stops when it reaches a high number
                var interimFileCount = countDirContents(path);  
		//dprint("interimFileCount prior to recursive search "+ interimFileCount);
		//dprint("fileCountLimit "+ fileCountLimit);

	
                if (interimFileCount >= fileCountLimit ) {
			alert('In this folder and below there are more than "' + fileCountLimit + '" files the media player has to search through in order to build a playlist. This is too many. The widget will fail due to excessive memory usage. Select a sub-folder with less than "' + fileCountLimit + '" valid files or disable recursive search.');
			mediapopupplaque.visible = false;
			return;
		} else {

                        //dprint ("path "+ path );
                        //the xwidget getfilelist does not return an array but a bar-separated list
			fs = getFileList(path,validTypes,true);
		}
	} else {
		fs = getFileList(path,validTypes,false);
	}

	mediapopupplaque.visible = false;


	idxFile = 0;
	var idxFolder = 0;
	// convert the filelist into an array
        var FSarray = fs.split('|');
	playListfileCount = FSarray.length;
	//dprint("1>>>>>>>>>>>>>>Filesystem recursive search file count " +playListfileCount);

        tmfilePlayList = new Array(fs.length);
	dirList = new Array(fs.length);

	for(var i = 0; i < FSarray.length; i++) {	
             //dprint ("hereb "+path + "\\" + FSarray[i]);
             if (FSarray[i] != "" ) {
                // if this is not a directory
                if (! folderExists(FSarray[i]) )
                {
                        // difference here between the YWE version, the code to filter has been removed 
                        // as there no need to check it is a valid type as the dirlist is already filtered
                        // by the xwidget getfilelist function

                        //dprint("FSarray[i] " + FSarray[i]);
			
                        if (FSarray[i] != "" ) {
				IsSong = true;
			} else {
				IsSong = false;
			}
			
                        // if it is a valid type then add it to the list
			if (IsSong) {
                                // YWE version different as the full path is provided by getfilelist
				//tmfilePlayList[idxFile] = new FileMedia(path + "\\" + FSarray[i]);
				tmfilePlayList[idxFile] = new FileMedia(FSarray[i]);
                                idxFile++;
			}else {
				// do nothing
                                // dprint ("Found invalid types - "+ FSarray[i]);
                        }
                        

		} else {
			dirList[idxFolder] = new FileMedia(FSarray[i]);
			idxFolder++;
		}
	    }
	}
	dprint ("Filesystem valid file count - adding "+ idxFile + " valid files to list.");

	playListfileCount = idxFile;
	//dprint("2>>>>>>>>>>>>>>Filesystem recursive search file count " +playListfileCount);

	if (idxFile > 0) {
		thePlayList = new Array(idxFile);
		for(var i = 0; i < idxFile; i++) {
			thePlayList[i] = tmfilePlayList[i];
			IsPlaylist = true;
		}
                       dprint ("Playmedia Call no. 3");
                       playMedia(0);
	} else {
               alert('In this folder "' + path + '" there are no files the media player can use. Please select the folder where your music resides.');
               openFolderToPlay();
        }

	checkShuffleState();

}
//=====================
//End function
//=====================

 //=================================
// Function to count the folder contents folder by folder
//=================================
function countDirContents(path) {
    var totalFilesCount = 0;
    var files;
    var i;

    dprint ("%-I-INFO, countDirContents");
    dprint ("recursively checking the contents of this folder - " + path);

	// define the getFileList function
    nonRecursiveFileList = function (path, limit) {
		var result = [];
		
		if (! folderExists(path)) {
			return result;
		}
		
		if (limit === undefined) {
			limit = 10000;    // default limit, if limit parameter omitted
		}

                function getListing(path) {
                        //cannot use - pathString = getFileList(path,validTypes,false);
                        //there is a bug in the Xwidget getFileList function when used in non-recursive mode that 
                        //means it fails to report the subfolders contained within a folder 
                        //xwidget baulked at for each statements
                        
                        //dprint("testing using getFileList in non-recursive mode ");                           
                        pathString = getFileList(path,validTypes,false);                                                                                                                                                                     
                                                        
                        // convert to array
                        var paths = pathString.split('|');
                        for(var i = 0; i < paths.length; i++)
                        {
                                var fpath = paths[i];
				if (limit <= 0) {
					throw new Error("Limit Exceeded!");
				}

				result.push(fpath);
				limit -= 1;             // counts files found

			};
			
                        //get the sub-folder list
                        paths = filesystemGetDirectoryContents(path, false)  ;
                        /*
                        if (pathString == "") {
                               dprint("no subfolders found beneath "+path);
                        } else {
                               dprint("subfolder found in "+path);
                        }
                        */
                           
                        for(var i = 0; i < paths.length; i++)
                        {
                                var fpath = paths[i];

                                if (folderExists(fpath)) {
					//dprint("testing >>> "+fpath);
                                        getListing(fpath);
				}
			};                           

		}
		
		try {
			getListing(path);
		} catch (e) {
			//dprint(e);
		}
		return result;
	};
	
	files = nonRecursiveFileList(path, fileCountLimit);
	for(var i = 0; i < files.length; i++)
        {
		totalFilesCount  = totalFilesCount  + 1;
	};	 
	
	dprint("Interim manual file count prior to automatic recursive search "+ totalFilesCount);
	return totalFilesCount;
}
//=================================
// end function
//=================================


//===================================
// function to read the data from an audio CD into the playlist
//===================================
function PlayAudioCD(cdDriveName, cdRomPlayList) {
	// this function is the CD equivalent of readFolderRecursively
        dprint ("%-I-INFO, PlayAudioCD");
        isAudioCD = true;
	IsFolder = false;
	IsPlaylist = true;
        playerState = "AudioCD";
	oCDROM = CDROM.Item(cdDriveName);
	colPlaylist = oCDROM.Playlist;
	chunkIndex = 0;
	
	cdPlaylistTitles = new Array(cdRomPlayList.count);
	cdPlaylistArtists = new Array(cdRomPlayList.count);
        playListfileCount = cdRomPlayList.count;
        
        if (playListfileCount != 0) {
           //dprint ("****************************** playListfileCount " + playListfileCount);        
           for(var i = 0; i < cdRomPlayList.count; i++) {		
		if (!colPlaylist.Item(i)) {alert('CD drive is having a problem');};
		var objSong = colPlaylist.Item(i);
                //dprint ("objSong " + objSong);
		cdPlaylistTitles[i] = objSong.getItemInfo("title");
		cdPlaylistArtists[i] = objSong.getItemInfo("artist");

		thePlayList[i] = cdRomPlayList.Item(i);
		WMPlayer.URL = thePlayList[i].sourceURL;
		//dprint("2 WMPlayer.URL "+WMPlayer.URL);
		//dprint("cdPlaylist[i].sourceURL "+thePlayList[i].sourceURL);
		
		var artist = trim(cdPlaylistArtists[i]);
		if (artist != "") artist = ": " + artist;

		trackName[i]= i + 1 + " " + trim(cdPlaylistTitles[i]);
                //dprint("trackName[i] "+trackName[i]);
                //dprint("cdPlaylistTitles[i] "+cdPlaylistTitles[i]);
            }
        } else {            
            alert('CD drive is not loaded');
            return;
	}
	//playListTitle.text  = "Audio CD Drive "+ CDROM.Item(cdRomNo).driveSpecifier;
	//dprint ("PlayAudioCD "+WMPlayer.URL);
	
	var artist = trim(cdPlaylistArtists[i]);
	if (artist != "") artist = ": " + artist;

	if (preferencesShuffleStatePrefValue.text =="enabled") {
		randomPlay();
	}
	
	// provide the track information to the track data above the slider itself
	trackNoText.text = "track "+ WMPlayer.currentMedia.name.substring(0, 6);
	
	dprint ("trackNameText.text " + trackNameText.text);
	
	//trackNameText.text is derived from chosenfolder used during updatePlayList function
	chosenFolder = CDROM.Item(0).driveSpecifier + " " +  objSong.getItemInfo("AlbumID");
        dprint ("Playmedia Call no. 4");

	// now it calls the function that actually plays the CD
	playMedia(0);
	//finally it updates the playlist
	updatePlayList();
}
//=====================
//End function
//=====================

//===================================
// function to play any media CD or playlist, called by nextButton, prevButton &c
//===================================
function arse(i) {
   var artist;

   dprint ("%-I-INFO, playMedia");
   if (playListfileCount>0) {
        playIndex = i;
        dprint("playListfileCount " + playListfileCount);
        dprint("playIndex " + playIndex);
        dprint("thePlayList[i].sourceURL " + thePlayList[i].sourceURL);

	WMPlayer.URL = thePlayList[i].sourceURL;
	//dprint("1 WMPlayer.URL "+WMPlayer.URL);

	// set the track display data

        if (isAudioCD) {
	    //dprint ("Audio CD " +WMPlayer.currentMedia.duration);
            artist = trim(cdPlaylistArtists[i]);
            if (artist !== "") {
                artist = ": " + artist;
            }
            trackNameText.text = trim(cdPlaylistTitles[i]) + artist;
            trackNoText.text = "track "+ WMPlayer.currentMedia.name.substring(0, 6);
	} else {
            if (preferencesTitlePrefValue.text == "filename only" ) {
              // add spaces to the end of the track name to cause the horiz scroll to start
              trackNameText.text = getFileOnly(WMPlayer.URL) + "                                    ";
            } else {
              trackNameText.text =  WMPlayer.URL + "                                    ";
            }

            //if the random button is pressed then
            if (preferencesShuffleStatePrefValue.text == "enabled") {
		        trackNoText.visible= false;
            } else {
			trackNoText.text = "track "+ eval(playIndex + 1);
			trackNoText.visible= true;
            }
	}

	dprint ("trackNameText.text " + trackNameText.text);
	dprint ("trackNoText.text " + trackNoText.text);        
        dprint ("Playmedia Call no. 3");
 
        if (playOverride === false) {
            // DB06
            if (preferencesAutoPlayStatePrefValue.text === "enabled") {
                positionTimer.enabled = true;
            }
            // DB06           positionTimer.enabled = true;
           sliderTimer.enabled = true;
           masterPlay();
           //WMPlayer.controls.play();
           playButton.visible=false;
           pauseButton.visible=true;  //ywe
        }

        // this next call is absolutely necessary, removes the styling at the point the track is selected and playing
	scrollPlayList(); 
  }
  dprint("WMPlayer.URL "+ WMPlayer.URL);

}
//=====================
//End function
//=====================
//===================================
// function to play any media CD or playlist, called by nextButton, prevButton &c
//===================================
function playMedia(i) {
   var artist;

   dprint ("%-I-INFO, playMedia");
   if (playListfileCount>0) {
        playIndex = i;
        dprint("playListfileCount " + playListfileCount);
        dprint("playIndex " + playIndex);
        dprint("thePlayList[i].sourceURL " + thePlayList[i].sourceURL);

	WMPlayer.URL = thePlayList[i].sourceURL;
	//dprint("1 WMPlayer.URL "+WMPlayer.URL);

	// set the track display data

        if (isAudioCD) {
	    //dprint ("Audio CD " +WMPlayer.currentMedia.duration);
            artist = trim(cdPlaylistArtists[i]);
            if (artist !== "") {
                artist = ": " + artist;
            }
            trackNameText.text = trim(cdPlaylistTitles[i]) + artist;
            trackNoText.text = "track "+ WMPlayer.currentMedia.name.substring(0, 6);
	} else {
            if (preferencesTitlePrefValue.text == "filename only" ) {
              // add spaces to the end of the track name to cause the horiz scroll to start
              trackNameText.text = getFileOnly(WMPlayer.URL) + "                                    ";
            } else {
              trackNameText.text =  WMPlayer.URL + "                                    ";
            }

            //if the random button is pressed then
            if (preferencesShuffleStatePrefValue.text == "enabled") {
		        trackNoText.visible= false;
            } else {
			trackNoText.text = "track "+ eval(playIndex + 1);
			trackNoText.visible= true;
            }
	}

	dprint ("trackNameText.text " + trackNameText.text);
	dprint ("trackNoText.text " + trackNoText.text);        
        dprint ("Playmedia Call no. 3");
 
        if (playOverride === false) {
            // DB06
            if (preferencesAutoPlayStatePrefValue.text === "enabled") {
                positionTimer.enabled = true;
            }
            // DB06           positionTimer.enabled = true;
           sliderTimer.enabled = true;
           masterPlay();
           //WMPlayer.controls.play();
           playButton.visible=false;
           pauseButton.visible=true;  //ywe
        }

        // this next call is absolutely necessary, removes the styling at the point the track is selected and playing
	scrollPlayList(); 
  }
  dprint("WMPlayer.URL "+ WMPlayer.URL);

}
//=====================
//End function
//=====================


//===================================
// function to play currently selected track
//===================================
function playTrack() {
  dprint ("%-I-INFO, playTrack");
        if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll="true";
        }
  if (playListfileCount >= 1) {
        playButton.visible = false;
        pauseButton.visible = true;                                        

        if (WMPlayer.controls.currentPosition == WMPlayer.currentMedia.duration) {
                WMPlayer.controls.currentPosition = 0;
        }
        masterPlay();
        playOverride = false;
        positionTimer.enabled=true;     
        sliderTimer.enabled = true;     
	    //buildVitality(currIcon, parseInt(percentTextShadow.text, 10), WMPlayer.settings.mute); // build the dock vitality
	dprint("player.currentMedia.duration "+WMPlayer.currentMedia.duration);
  }
}
//=====================
//End function
//=====================


//===================================
// function to add a single track for immediate playing
//===================================
function addSingleTrack(trackType) {
	var fileName;
	dprint("%-I-INFO, addSingleTrack");
	if (preferencesSoundprefValue.text === "enabled") {
	   PlaySound(winding);
	}
	dprint("%-I-INFO, addSingleTrack URLsearchText.text "+ URLsearchText.text);

        if (trackType === "url") {
            res = URLsearchText.text;
            //res = inputForm("Remote Media File", "Save", "Cancel");
            if ((res === null) || (res === "http://")) {
                return;
            }
            fileName = "";
            fileName = encodeURI(res);
        } else {
            fileName = openFileDialog(""); // a validate type check is required here but Xwidget does not provide.
            if (fileName == "") {
              fileName = "";
              //alert("no file selected");
              return;
            }
        }

        	dprint("%-I-INFO, addSingleTrack fileName "+ fileName);

        //xwidget does not like .indexOf as per YWE we use validate_filetype function instead
        //if (validTypes.indexOf(xtn(fileName)) === true) {
        //The indexOf() method returns the position of the first occurrence of a specified value in a string.
        //JScript arrays have no .IndexOf() method so validSuffix cannot be an array of valid suffixes
        if (validate_filetype(fileName,validTypes) === true ) {
      	   dprint("fileName " + fileName);
      	   playOverride = false;
      	   PlayFile(fileName);
      	   chosenFolder = "";
        } else {
          //alert("incompatible file type");
        }

	dprint("%-I-INFO, addSingleTrack finished");

}
//=====================
//End function
//=====================


//===================================
// function to tell the WMP to pause
//===================================
function pauseTrack() {
    dprint ("%-I-INFO, pauseTrack");
  if (playListfileCount>0) {
        trackNameText.enabledHorzScroll="false";
	WMPlayer.controls.pause();
	//stop the timers, no point in them running
	sliderTimer.enabled=false; 
	positionTimer.enabled=false;  
  }
}
//=====================
//End function
//=====================


//=================================
// Function to extract the extension from a filename string
//=================================
xtn = function (s) {
    var ext, idx = s.lastIndexOf(".");

    if (idx > 0) {  // was idx >= 0
        ext = s.substring(idx);
        if (ext.length > 1) {
            return ext;
        }
    }
    return "";
}
//=================================
// end function
//=================================





//=================================
// Function to get the files  //unused function
//=================================
function ShowFontFilenames(){
 var objShell = new ActiveXObject("WScript.Shell");
 var sysRoot = objShell.Environment("PROCESS").Item("SYSTEMROOT"); 
 var fontPath = sysRoot + "\\fonts";
 var fontString = getFileList(fontPath,"*.ttf",false);
 fontArray = fontString.split('|');
 
 //var vbs_code = 'GetObject("winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\default:StdRegProv")._\  
 //EnumValues &H80000002, "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Fonts", arrNames\  

 //dprint("fontArray[0] " + fontArray[0]);
  //dprint("sysRoot " + sysRoot);
 //dprint("fontPath " + fontPath);
 //dprint("fontString " + fontString);
 }
//=================================
// end function
//=================================


//=================================
// Function to get the fonts from the registry
//=================================
function ShowFontList(){
    dprint ("%-I-INFO, ShowFontList");

var tmpFontArray ;
// Get an instance of the StdRegProv class...
var objService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\\\.\\root\\default");
var objReg = objService.Get("StdRegProv");

// Prepare the EnumKey method...
var objMethod = objReg.Methods_.Item("EnumValues"); 
var objParamsIn = objMethod.InParameters.SpawnInstance_(); 
objParamsIn.hDefKey = HKLM; 
objParamsIn.sSubKeyName = "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Fonts\\"; 

// Execute the method and collect the output...
var objParamsOut = objReg.ExecMethod_(objMethod.Name, objParamsIn); 

// If successful, iterate the subkeys...
if (objParamsOut.ReturnValue === 0) {
    if (objParamsOut.sNames != null) {
        tmpFontArray = objParamsOut.sNames.toArray(); //populate the temporary array
        for (var i = 0; i < tmpFontArray.length; ++i) {
            if  ( trim(tmpFontArray[i]) == "" || tmpFontArray[i].lastIndexOf("Bold") != -1 || tmpFontArray[i].lastIndexOf("Italic") != -1 )  { 
                tmpFontArray[i] = "";    //exclude certain font entries
            } else {
                tmpFontArray[i] = trim(tmpFontArray[i].substring(0,tmpFontArray[i].lastIndexOf("(TrueType)")));
            }
        }
    }
}
        //populate the final array and sort it
        fontArray=[];
        var j = 0;
        for (var i = 0; i < tmpFontArray.length; ++i) {
            if (trim(tmpFontArray[i]) != "" ) {             
               fontArray[j] = tmpFontArray[i];
               j = j + 1;
            }
        }
        fontArray.sort(); 
}
//=================================
// end function
//=================================







//=================================
// Function to count the folder contents folder by folder
//  there is a bug in the Xwidget getFileList function when used in non-recursive mode that
//  means it fails to report the subfolders contained within a folder
//  xwidget baulked at for each statements
//=================================
function filesystemGetDirectoryContents(folderspec, recursiveBoolean){
var fso, f, fc, fs, s;
  if ( recursiveBoolean == false ) {
    fso = new ActiveXObject("Scripting.FileSystemObject");
    f = fso.GetFolder(folderspec);
    colFiles  = f.SubFolders;
    fc = new Enumerator( colFiles );

    s = "";
    for (; !fc.length; fc.moveNext()) {
        if (fc.item() == null) {
           break;
        }
        s += fc.item();
        s += "|";
    }
    // now we have the folders - add to the file list
    fs = getFileList(folderspec,validTypes,false);
    s = s + fs;
  } else {
    //the xwidget getfilelist does not return an array but a bar-separated list
    s = getFileList(folderspec,validTypes,true);
  }
  // convert the filelist into an array
  s = s.split('|');  
  return s;
}
//=================================
// end function
//=================================
                  




//===================================
// function to select the previous track
//===================================
function previousTrack() {
    dprint ("%-I-INFO, previousTrack");
        positionTimer.enabled = false;
        playOverride = false;
        //dprint("playListfileCount "+playListfileCount);
        //dprint("playIndex "+playIndex);
        //dprint("playerState "+playerState);
        if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll="true";
        }        
        if (!WMPlayer.URL) {
            return;
        } else {
            if (playerState == "single")  {
              masterPlay();   //just replays single track
              positionTimer.enabled=true;
              sliderTimer.enabled = true;
              
              return;
            }
    	    if (playIndex >0 ) {
                    playIndex--;
            } else {
                    playIndex = playListfileCount - 1;
            }
            dprint ("Playmedia Call no. 5");
            playMedia(playIndex);
         }
        //dprint("WMPlayer.URL"+ WMPlayer.URL);
        positionTimer.enabled = true;
}
//=====================
//End function
//=====================

//===================================
// function to select the next track
//===================================
function nextTrack() {
    dprint ("%-I-INFO, nextTrack");
        positionTimer.enabled = false;
        playOverride = false;
        if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll="true";
        }
        if (!WMPlayer.URL) {
            return;
        } else {
            if (playerState == "single")  {
                masterPlay();  //just replays single track
                positionTimer.enabled=true;
                return;
            }
            if (playIndex+1 < playListfileCount ) {
                    playIndex++;
                    trackIndex++;
		    dprint("trackIndex "+trackIndex);

                    if (trackIndex == 12) {
                      trackIndex = 1;
                      chunkIndex = chunkIndex + 1;
					  dprint("chunkIndex "+chunkIndex);
					  dprint("trackIndex "+trackIndex);
					  
					  updatePlayList();
                    };
            } else {
                    playIndex = 0;
            }
            dprint ("Playmedia Call no. 6");
            playMedia(playIndex);
            positionTimer.enabled=true;
            positionSliderperc = 0;
        }
        //dprint("WMPlayer.URL"+ WMPlayer.URL);
        positionTimer.enabled = true;
}
//=====================
//End function
//=====================

//===================================
// function to emulate LTrim
//===================================
function LTrim(str) {
    var whitespace = " \t\n\r";
    var s = String(str);
    var j;
    var i;

    if (whitespace.indexOf(s.charAt(0)) !== -1) {
        j = 0;
        i = s.length;
        while (j < i && whitespace.indexOf(s.charAt(j)) !== -1) {
            j += 1;
        }
        s = s.substring(j, i);
    }
    return s;
}
//=====================
//End function
//=====================

//===================================
// function to emulate RTrim
//===================================
function RTrim(str) {
    var whitespace = " \t\n\r";
    var s = String(str);
    var i;

    if (whitespace.indexOf(s.charAt(s.length - 1)) !== -1) {
        i = s.length - 1;
        while (i >= 0 && whitespace.indexOf(s.charAt(i)) !== -1) {
            i -= 1;
        }
        s = s.substring(0, i + 1);
    }
    return s;
}
//=====================
//End function
//=====================






function chainOnMouseDown(Sender,Button,Shift,X,Y)
{
  
  chainAction();
}


//===================================
// function to animate the chain and activate the playlist
//===================================
function chainAction() {
    dprint ("%-I-INFO, chainAction");
     chain.top = chain.top + (20);
     PlaySound(creturn);
     sleep (100);
     chain.top = chain.top - (20);
     if (playlistFrame.visible == -1 ) { // true
        dprint ("%-I-INFO, chainAction 2");
        playlistFrame.visible = false;
        deleteLayer.visible = false;
	preferencesPlayListPrefValue.text = "disabled";
     } else {
        dprint ("%-I-INFO, chainAction 3 "+ playlistFrame.visible);
        playlistFrame.visible = true;
        deleteLayer.visible = true;

	preferencesPlayListPrefValue.text = "enabled";
        // if the playlist needs to be refreshed
        if (chosenFolder == "") {
           chosenFolder = preferencesMusicFolderPrefValue.text;
	   dprint ("*****************chosenFolder " + chosenFolder);
           readFolderRecursively(chosenFolder );
           updatePlayList();

		}
     }
 }
 //=====================
 //End function
 //=====================


 
//===================================
// function to get the filename only
//===================================
function getFileOnly(str) {
         file_extension = str.split('.').pop();
         return str.replace(/^.*[\\\/]/, '')
}
//=====================
//End function
//=====================


function pauseButtonOnMouseMove(Sender,Shift,X,Y,Dx,Dy)
{

}

function pauseButtonOnMouseEnter(Sender)
{
  	pauseButton.src="pauseHover.png";

}

function pauseButtonOnMouseLeave(Sender)
{
  	pauseButton.src="pause.png";

}

function playButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
       startupFlg == 0;
       playTrack();

}

function playButtonOnMouseEnter(Sender)
{
  	playButton.src="playHover.png";

}

function playButtonOnMouseLeave(Sender)
{
  	playButton.src="play.png";

}

function playButtonOnDblClick(Sender)
{
  	playTrack();

}






function pauseButtonOnDblClick(Sender)
{
  
}

function pauseButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
  startupFlg == 0;
  playButton.src="pause.png";
  pauseTrack();
  playButton.visible = true;
  pauseButton.visible = false;
  //buildVitality(currIcon, parseInt(percentTextShadow.text, 10), WMPlayer.settings.mute); // build the dock vitality                               
}
//=====================
//End function
//=====================




//===================================
// function to set the lock state
//===================================
function checkAutoPlayState() {
    if (preferencesAutoPlayStatePrefValue.text === "disabled") {
        autoPlayLug.visible = true;
        autoPlayLugEnabled.visible = false;
    } else {
        autoPlayLug.visible = false;
        autoPlayLugEnabled.visible = true;
    }

    if (preferencesSoundprefValue.text === "enabled") {
        playSound(lock);
    }
}
//=====================
//End function
//=====================


//===================================
// set the autoplay state read the default folder
//===================================
function checkStartupPlayState() {
           playerState = "folder"; //this is to ensure that shuffle mode is respected
       	   if (startupFlg == 1 && preferencesStartupPlayStatePrefValue.text === "disabled") {
             // do nothing
             dprint("doing nothing");

             playOverride = true;
             positionTimer.enabled = false;
             playButton.visible=true;
             pauseButton.visible=false;
           }
       	   path = preferencesMusicFolderPrefValue.text;
       	   chosenFolder = preferencesMusicFolderPrefValue.text;
       	   readFolderRecursively(preferencesMusicFolderPrefValue.text);
};
//=====================
//End function
//=====================



//===========================================




//===================================
// function to shuffle the play list or file list
//===================================
function toggleRandomPlay() {
   dprint ("%-I-INFO, toggleRandomPlay");

   if (preferencesShuffleStatePrefValue.text == "disabled") {
	        preferencesShuffleStatePrefValue.text = "enabled";
	        //dprint ("1. ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ preferences.shuffleStatePref.value " + preferences.shuffleStatePref.value);

		pipesRight.src="pipesRightClicked.png";
		dprint ("toggling the random state to " + preferencesShuffleStatePrefValue.text);
		pipesRight.hint = "pulled out - shuffle is now enabled";
		randomPlay();
   } else { //preferences.shuffleStatePref.value = "enabled"
	        //dprint ("2. ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ preferences.shuffleStatePref.value " + preferences.shuffleStatePref.value);	  
	        pipesRight.src="pipesRight.png";
		preferencesShuffleStatePrefValue.text = "disabled"
		dprint ("toggling the random state to " + preferencesShuffleStatePrefValue.text);
		pipesRight.hint = "pushed in - shuffle is now disabled";

		if (!isAudioCD) {
                           chosenFolder = preferencesMusicFolderPrefValue.text;		           
                           //dprint(" chosenFolder "+chosenFolder);
                           if (chosenFolder != null ) {
                              readFolderRecursively(chosenFolder); //only re-read the default folder when not a CD
                           }
                } else {
		        if (CDROMcount != 0 ) {
			   PlayAudioCD( 0 , CDROM.Item(cdRomNo).Playlist);
                        }
		}
		
		updatePlayList();
   }
   if (preferencesSoundprefValue.text === "enabled") {
      	PlaySound(lock);
   }

}
//=====================
//End function
//=====================


//===================================
// function to shuffle an existing play list or file list
//===================================
function randomPlay() {
   dprint ("%-I-INFO, randomPlay");
   //dprint("playListfileCount  "+playListfileCount );   
	if (playerState == "folder"  || playerState == "AudioCD")  {
		var i = playListfileCount ;
		if (i == 0) return false;	
		while (--i) {
				var j = Math.floor( Math.random() * (i + 1));
				var tempi = thePlayList[i];
				var tempj = thePlayList[j];
				thePlayList[i] = tempj;
				thePlayList[j] = tempi;
				if (isAudioCD) {
					var objSongi = cdPlaylistTitles[i];
					var objSongj = cdPlaylistTitles[j];
					cdPlaylistTitles[i] = objSongj;
					cdPlaylistTitles[j] = objSongi;
				}
			}
                        dprint ("Playmedia Call no. 7");
                        playMedia(0);
			playerState = "folder"; //this is to ensure that shuffle mode is respected
			//dprint ("1^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ path " + path);
			dprint ("Randomising done " );
			
			updatePlayList();
		//dprint ("2 ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^path " + path);
	}   
}
//=====================
//End function
//=====================



//===================================
// set the saved shuffle status
//===================================
function checkShuffleState() {
    dprint ("%-I-INFO, checkShuffleState");
       if (preferencesShuffleStatePrefValue.text =="enabled") {
		   //dprint ("1. ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ preferences.shuffleStatePref.value " + preferences.shuffleStatePref.value);	
		   
                pipesRight.src="pipesRightClicked.png";
		pipesRight.hint = "pulled out - shuffle is now enabled";
               	randomPlay();
		} else {
		   pipesRight.hint = "pushed in - shuffle is now disabled";
		}
};
//=====================
//End function
//=====================






//===========================================
// this function serves to cause the icon to change on a mouseover only, the multiclick event does not change the mouse over icon
//===========================================
function trackNameTextOnMouseDown(Sender,Button,Shift,X,Y) {
	dprint ("%-I-INFO, trackNameText.onMouseDown");
}

//=====================
//End function
//=====================



//===================================
// function to update the play list
//===================================
function updatePlayList() {
	dprint ("%-I-INFO, updatePlayList");
	
	
                        //dprint("*********** 5 thePlayList[0] " +thePlayList[0].sourceURL);
                        //dprint("*********** 5 thePlayList[1] " +thePlayList[1].sourceURL);
                        //dprint("*********** 5 thePlayList[2] " +thePlayList[2].sourceURL);
                        //dprint("*********** 5 thePlayList[3] " +thePlayList[3].sourceURL);
                        //dprint("*********** 5 thePlayList[4] " +thePlayList[4].sourceURL);
                        //dprint("*********** 5 thePlayList[5] " +thePlayList[5].sourceURL);

	//dwipePlayList(); };
	clearPlayList();
	readPlayList();

	removePlayListScrolling();
	removePlayListStyling();

	log("chosenFolder "+chosenFolder);
	playListTitle.text =  chosenFolder;
	if (chosenFolder == "") {
		playListTitle.text =  preferencesMusicFolderPrefValue.text; // just in case the playlist is absent due to invalid or missing files
	}
	log("IsPlaylist "+IsPlaylist);	
	if (IsPlaylist != false || playListfileCount==1) {
		showPlayList();
	}
	addSpacesToPlayList();
	setPlayListScrollingLength();
	setPlayListTooltip();
	//buttonOpacity();
	highlightPlayingTrack();
}
//=====================
//End function
//=====================


//===================================
// function to read the play list
//===================================
function clearPlayList() {
    dprint ("%-I-INFO, clearPlayList");
    trackName = []; // new Array(idxFile)     ;
    fullTrackName = []; // new Array(idxFile) ;
    playListTitle.hint =  "";
    playListTitle.text = "";
	playListText0.text = "";
	playListText1.text =  "";
	playListText2.text =  "";
	playListText3.text =  "";
	playListText4.text =  "";
	playListText5.text =  "";
	playListText6.text =  "";
	playListText7.text =  "";
	playListText8.text =  "";
	playListText9.text =  "";
	playListText10.text =  "";
	playListText11.text =  "";
}
//=====================
//End function
//=====================



//===================================
// function to read the play list
//===================================
function addSpacesToPlayList() {
    dprint ("%-I-INFO, addSpacesToPlayList");

	playListText0.text = playListText0.text + "                               ";
	playListText1.text = playListText1.text + "                                ";
	playListText2.text = playListText2.text + "                                ";
	playListText3.text = playListText3.text + "                                ";
	playListText4.text =  playListText4.text + "                                ";
	playListText5.text =  playListText5.text + "                                ";
	playListText6.text =  playListText6.text + "                                ";
	playListText7.text =  playListText7.text + "                                ";
	playListText8.text =  playListText8.text + "                                ";
	playListText9.text =  playListText9.text + "                                ";
	playListText10.text =  playListText10.text + "                                ";
	playListText11.text =  playListText11.text + "                                ";

}
//=====================
//End function
//=====================




//===================================
// read the play list
//===================================
function readPlayList() {
	dprint ("%-I-INFO, readPlayList");
	
	trackNoText.text = "track "+ WMPlayer.currentMedia.name.substring(0, 6);
	
	if (playListfileCount==1) { //single file

		trackName[0]= getFileOnly(thePlayList[0].sourceURL);
		//fullTrackName[0]= convertPathToPlatform(thePlayList[0].sourceURL); //nyi
		fullTrackName[0]= thePlayList[0].sourceURL;

	} else { //multiple files
		for(var i = 0; i <= chunkSize; i++) {
			var j = i + (12 * chunkIndex);
			trackNumber[j]= j;
			//dprint (">>>>>>>>>>>>>>>>>>>>>> j " + j);
			//dprint ("playListfileCount " + playListfileCount);

			if (j <= playListfileCount-1) {				
				if (isAudioCD) {
					/*var cdRomPlayList = CDROM.Item(cdRomNo).Playlist
					WMPlayer.URL = thePlayList[j].sourceURL;
					objSong = colPlaylist.Item(j);           
					cdPlaylistTitles[j] = objSong.getItemInfo("title");
					cdPlaylistArtists[j] = objSong.getItemInfo("artist");
					
					thePlayList[i] = cdRomPlayList.Item(j);
					//dprint("cdPlaylist[j].sourceURL "+thePlayList[j].sourceURL);
					var artist = trim(cdPlaylistArtists[i]);
					if (artist != "") artist = ": " + artist;
					*/
					trackName[j]= j + 1 + " " + trim(cdPlaylistTitles[j]);
				} else {
					// this is the track as displayed in the track list
					trackName[j]= getFileOnly(thePlayList[j].sourceURL);
					//dprint ("&&&&&&&&&&&&&&&&& fullTrackName[j] " + fullTrackName[j]);
					//dprint ("trackName[j] " + trackName[j]);			
					
				}
				// this is the full track path converted to native format
				//fullTrackName[j]= convertPathToPlatform(thePlayList[j].sourceURL); //nyi
                                fullTrackName[j]= thePlayList[j].sourceURL;
			}
		}
	}
}
//=====================
//End function
//=====================


//===================================
// this routine is here for cleanliness during debugging, it wipes the whole play list
//===================================
function wipePlayList() {
	dprint ("%-I-INFO, wipePlayList");

	for(var i = 0; i <= chunkSize; i++) {
		var j = i + (12 * chunkIndex);
		trackNumber[j]= j;
		//dprint (">>>>>>>>>>>>>>>>>>>>>> j " + j);
		if (j <= playListfileCount-1) {				
				// this is the track as displayed in the track list
			trackName[j]= "";					
			// this is the full track path converted to native format
			fullTrackName[j]= "";
		}
	}
}
//=====================
//End function
//=====================


//===================================
// display a chunk of the tracks
//===================================
function showPlayList() {
    dprint ("%-I-INFO, showPlayList");

		playListPage.text = "  Page no. " + parseInt(chunkIndex + 1) ;

		if (playListfileCount==1) { //single file
			playListText0.text = trackName[0];
		} else {
			dprint("chunkIndex "+chunkIndex);
			if (trackName[0+ (12 * chunkIndex)] != null ) {playListText0.text = trackName[0+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[1+ (12 * chunkIndex)] != null ) {playListText1.text =  trackName[1+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[2+ (12 * chunkIndex)] != null ) {playListText2.text =  trackName[2+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[3+ (12 * chunkIndex)] != null ) {playListText3.text =  trackName[3+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[4+ (12 * chunkIndex)] != null ) {playListText4.text =  trackName[4+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[5+ (12 * chunkIndex)] != null ) {playListText5.text =  trackName[5+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[6+ (12 * chunkIndex)] != null ) {playListText6.text =  trackName[6+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[7+ (12 * chunkIndex)] != null ) {playListText7.text =  trackName[7+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[8+ (12 * chunkIndex)] != null ) {playListText8.text =  trackName[8+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[9+ (12 * chunkIndex)] != null ) {playListText9.text =  trackName[9+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[10+ (12 * chunkIndex)] != null ) {playListText10.text =  trackName[10+ (12 * chunkIndex)].toLowerCase()};
			if (trackName[11+ (12 * chunkIndex)] != null ) {playListText11.text =  trackName[11+ (12 * chunkIndex)].toLowerCase()};			  
		}
}
//=====================
//End function
//=====================



//===================================
// set the play list tooltips
//===================================
function setPlayListTooltip() {
    dprint ("%-I-INFO, setPlayListTooltip");
	if (isAudioCD) {
            if (preferencesHintsPrefValue.text == "enabled") {
                playListTitle.hint =  "CD drive : "+playListTitle.text;
		playListText0.hint =  "CD track : "+trackName[0+ (12 * chunkIndex)];
		playListText1.hint =  "CD track : "+trackName[1+ (12 * chunkIndex)];
		playListText2.hint =  "CD track : "+trackName[2+ (12 * chunkIndex)];
		playListText3.hint =  "CD track : "+trackName[3+ (12 * chunkIndex)];
		playListText4.hint =  "CD track : "+trackName[4+ (12 * chunkIndex)];
		playListText5.hint =  "CD track : "+trackName[5+ (12 * chunkIndex)];
		playListText6.hint =  "CD track : "+trackName[6+ (12 * chunkIndex)];
		playListText7.hint =  "CD track : "+trackName[7+ (12 * chunkIndex)];
		playListText8.hint =  "CD track : "+trackName[8+ (12 * chunkIndex)];
		playListText9.hint =  "CD track : "+trackName[9+ (12 * chunkIndex)];
		playListText10.hint =  "CD track : "+trackName[10+ (12 * chunkIndex)];
		playListText11.hint =  "CD track : "+trackName[11+ (12 * chunkIndex)];
	    } else {
                clearPlayListHints();
	    }
	} else {
	    //dprint(">>>>"+preferencesHintsPrefValue.text);
            if (preferencesHintsPrefValue.text == "enabled") {
		if (playListfileCount==1) { //single file
			//dprint (">>>>>>>>>>>>>>>>>>>>>> playListfileCount " + playListfileCount);
			//dprint ("trackName[0] " + trackName[0]);
			playListText0.hint =  fullTrackName[0];
		} else {

			playListText0.hint =  fullTrackName[0+ (12 * chunkIndex)];
			playListText1.hint =  fullTrackName[1+ (12 * chunkIndex)];
			playListText2.hint =  fullTrackName[2+ (12 * chunkIndex)];
			playListText3.hint =  fullTrackName[3+ (12 * chunkIndex)];
			playListText4.hint =  fullTrackName[4+ (12 * chunkIndex)];
			playListText5.hint =  fullTrackName[5+ (12 * chunkIndex)];
			playListText6.hint =  fullTrackName[6+ (12 * chunkIndex)];
			playListText7.hint =  fullTrackName[7+ (12 * chunkIndex)];
			playListText8.hint =  fullTrackName[8+ (12 * chunkIndex)];
			playListText9.hint =  fullTrackName[9+ (12 * chunkIndex)];
			playListText10.hint =  fullTrackName[10+ (12 * chunkIndex)];
			playListText11.hint =  fullTrackName[11+ (12 * chunkIndex)];	
		}
	    } else {
                clearPlayListHints();
	    }	
	}
}
//=====================
//End function
//=====================

//=====================
// functions to add hover over effects to the items in the playlist
//=====================
function playListTitleOnMouseEnter(Sender,Button,Shift,X,Y) {
        if (preferencesScrollingPrefValue.text === "enabled" ) {
              playListTitle.enabledHorzScroll="true";
        }
}


//increase the font by one point, the extra 0.49 is added to cater for the scaling flattening the font size slightly
function playListText0OnMouseEnter(Sender,Button,Shift,X,Y) {
       playListText0.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 0;   // DB05 to allow internal drop
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
               savedReplacedTrack = playListText0.text;
               playListText0.text = partlySelectedTrack.toLowerCase();
               playListSelectBar0.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText0.text != "") {
              deleteButton0.opacity = "1";
            }
        }
}
function playListText1OnMouseEnter(Sender,Button,Shift,X,Y) {
       playListText1.font.size = (parseInt(fontDefault) * 1.2)    ;
       dropPosition = 1;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText1.text;
              playListText1.text = partlySelectedTrack.toLowerCase();
              playListSelectBar1.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText1.text != "") {deleteButton1.opacity = "1";};
        }
}
function playListText2OnMouseEnter(Sender,Button,Shift,X,Y) {
       playListText2.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 2;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText2.text;
              playListText2.text = partlySelectedTrack.toLowerCase();
              playListSelectBar2.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText2.text != "") {deleteButton2.opacity = "1";};
        }
}
function playListText3OnMouseEnter(Sender,Button,Shift,X,Y) {
        playListText3.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 3;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText3.text;
              playListText3.text = partlySelectedTrack.toLowerCase();
              playListSelectBar3.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText3.text != "") {deleteButton3.opacity = "1";};
        }
}
function playListText4OnMouseEnter(Sender,Button,Shift,X,Y) {
        playListText4.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 4;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText4.text;
              playListText4.text = partlySelectedTrack.toLowerCase();
              playListSelectBar4.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText4.text != "") {deleteButton4.opacity = "1";};
        }
}
function playListText5OnMouseEnter(Sender,Button,Shift,X,Y) {
        playListText5.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 5;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText5.text;
              playListText5.text = partlySelectedTrack.toLowerCase();
               playListSelectBar5.background.solidColor.enabled="true";
       } else {              // normal usage for a simple hover
            if (playListText5.text != "") {deleteButton5.opacity = "1";};
        }
}
function playListText6OnMouseEnter(Sender,Button,Shift,X,Y) {
       playListText6.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 6;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText6.text;
              playListText6.text = partlySelectedTrack.toLowerCase();
              playListSelectBar6.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText6.text != "") {deleteButton6.opacity = "1";};
        }
}
function playListText7OnMouseEnter(Sender,Button,Shift,X,Y) {
       playListText7.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 7;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText7.text;
              playListText7.text = partlySelectedTrack.toLowerCase();
              playListSelectBar7.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText7.text != "") {deleteButton7.opacity = "1";};
        }
}
function playListText8OnMouseEnter(Sender,Button,Shift,X,Y) {
        playListText8.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 8;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText8.text;
              playListText8.text = partlySelectedTrack.toLowerCase();
              playListSelectBar8.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText8.text != "") {deleteButton8.opacity = "1";};
        }
}
function playListText9OnMouseEnter(Sender,Button,Shift,X,Y) {
        playListText9.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 9;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText9.text;
              playListText9.text = partlySelectedTrack.toLowerCase();
              playListSelectBar9.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText9.text != "") {deleteButton9.opacity = "1";};
        }
}
function playListText10OnMouseEnter(Sender,Button,Shift,X,Y) {
        playListText10.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 10;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText10.text;
              playListText10.text = partlySelectedTrack.toLowerCase();
              playListSelectBar10.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText10.text != "") {deleteButton10.opacity = "1";};
        }
}
function playListText11OnMouseEnter(Sender,Button,Shift,X,Y) {
        playListText11.font.size = (parseInt(fontDefault) * 1.2)     ;
       dropPosition = 11;   // DB05 to allow internal drop
       //dprint("dragDropFlg " + dragDropFlg);
       ////dprint("trackClickedFlg " + trackClickedFlg);
       if ((dragDropFlg === 1 && trackClickedFlg === 1)) {
            savedReplacedTrack = playListText11.text;
              playListText11.text = partlySelectedTrack.toLowerCase();
              playListSelectBar11.background.solidColor.enabled="true";
        } else {              // normal usage for a simple hover
            if (playListText11.text != "") {deleteButton11.opacity = "1";};
        }
}
//=====================
//End mouse enter functions
//=====================



//===========================================
// this function provides the mouse over icon change.
//===========================================
playListTitle.onClick = function () {
	// do not remove this empty function it has a purpose...
}
//=====================
//End function
//=====================


//=====================
// functions to extract some track information for dragging and dropping
//=====================
function playListTextOnMouseDown(i) {
        dprint("******************************DRAG*****************");
        //if (event.ctrlKey) {
        //    ctrlPressed = 1;
        //}
        busyStop();
        // stops any busy timer that may be running when each track is selected
        dragPosition = i;   // this undoes any previous internal drag/drop operation
        dropPosition = i;   // this undoes any previous internal drag/drop operation
        trackClickedFlg = 1;      // this fires even on a right mouse click
        removePlayListStyling();

        // selected but not running track
        partlySelectedFullTrack = fullTrackName[i + (chunkSize * chunkIndex)];
        partlySelectedTrack = trackName[i + (chunkSize * chunkIndex)];
        // when there is no tracklist selected the extracted data may be undefined - the xwidget engine does not like
        // working with undefined variables whereas the YWE is OK. This next line sorts this.
        if (typeof partlySelectedTrack == 'undefined' ) {
          partlySelectedTrack = "";
        } else {
          // this sorts out the problem with a right click (after clearing the playlist) in Xwidget a right click mistakenly generates a click event
          // checking if the partlySelectedTrack has a value before setting the drag drop flag
          dragDropFlg = 1;
        }
        savedReplacedTrack = partlySelectedTrack.toLowerCase();
        highlightPlayingTrack();
}
//=====================
//  END function
//=====================

// functions to set the background on the single-clicked tracks
// style it with a slight grey background

function playListText0OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(0);
        playListSelectBar0.background.solidColor.enabled="true";
}
function playListText1OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(1);
        playListSelectBar1.background.solidColor.enabled="true";
}
function playListText2OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(2)
        playListSelectBar2.background.solidColor.enabled="true";
}
function playListText3OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(3);
        playListSelectBar3.background.solidColor.enabled="true";
}
function playListText4OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(4);
        playListSelectBar4.background.solidColor.enabled="true";
}
function playListText5OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(5);
        playListSelectBar5.background.solidColor.enabled="true";
}
function playListText6OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(6);
        playListSelectBar6.background.solidColor.enabled="true";
}
function playListText7OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(7);
        playListSelectBar7.background.solidColor.enabled="true";
}
function playListText8OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(8);
        playListSelectBar8.background.solidColor.enabled="true";
}
function playListText9OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(9);
        playListSelectBar9.background.solidColor.enabled="true";
}
function playListText10OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(10);
        playListSelectBar10.background.solidColor.enabled="true";
}
function playListText11OnMouseDown(Sender,Button,Shift,X,Y) {
        playListTextOnMouseDown(11);
        playListSelectBar11.background.solidColor.enabled="true";
}
//=====================
// functions
//=====================





//=====================
// functions to play a selected track when a playlist member is double-clicked
//=====================

function playListText0OnDblClick(Sender)
{
// determine which track
    playIndex = 0 + (chunkSize * chunkIndex);
    startupFlg == 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);
}
function playListText1OnDblClick(Sender)
 {
    playIndex = 1 + (chunkSize * chunkIndex);
    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
 dprint("chunkIndex " +chunkIndex );
 dprint("playIndex " +chunkIndex );

    playMedia(playIndex);
}
function playListText2OnDblClick(Sender)
 {
 dprint("chunkIndex " +chunkIndex );
    playIndex = 2 + (chunkSize * chunkIndex);
    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText3OnDblClick(Sender) {
    playIndex = 3 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText4OnDblClick(Sender) {
    playIndex = 4 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText5OnDblClick(Sender) {
    playIndex = 5 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText6OnDblClick(Sender) {
    playIndex = 6 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText7OnDblClick(Sender) {
    playIndex = 7 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText8OnDblClick(Sender) {
    playIndex = 8 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText9OnDblClick(Sender) {
    playIndex = 9 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText10OnDblClick(Sender) {
    playIndex = 10 + (chunkSize * chunkIndex);
                    
    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
function playListText11OnDblClick(Sender) {
    playIndex = 11 + (chunkSize * chunkIndex);

    startupFlg = 0;
    playOverride = false;
    if (preferencesScrollingPrefValue.text === "enabled" ) {
           trackNameText.enabledHorzScroll = "true";
    }
    positionTimer.enabled = true;
    playMedia(playIndex);

}
//=====================
//End mouse multi click functions
//=====================





//===================================
//  function to remove play list scrolling
//===================================
function removePlayListScrolling() {
    dprint ("%-I-INFO, removePlayListScrolling");

        // stop anything scrolling

        playListText0.enabledHorzScroll="false";
        playListText1.enabledHorzScroll="false";
        playListText2.enabledHorzScroll="false";
        playListText3.enabledHorzScroll="false";
        playListText4.enabledHorzScroll="false";
        playListText5.enabledHorzScroll="false";
        playListText6.enabledHorzScroll="false";
        playListText7.enabledHorzScroll="false";
        playListText8.enabledHorzScroll="false";
        playListText9.enabledHorzScroll="false";
        playListText10.enabledHorzScroll="false";
        playListText11.enabledHorzScroll="false";

}
//=====================
//End function
//=====================

//===================================
//  function to remove play list styling
//===================================
function removePlayListStyling() {
    dprint ("%-I-INFO, removePlayListStyling");

        playListPage.background.solidColor = "rgba(255,255,255,0.06)";
        // get rid of any background styling

        playListText0.background.solidColor.enabled="false";
        playListText1.background.solidColor.enabled="false";
        playListText2.background.solidColor.enabled="false";
        playListText3.background.solidColor.enabled="false";
        playListText4.background.solidColor.enabled="false";
        playListText5.background.solidColor.enabled="false";
        playListText6.background.solidColor.enabled="false";
        playListText7.background.solidColor.enabled="false";
        playListText8.background.solidColor.enabled="false";
        playListText9.background.solidColor.enabled="false";
        playListText10.background.solidColor.enabled="false";
        playListText11.background.solidColor.enabled="false";

// the playlist background bar is due to a limitation in xwidget re:
// the scrolling of a text field. Text fields will not scroll
// unless the text is longer than their container field
// when you set the background to the container field you are
// given a chopped off field, so to extend the background 
// field to the width of the playlist I have another underlying field
// underneath that displays in the same manner.

        playListSelectBar0.background.solidColor.enabled="false";
        playListSelectBar1.background.solidColor.enabled="false";
        playListSelectBar2.background.solidColor.enabled="false";
        playListSelectBar3.background.solidColor.enabled="false";
        playListSelectBar4.background.solidColor.enabled="false";
        playListSelectBar5.background.solidColor.enabled="false";
        playListSelectBar6.background.solidColor.enabled="false";
        playListSelectBar7.background.solidColor.enabled="false";
        playListSelectBar8.background.solidColor.enabled="false";
        playListSelectBar9.background.solidColor.enabled="false";
        playListSelectBar10.background.solidColor.enabled="false";
        playListSelectBar11.background.solidColor.enabled="false";

        playListBar0.background.solidColor.enabled="false";
        playListBar1.background.solidColor.enabled="false";
        playListBar2.background.solidColor.enabled="false";
        playListBar3.background.solidColor.enabled="false";
        playListBar4.background.solidColor.enabled="false";
        playListBar5.background.solidColor.enabled="false";
        playListBar6.background.solidColor.enabled="false";
        playListBar7.background.solidColor.enabled="false";
        playListBar8.background.solidColor.enabled="false";
        playListBar9.background.solidColor.enabled="false";
        playListBar10.background.solidColor.enabled="false";
        playListBar11.background.solidColor.enabled="false";

}
//=====================
//End function
//=====================

//===================================
//  function to scroll individual items on the play list
//===================================
function scrollPlayList() {
    dprint ("%-I-INFO, scrollPlayList");
// stop anything scrolling
        removePlayListScrolling();
        removePlayListStyling();
        highlightPlayingTrack();
        setPlayListScrollingLength();
}
//=====================
//End function
//=====================



//===================================
//  function to set play list scrolling field length for xwidget only
//===================================
function setPlayListScrollingLength() {
    var fieldLength;
    // some code to overcome XW's inability to scroll text in a text field that is shorter than the field length
    //this field width is coupled with a constraint set in the IDE
    //which sets the maxwidth to 206
    
    // see also the playlist background bar description above
    
    			        fieldLength = playListText0.text.length; // count track name length
    			        playListText0.width = fieldLength * 6.6; // set the text field length

        			fieldLength = playListText1.text.length; // count track name length
        			playListText1.width = fieldLength * 6.6; // set the text field length

          			fieldLength = playListText2.text.length; // count track name length
          			playListText2.width = fieldLength * 6.6; // set the text field length

                                fieldLength = playListText3.text.length; // count track name length
                                playListText3.width = fieldLength * 6.6; // set the text field length
                                                                // some code to overcome XW's inability to scroll text in a text field that is shorter than the field length
          			fieldLength = playListText4.text.length; // count track name length
          			playListText4.width = fieldLength * 6.6; // set the text field length

                                                                  // some code to overcome XW's inability to scroll text in a text field that is shorter than the field length
          			fieldLength = playListText5.text.length; // count track name length
          			playListText5.width = fieldLength * 6.6; // set the text field length

          			fieldLength = playListText6.text.length; // count track name length
          			playListText6.width = fieldLength * 6.6; // set the text field length

          			fieldLength = playListText7.text.length; // count track name length
          			playListText7.width = fieldLength * 6.6; // set the text field length

          			fieldLength = playListText8.text.length; // count track name length
          			playListText8.width = fieldLength * 6.6; // set the text field length

          			fieldLength = playListText9.text.length; // count track name length
          			playListText9.width = fieldLength * 6.6; // set the text field length

          			fieldLength = playListText10.text.length; // count track name length
          			playListText10.width = fieldLength * 6.6; // set the text field length

          			fieldLength = playListText11.text.length; // count track name length
          			playListText11.width = fieldLength * 6.6; // set the text field length
}
//=====================
//End function
//=====================


//===================================
// set the play list tooltips
//===================================
function highlightPlayingTrack() {
    dprint ("%-I-INFO, highlightPlayingTrack");
		if (playListfileCount==1) { //single file
                        if (preferencesScrollingPrefValue.text === "enabled" ) {
                                playListText0.enabledHorzScroll="true";
                        }
			playListText0.background.solidColor.enabled="true";
			//playListText0.background.solidColor = "rgb(128,128,128)";
                        playListBar0.background.solidColor.enabled="true";
                        playListSelectBar0.background.solidColor.enabled="false";
			//playListBar0.background.solidColor = "rgb(128,128,128)";
		} else {
			if (playIndex == 0+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText0.enabledHorzScroll="true";
                                }
                                // set the background styling for the selected track
    			        playListText0.background.solidColor.enabled="true";
                                //playListText0.background.solidColor = "rgb(128,128,128)";
                                playListBar0.background.solidColor.enabled="true";
			        playListSelectBar0.background.solidColor.enabled="false";
                        }
			if (playIndex == 1+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText1.enabledHorzScroll="true";
                                }        			
                                playListText1.background.solidColor.enabled="true";
        			//playListText1.background.solidColor = "rgb(128,128,128)";
                                playListBar1.background.solidColor.enabled="true";
			        playListSelectBar1.background.solidColor.enabled="false";

			}
			if (playIndex == 2+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText2.enabledHorzScroll="true";
                                }
                                playListText2.background.solidColor.enabled="true";
                                //playListText2.background.solidColor = "rgb(128,128,128)";
                                playListBar2.background.solidColor.enabled="true";
			        playListSelectBar2.background.solidColor.enabled="false";
			}
			if (playIndex == 3+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText3.enabledHorzScroll="true";
                                }
                                playListText3.background.solidColor.enabled="true";
                                //playListText3.background.solidColor = "rgb(128,128,128)";
                                playListBar3.background.solidColor.enabled="true";
			        playListSelectBar3.background.solidColor.enabled="false";
			        //playListBar3.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 4+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText4.enabledHorzScroll="true";
                                }
			        playListText4.background.solidColor.enabled="true";
			        //playListText4.background.solidColor = "rgb(128,128,128)";
                                playListBar4.background.solidColor.enabled="true";
			        playListSelectBar4.background.solidColor.enabled="false";
			        //playListBar4.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 5+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText5.enabledHorzScroll="true"; 
                                }
			        playListText5.background.solidColor.enabled="true";
			        //playListText5.background.solidColor = "rgb(128,128,128)";
                                playListBar5.background.solidColor.enabled="true";
			        playListSelectBar5.background.solidColor.enabled="false";
			        //playListBar5.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 6+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText6.enabledHorzScroll="true";
                                }
			        playListText6.background.solidColor.enabled="true";
			        //playListText6.background.solidColor = "rgb(128,128,128)";
                                playListBar6.background.solidColor.enabled="true";
			        playListSelectBar6.background.solidColor.enabled="false";
			        //playListBar6.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 7+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText7.enabledHorzScroll="true";
                                }
			        playListText7.background.solidColor.enabled="true";
			        //playListText7.background.solidColor = "rgb(128,128,128)";
                                playListBar7.background.solidColor.enabled="true";
			        playListSelectBar7.background.solidColor.enabled="false";
			        //playListBar7.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 8+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText8.enabledHorzScroll="true";
                                }
			        playListText8.background.solidColor.enabled="true";
			        //playListText8.background.solidColor = "rgb(128,128,128)";
                                playListBar8.background.solidColor.enabled="true";
			        playListSelectBar8.background.solidColor.enabled="false";
			        //playListBar8.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 9+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText9.enabledHorzScroll="true";
                                }
			        playListText9.background.solidColor.enabled="true";
			        //playListText9.background.solidColor = "rgb(128,128,128)";
                                playListBar9.background.solidColor.enabled="true";
			        playListSelectBar9.background.solidColor.enabled="false";
			        //playListBar9.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 10+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText10.enabledHorzScroll="true";
                                }
			        playListText10.background.solidColor.enabled="true";
			        //playListText10.background.solidColor = "rgb(128,128,128)";
                                playListBar10.background.solidColor.enabled="true";
			        playListSelectBar10.background.solidColor.enabled="false";
			        //playListBar10.background.solidColor = "rgb(128,128,128)";
			}
			if (playIndex == 11+ (12 * chunkIndex)) {
                                if (preferencesScrollingPrefValue.text === "enabled" ) {
                                   playListText11.enabledHorzScroll="true";
                                }
			        playListText11.background.solidColor.enabled="true";
			        //playListText11.background.solidColor = "rgb(128,128,128)";
                                playListBar11.background.solidColor.enabled="true";
			        playListSelectBar11.background.solidColor.enabled="false";
			        //playListBar11.background.solidColor = "rgb(128,128,128)";
			}
		}
}
//=====================
//End function
//=====================


//===================================
//  function to select the previous page
//===================================
function prevChunkOnMouseDown(Sender,Button,Shift,X,Y)
{
      //PlaySound(keypress);
      prevChunkClick();
}
//=====================
//End function
//=====================

//===================================
// function to handle the multiclick - this seems unnecessarily duplicated but it simply overrides the double click for the whole widget
//===================================
function prevChunkOnDblClick(Sender)  {
  prevChunkClick();
}
//=====================
//End function
//=====================

//===================================
//  function to select the next page
//===================================
function nextChunkOnMouseDown(Sender,Button,Shift,X,Y) {
  //PlaySound(keypress);
  nextChunkClick();
}
//=====================
//End function
//=====================






//===================================
//  function to select the next page
//===================================
function nextChunkClick() {
    var totalChunks = Math.ceil(playListfileCount / chunkSize);

    dprint("%-I-INFO, nextChunkClick");
    PlaySound(keypress);
    trackIndex = 1;
    if (chunkIndex < totalChunks - 1) {
    	chunkIndex = chunkIndex + 1;
    } else {
        playSound(mistake);
    }
    dprint("chunkIndex " + chunkIndex);
    dprint("trackIndex " + trackIndex);
    updatePlayList();
}
//=====================
//End function
//=====================

//===================================
// function to handle the multiclick - this seems unnecessarily duplicated but it simply overrides the double click for the whole widget
//===================================
function nextChunkOnDblClick(Sender)  {
  nextChunkClick();
}
//=====================
//End function
//=====================


//===================================
//  function to select the previous page
//===================================
function prevChunkClick() {
    dprint ("%-I-INFO, prevChunkClick");
    if (preferencesSoundprefValue.text === "enabled") {
                      PlaySound(keypress);
    }
//    trackIndex = 1;
    if (chunkIndex >0) {
      chunkIndex = chunkIndex - 1;
			dprint("chunkIndex "+chunkIndex);
			dprint("trackIndex "+trackIndex);
      updatePlayList();
    }
}
//=====================
//End function
//=====================


//===================================
//  function to select the first page
//===================================
function firstChunkOnMouseDown(Sender,Button,Shift,X,Y) {
    dprint ("%-I-INFO, firstChunk.onMouseDown");
    if (preferencesSoundprefValue.text === "enabled") {
            PlaySound(keypress);
    }
    chunkIndex = 0;
    dprint("firstChunk chunkIndex "+chunkIndex);
    dprint("firstChunk trackIndex "+trackIndex);
    updatePlayList();
}
//=====================
//End function
//=====================

//===================================
//  function to select the last page
//===================================
function lastChunkOnMouseDown(Sender,Button,Shift,X,Y)
{
    var totalChunks = Math.ceil(playListfileCount / chunkSize);
    dprint("%-I-INFO, lastChunk.onMouseDown");
    dprint("playListfileCount " + playListfileCount);
    dprint("chunkSize " + chunkSize);
    dprint("totalChunks " + totalChunks);
    if (preferencesSoundprefValue.text === "enabled") {
          PlaySound(keypress);
    }
    chunkIndex = totalChunks - 1;
    updatePlayList();
}
//=====================
//End function
//=====================


//===================================
// function to make the buttons visible when the mouse is on the playlist
//===================================
function playlistFrameOnMouseEnter(Sender,Button,Shift,X,Y) {
    //dprint ("%-I-INFO, playlistFrame.onMouseEnter");
    buttonOpacity();
}
//=====================
//End function
//=====================


//===================================
// function to make the buttons visible when a mouseover event occurs
//===================================
function buttonOpacity() {
 //dprint ("%-I-INFO, buttonOpacity");
    nextChunk.opacity = 1;
    prevChunk.opacity = 1;
    firstChunk.opacity = 1;
    lastChunk.opacity = 1;
    buttonConfig.opacity = 1;
    keyf.opacity = 1;
    keyd.opacity = 1;
    keyu.opacity = 1;
    if (preferencesPlaylistFormatPrefValue.text === "xml") {
      oButton.opacity = 1;
      sButton.opacity = 1;
    } else {
      oButton.opacity = .01;
      sButton.opacity = .01;
    }
    ovalButton.opacity = 1;
    keyViewScreen.opacity = 1;
    keyFullScreen.opacity = 1;
    bracket.opacity = 1;

 // the fadeTo (255,1) does not actually do what it is designed to do
 // instead it reverses any current fadeTo that is currently underway
    /*
    lastChunk.FadeTo(255,1);
    nextChunk.FadeTo(255,1);
    prevChunk.FadeTo(255,1);
    firstChunk.FadeTo(255,1);
    lastChunk.FadeTo(255,1);
    buttonConfig.FadeTo(255,1);
    oButton.FadeTo(255,1);
    sButton.FadeTo(255,1);
    ovalButton.FadeTo(255,1);
    keyf.FadeTo(255,1);
    keyd.FadeTo(255,1);
    keyu.FadeTo(255,1);
    bracket.FadeTo(255,1);
    keyViewScreen.FadeTo(255,1);
    keyFullScreen.FadeTo(255,1);
    */
    // they have to be set to be completely opaque

}
//=====================
//End function
//=====================



//===================================
// function to handle multiclick on the chain pull
//===================================
function chainOnDblClick(Sender)  {
     chainAction();               // this seems unnecessarily duplicated but it simply overrides the double click for the whole widget
}
//=====================
//End function
//=====================


//===================================
// function to handle a single click on the chain pull
//===================================
function chainOnMouseDown(Sender,Button,Shift,X,Y) {
     chainAction();
}
//=====================
//End function
//=====================





//=======================================
// Function to parse an XML playlist file
//=======================================
function parseXMLFile(filename) {

        var playListfileCount;
        var linesStringRead;
        var lines;
        var count = 0;
        var filename;
        var i;

    	// xwidget reads files as a string rather than an array of elements
        linesStringRead = readFile(filename);
        // we convert the string into a useful array using the newline character as the delineator
        lines = linesStringRead.split(/\r?\n/);
        // I should really parse this properly but Xwidget does not handle the XML DOM intrinsically
	for (i = 0; i < 8; i += 1) {
          // trim it too as there may be spurious extra characters in and around it
          var lineString = trim(lines[i]);
          if ( lineString.indexOf("</path>") != -1 ) {
                  // if the <path> is found we jump to the next line where the actual path is
                  // it'll look something like this "e:\music</path>"
  		  chosenFolder = lineString.substring(0,lineString.lastIndexOf("</path>"));
                  chosenFolder = chosenFolder.substring(6);
                  //dprint ("chosenFolder found!" + chosenFolder);
	  }

          if ( lineString.indexOf("</filecount>") != -1 ) {
                playListfileCount = lineString.substring(0,lineString.lastIndexOf("</filecount>"));
		playListfileCount = playListfileCount.substring(11);
	//dprint("3>>>>>>>>>>>>>>Filesystem recursive search file count " +playListfileCount);
          }
        }

        thePlayList = new Array(playListfileCount);

        for (i = 0; i < lines.length; i += 1) {
           var lineString = trim(lines[i]);
           if ( lineString.indexOf("</file>") != -1 ) {
                filePath = (lineString.substring(0,lineString.lastIndexOf("</file>")));
                filePath = (filePath.substring(6));
		thePlayList[count] = new FileMedia(filePath);
		//dprint(filePath2);
		count = count + 1;
           }
         }
}
//=====================
//End function
//=====================


//=======================================
// Function to parse an XML playlist file
//=======================================
function parseXSPFFile(filename) {

        var playListfileCount;
        var linesStringRead;
        var lines;
        var count = 0;
        var filename;
        var i;

    	// xwidget reads files as a string rather than an array of elements
        linesStringRead = readFile(filename);
        // we convert the string into a useful array using the newline character as the delineator
        lines = linesStringRead.split(/\r?\n/);
        playListfileCount = lines.length - 3;

        // I should really parse this properly but Xwidget does not handle the XML DOM intrinsically
	for (i = 0; i < 5; i += 1) {
          // trim it too as there may be spurious extra characters in and around it
          var lineString = trim(lines[i]);
          if ( lineString.indexOf("</location>") != -1 ) {
                  // if the <location> is found it'll look something like this "e:\music</path>"
  		  chosenFolder = lineString.substring(0,lineString.lastIndexOf("</location>"));
                  chosenFolder = chosenFolder.substring(24);
                  chosenFolder = chosenFolder.substring(0,chosenFolder.lastIndexOf("\\"));
                  //dprint ("chosenFolder found!" + chosenFolder);
	  }
        }

        thePlayList = new Array(playListfileCount);

        for (i = 0; i < lines.length; i += 1) {
           var lineString = trim(lines[i]);
           if ( lineString.indexOf("</location>") != -1 ) {
                filePath = (lineString.substring(0,lineString.lastIndexOf("</location>")));
                filePath = (filePath.substring(24));
		thePlayList[count] = new FileMedia(filePath);
		//dprint(filePath);
		count = count + 1;
           }
         }
}
//=====================
//End function
//=====================


//=================================
// Function to open an XML file for reading
//=================================
function readSiteRecords(trackListFileFormat) {
	var dict = [], i;
        var validSuffix, filename;

	dprint ("%-I-INFO, readSiteRecords");

	//trackListFileFormat = "xspf";  //for testing
        chunkIndex = 0;
	isAudioCD = false;

        if (trackListFileFormat === "xspf") {
           validSuffix = ".xspf";
        } else {
           validSuffix = ".xml";
        }

	filename = openFileDialog("");
        if ( filename === null || filename === "" ) {  //xwidget responds with a "" and not null if cancelled
           return;
        }
        
        //The indexOf() method returns the position of the first occurrence of a specified value in a string.
        //JScript arrays have no .IndexOf() method so validSuffix cannot be an array of valid suffixes
        if (validSuffix.indexOf(xtn(filename)) === -1) {
           alert("Invalid file type, please ensure your input file has " + validSuffix + " as the suffix.");
           return;
        }

        if (trackListFileFormat === "xspf") {
           parseXSPFFile(filename)
        } else {
           parseXMLFile(filename);
        }

        log("----- readSiteRecords -----");

        //dprint("thePlayList[0].sourceURL  "+ thePlayList[0].sourceURL );
        //dprint("thePlayList[8].sourceURL  "+ thePlayList[8].sourceURL );
        //dprint("thePlayList[playListfileCount-1].sourceURL  "+ thePlayList[playListfileCount-1].sourceURL );

        updatePlayList();
        alert("Playlist  \"" + filename + "\" read successfully.");
}
//=================================
// end function
//=================================


//=================================
// Function to open an XML file for writing
//=================================
function writeSiteRecords(trackListFileFormat) {
        dprint("%-I-INFO, writeSiteRecords");
	var filename,  i;
        var validSuffix;

        if (trackListFileFormat === "xspf") {
           validSuffix = ".xspf";
        } else {
           validSuffix = ".xml";
        }

        filename = SaveFileDialog("");
        if ( filename === null || filename === "" ) {   //xwidget responds with a "" and not null if cancelled
           return;
        }
        if (trackListFileFormat === "xml") {    // user did not supply a suffix
           if (xtn(filename) === "") { filename += ".xml"; }
        } else {
           if (xtn(filename) === "") { filename += ".xspf"; }
        }

        //The indexOf() method returns the position of the first occurrence of a specified value in a string.
        //JScript arrays have no .IndexOf() method so validSuffix cannot be an array of valid suffixes
        if (validSuffix.indexOf(xtn(filename)) === -1) {
               alert("Invalid file type, please ensure your output file has " + validSuffix + " as the suffix.");
    	       return;
        }

        if (trackListFileFormat === "xml") {
    		//path = preferencesMusicFolderPrefValue.text ;
    		writeXMLRecords(filename);
    		//eprint("siteList.length: " + siteList.length);
    		//eprint("siteList: " + siteList);
        } else {
               writeXSPFRecords(filename)
        }

        //dprint("----- writeSiteRecords -----");
	//dprint(" ");
	//alert("Playlist  \"" + filename + "\" written successfully.");

}
//=================================
// end function
//=================================


//=================================
// Function to write the records to a file
//=================================
function writeXMLRecords(XMLpath, dict) {
	var i = 0,
	head = '<?xml version="1.0" encoding="UTF-8"?>\n<rss version="2.0">\n<channel>\n',
	tail = "</channel>\n</rss>\n",
	body = "",dict = [],
        output;

        for (i = 0; i < thePlayList.length; i += 1) {
			dict[i] = {};
			dict[i].trackPath = thePlayList[i].sourceURL;
			//dprint("thePlayList[i] "+ thePlayList[i].sourceURL);
	}

        dprint("writeXMLRecords: " + XMLpath + ", " + dict.length);
    
	body += "<filecount>" + playListfileCount + "</filecount>\n";
	body += "<path>" + path + "</path>\n";

	for (i = 0; i < dict.length; i += 1) {
		body += "<file>" + dict[i].trackPath + "</file>\n";
	}
        output = head + body + tail;
	FilesystemWriteFile(XMLpath, output);
}
//=================================
// end function
//=================================


//=========================================
// Function to write XSPF records to a file
//=========================================
function writeXSPFRecords(XSPFpath, dict) {
    var i = 0,
        head = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<playlist version=\"1\" xmlns=\"http://xspf.org/ns/0/\">\n<trackList>\n",
        tail = "</trackList>\n</playlist>\n",
        body = "",dict = [],
        output;

    dprint("writeXSPFRecords: " + XSPFpath + ", " + dict.length);

    for (i = 0; i < thePlayList.length; i += 1) {
			dict[i] = {};
			dict[i].trackPath = thePlayList[i].sourceURL;
			//dprint("thePlayList[i] "+ thePlayList[i].sourceURL);
    }

    for (i = 0; i < dict.length; i += 1) {
        if (dict[i].trackPath.indexOf("http://") === 0) {
            body += "<track><location>" + dict[i].trackPath.replace(/&/g, "&amp;") + "</location></track>\n";
        } else {
            body += "<track><location>" + "file://" + dict[i].trackPath.replace(/&/g, "&amp;") + "</location></track>\n";
        }
    };

    output = head + body + tail;
    FilesystemWriteFile(XSPFpath, output);
}
//=================================
// end function
//=================================

//=================================
//function to write an ANSI file
//=================================
function FilesystemWriteFile(writePath,writeData)
{
   var fso  = new ActiveXObject("Scripting.FileSystemObject");
   var fh = fso.CreateTextFile(writePath, 2, true);
   fh.WriteLine(writeData);
   fh.Close();
}
//=================================
// end function
//=================================


//=================================
// Function to open a file
//=================================
function oButtonOnMouseDown(Sender,Button,Shift,X,Y) {

         if (preferencesSoundprefValue.text === "enabled") {
            PlaySound(winding);
         }

         readSiteRecords(trackListFileFormat);

}
//=================================
// end function
//=================================

//=================================
// Function to save a file
//=================================
function sButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
    if (preferencesSoundprefValue.text === "enabled") {
	 PlaySound(winding);
    }
    writeSiteRecords(trackListFileFormat);
}

//=================================
// end function
//=================================


//======================================================================================
// END mediaPlayer.js
//======================================================================================

//===========================================
// this function opens Google to search using the track name
//===========================================
function trackNameTextOnDblClick(Sender)
{
	dprint ("%-I-INFO, trackNameText.onMultiClick");
	var searchTrack = getFileOnly(trackNameText.text);
	if (confirm2(" This opens a browser window and searches the internet for this track name: " +  String.fromCharCode(13) + searchTrack + String.fromCharCode(13) + "                              Do you wish to proceed?                         "))
        {
		openURL("https://www.google.co.uk/?gws_rd=ssl#q="+searchTrack);
        }          
}
//=====================
//End function
//=====================


//===========================================
// this function opens explorer to view the folder
//===========================================
function playListTitleOnDblClick(Sender)
{
	dprint ("%-I-INFO, trackNameText.onMultiClick");
	if (isAudioCD == false) {
                if (preferencesHintsPrefValue.text == "enabled") {
                   playListTitle.hint =  playListTitle.text;
                }
		var targetFullPath = playListTitle.text;

                if (folderExists(targetFullPath) )   {
			open(targetFullPath);
		}
	}
}
//=====================
//End function
//=====================





//=====================
// function to show the track title back into normal state
//=====================
function playListTitleOnMouseLeave(Sender)
{
     playListTitle.enabledHorzScroll="false";
}
//=====================
//End function
//=====================


//=====================
// functions to show the track NAMES back into normal state
//=====================
function playListText0OnMouseLeave(Sender)
{
        playListText0.font.size = (fontDefault)     ;
        deleteButton0.opacity="0.01";  // normal usage for a simple hover
        if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText0.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar0.background.solidColor.enabled="false";
        }

        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 0) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];
              deleteTrack(0);
        }
}
function playListText1OnMouseLeave(Sender)
{
        playListText1.font.size = (fontDefault)     ;
        deleteButton1.opacity="0.01";  // normal usage for a simple hover
        if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText1.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar1.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 1) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];
              deleteTrack(1);
        }
}
function playListText2OnMouseLeave(Sender)
{
          playListText2.font.size = (fontDefault)     ;
          deleteButton2.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText2.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar2.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 2) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];
              deleteTrack(2);
          }
}
function playListText3OnMouseLeave(Sender)
{
          playListText3.font.size = (fontDefault)     ;
          deleteButton3.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText3.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar3.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 3) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(3);
          }
}
function playListText4OnMouseLeave(Sender)
{
          playListText4.font.size = (fontDefault)     ;
          deleteButton4.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText4.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar4.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 4) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(4);
          }
}
function playListText5OnMouseLeave(Sender)
{
          playListText5.font.size = (fontDefault)     ;
          deleteButton5.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText5.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar5.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 5) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(5);
          }
}
function playListText6OnMouseLeave(Sender)
{
          playListText6.font.size = (fontDefault)     ;
          deleteButton6.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText6.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar6.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 6) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(6);
          }
}
function playListText7OnMouseLeave(Sender)
{
          playListText7.font.size = (fontDefault)     ;
          deleteButton7.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText7.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar7.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 7) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(7);
          }
}
function playListText8OnMouseLeave(Sender)
{
          playListText8.font.size = (fontDefault)     ;
          deleteButton8.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText8.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar8.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 8) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(8);
          }
}
function playListText9OnMouseLeave(Sender)
{
          playListText9.font.size = (fontDefault)     ;
          deleteButton9.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              //dprint("   savedReplacedTrack "+savedReplacedTrack);
              playListText9.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar9.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 9) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(9);
          }
}
function playListText10OnMouseLeave(Sender)
{
          playListText10.font.size = (fontDefault)     ;
          deleteButton10.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText10.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar10.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 10) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];

              deleteTrack(10);
          }
}

function playListText11OnMouseLeave(Sender)
{
          playListText11.font.size = (fontDefault)     ;
          deleteButton11.opacity="0.01";  // normal usage for a simple hover
          if (dragDropFlg === 1 && trackClickedFlg === 1) {  //if (drag and drop in operation)
              playListText11.text = savedReplacedTrack.toLowerCase();   //old track name being replaced in mouseleave
              playListSelectBar11.background.solidColor.enabled="false";
        }
        if (dragDropFlg === 1 && trackClickedFlg === 1 && dragPosition === 11) {
              fullTrackNameToDrop = fullTrackName[dragPosition + (chunkSize * chunkIndex)];
              deleteTrack(11);
          }
}
//=====================
//End mouse exit functions
//=====================








function nextButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
  	currentButtonStatus = "next";
}

function nextButtonOnMouseEnter(Sender)
{
  nextButton.src="nextButtonHover.png";
}

function nextButtonOnMouseLeave(Sender)
{
  nextButton.src="nextButton.png";
}


function nextButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
  	nextTrack();
	currentButtonStatus = "";
}
//=====================
//End functions
//=====================

//===========================================
// Function that causes the button to react to a mousehover
//===========================================
function prevButtonOnMouseEnter(Sender)
{
  prevButton.src="previousButtonHover.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that causes the button to react to a mousehover
//===========================================
function prevButtonOnMouseLeave(Sender)
{
  prevButton.src="previousButton.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that tracks the current button press status
//===========================================
function prevButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
  currentButtonStatus = "previous";
}
//=====================
//End functions
//=====================

//===========================================
// Function that calls the previous track
//===========================================
function prevButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
  previousTrack();
  currentButtonStatus = "";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function lockAreaFreeOnMouseEnter(Sender)
{
  lockAreaFree.src="lockAreaHover.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function lockAreaFreeOnMouseLeave(Sender)
{
  lockAreaFree.src="lockAreaFree.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function autoPlayLugOnMouseEnter(Sender)
{
  autoPlayLug.src="autoPlayLugHover.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function autoPlayLugOnMouseLeave(Sender)
{
  autoPlayLug.src="autoPlayLug.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function autoPlayLugOnMouseMove(Sender,Shift,X,Y,Dx,Dy)
{
  
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function endPipeOnMouseLeave(Sender)
{
   endPipe.src="pipes-end.png";
  
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function endPipeOnMouseEnter(Sender)
{
    endPipe.src="pipes-endHover.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function pipesRightOnMouseEnter(Sender)
{
                        //dprint("2 preferencesShuffleStatePrefValue.text "+preferencesShuffleStatePrefValue.text);
                        if (preferencesShuffleStatePrefValue.text  == "enabled") {
                            pipesRight.src="pipesRightHover.png";
                            
                        } else {
                            pipesRight.src="pipesRightClicked.png";
                        }
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function pipesRightOnMouseDown(Sender,Button,Shift,X,Y)
{
  pipesRight.src="pipesRight.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function pipesRightOnMouseUp(Sender,Button,Shift,X,Y)
{
  toggleRandomPlay();
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function pipesRightOnMouseLeave(Sender)
{
                        //dprint("1 preferencesShuffleStatePrefValue.text "+preferencesShuffleStatePrefValue.text);
                        if (preferencesShuffleStatePrefValue.text  == "enabled") {
                            pipesRight.src="pipesRightClicked.png";
                        } else {
                            pipesRight.src="pipesRight.png";
                        }
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function volumeDeviceOnMouseEnter(Sender)
{
    if (sliderSetClicked === true) {
        sliderSetClicked = false;
    }

}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function pipesOnMouseEnter(Sender)
{
  sliderSetClicked = false;
  buttonOpacity();

}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function lastChunkOnMouseEnter(Sender)
{
  lastChunk.src="lastButtonHover.png";
}

function lastChunkOnMouseLeave(Sender)
{
  lastChunk.src="lastButton.png";
}

function nextChunkOnMouseEnter(Sender)
{
  nextChunk.src="nextButtonHover.png";
}

function nextChunkOnMouseLeave(Sender)
{
  nextChunk.src="nextButton.png";
}

function prevChunkOnMouseEnter(Sender)
{
  prevChunk.src="previousButtonHover.png";
}

function prevChunkOnMouseLeave(Sender)
{
  prevChunk.src="previousButton.png";
}

function firstChunkOnMouseEnter(Sender)
{
  firstChunk.src="firstButtonHover.png";
}

function firstChunkOnMouseLeave(Sender)
{
  firstChunk.src="firstButton.png";
}

function oButtonOnMouseEnter(Sender)
{
  oButton.src="oButtonHover.png";
}

function oButtonOnMouseLeave(Sender)
{
  oButton.src="oButton.png";
}

function sButtonOnMouseEnter(Sender)
{
  sButton.src="sButtonHover.png";
}

function sButtonOnMouseLeave(Sender)
{
  sButton.src="sButton.png";
}

function ovalButtonOnMouseEnter(Sender)
{
  ovalButton.src="ovalButtonHover.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function ovalButtonOnMouseLeave(Sender)
{
  ovalButton.src="ovalButton.png";
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
//===================================
// function to save the last used music folder path
//===================================
 function saveFolder(path){
    dprint ("%-I-INFO, saveFolder");
	if (path == "") {
	      return;
	}
        if (preferencesMusicFolderPrefValue.text != "") {
                if (preferencesMusicFolderPref2Value.text != "") {
                        if (preferencesMusicFolderPref3Value.text != "") {
                              if (preferencesMusicFolderPref4Value.text != "") {
                                      preferencesMusicFolderPref5Value.text = preferencesMusicFolderPref4Value.text;
                              }                        	
                              preferencesMusicFolderPref4Value.text = preferencesMusicFolderPref3Value.text;
                        }
                	preferencesMusicFolderPref3Value.text = preferencesMusicFolderPref2Value.text;
                }
        	preferencesMusicFolderPref2Value.text = preferencesMusicFolderPrefValue.text;
        }
       	preferencesMusicFolderPrefValue.text = path;
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem15OnClick(Sender)
{
              addSingleTrack("local");
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem16OnClick(Sender)
{
  openFolderToPlay();
}
//=====================
//End functions
//=====================

//===========================================
// Function that opens a folder to play
//===========================================
function openFolderToPlay() {
  if (preferencesSoundprefValue.text === "enabled") {
     PlaySound(winding);
  }
  chosenFolder = openFolderDialog("");     //YWE function

    path = chosenFolder;

    if (chosenFolder != "") {
       dprint("chosenFolder "+chosenFolder);
       playerState = "folder"; //this is to ensure that shuffle mode is respected
       //  If it is a drive top folder chosen C:\ or d:\ for example
       if (chosenFolder.length == 3 && chosenFolder.substr(1,1) == ":")
       {
          var o = chosenFolder.substr(0,2);
          if (CDROMcount != 0 ) {
             if ( o == CDROM.Item(cdRomNo).driveSpecifier) {
               menuitem23.caption="Audio CD Drive ("+ CDROM.Item(cdRomNo).driveSpecifier +")";
               PlayAudioCD( 0 , CDROM.Item(cdRomNo).Playlist);
             } else {
                 alert("Player needs a folder not a drive root");
             }
          } else {
             alert("Player needs a folder not a drive root");
          }   
        } else { 
          readFolderRecursively(chosenFolder);
          saveFolder(chosenFolder);
          updatePlayList();
        }
        setmenu(); // had to add this to the xwidget version as the YWE assignment of a pref to a menu
                   // item is dynamic. Not the case in Xwidgets.
     }
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem18OnClick(Sender)
{

            playerState = "folder"; //this is to ensure that shuffle mode is respected
            if (folderExists(preferencesMusicFolderPrefValue.text)) {
               chosenFolder = preferencesMusicFolderPrefValue.text;
               path = chosenFolder;
            } else {
	       dprint("folder not found");
               alert('The folder does not exist. Selecting the previous folder/playlist instead.');
            }                  
            menuitem18.caption="Play previous folder 1 - " + preferencesMusicFolderPrefValue.text;
            readFolderRecursively(chosenFolder);
            updatePlayList();
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem19OnClick(Sender)
{
              playerState = "folder"; //this is to ensure that shuffle mode is respected
            if (folderExists(preferencesMusicFolderPref2Value.text)) {
               chosenFolder = preferencesMusicFolderPref2Value.text;
			   path = chosenFolder;
            } else {
				dprint("folder not found");
               alert('The folder does not exist. Selecting the previous folder/playlist instead.');
            }
            menuitem19.caption="Play previous folder 2 - " + preferencesMusicFolderPref2Value.text;
            readFolderRecursively(chosenFolder);
            updatePlayList();
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem20OnClick(Sender)
{
           playerState = "folder"; //this is to ensure that shuffle mode is respected
            if (folderExists(preferencesMusicFolderPref3Value.text)) {
               chosenFolder = preferencesMusicFolderPref3Value.text;
			   path = chosenFolder;
            } else {
				dprint("folder not found");
               alert('The folder does not exist. Selecting the previous folder/playlist instead.');
            }
            menuitem20.caption="Play previous folder 3 - " + preferencesMusicFolderPref3Value.text;
            readFolderRecursively(chosenFolder);
            updatePlayList();
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem21OnClick(Sender)
{
              playerState = "folder"; //this is to ensure that shuffle mode is respected
            if (folderExists(preferencesMusicFolderPref4Value.text)) {
               chosenFolder = preferencesMusicFolderPref4Value.text;
			   path = chosenFolder;
            } else {
				dprint("folder not found");
               alert('The folder does not exist. Selecting the previous folder/playlist instead.');
            }
            menuitem21.caption="Play previous folder 4 - " + preferencesMusicFolderPref4Value.text;
            readFolderRecursively(chosenFolder);
            updatePlayList();
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem22OnClick(Sender)
{
            playerState = "folder"; //this is to ensure that shuffle mode is respected
            if (folderExists(preferencesMusicFolderPref5Value.text)) {
               chosenFolder = preferencesMusicFolderPref5Value.text;
			   path = chosenFolder;
            } else {
				dprint("folder not found");
               alert('The folder does not exist. Selecting the previous folder/playlist instead.');
            }
            menuitem22.caption="Play previous folder 5 - " + preferencesMusicFolderPref5Value.text;
            readFolderRecursively(chosenFolder);
            updatePlayList();
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function menuitem23OnClick(Sender)
{
        if (CDROMcount != 0 ) {
                 dprint("Audio CD Drive ("+ CDROM.Item(cdRomNo).driveSpecifier +")");
                 menuitem23.caption="Audio CD Drive ("+ CDROM.Item(cdRomNo).driveSpecifier +")";
                 PlayAudioCD( 0 , CDROM.Item(cdRomNo).Playlist);
        }
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function setmenu()    {
    if (preferencesMusicFolderPrefValue.text != "") {
       menuitem18.caption="Play previous folder 1 - " + preferencesMusicFolderPrefValue.text;
    }
    if (preferencesMusicFolderPref2Value.text != "") {
       menuitem19.caption="Play previous folder 2 - " + preferencesMusicFolderPref2Value.text;
    }
    if (preferencesMusicFolderPref3Value.text != "") {
       menuitem20.caption="Play previous folder 3 - " + preferencesMusicFolderPref3Value.text;
    }
    if (preferencesMusicFolderPref4Value.text != "") {
       menuitem21.caption="Play previous folder 4 - " + preferencesMusicFolderPref4Value.text;
    }
    if (preferencesMusicFolderPref5Value.text != "") {
       menuitem22.caption="Play previous folder 5 - " + preferencesMusicFolderPref5Value.text;
    }
    if (CDROMcount != 0 ) {
     if (CDROM.Item(cdRomNo)) {
        menuitem23.caption="Audio CD Drive ("+ CDROM.Item(cdRomNo).driveSpecifier +")";
     }
    } else {
      menuitem23.caption="No CD drive";
    }
}


//===========================================
// Function to slide the volume slider according to mouse scrollwheel position
//===========================================
function playlistFrameOnMouseWheelUp(Sender)
{
 if (ctrlPressed === 1) {
     volumeDeviceOnMouseWheelUp(Sender);  // resize
 } else {
     if (preferencesMouseWheelScrollingPrefValue.text === "up") {
        nextChunkClick();
     } else {
        prevChunkClick();
     }
 }
}
//=====================
//End function
//=====================

//===========================================
// Function to slide the volume slider according to mouse scrollwheel position
//===========================================
function playlistFrameOnMouseWheelDown(Sender)
{
 if (ctrlPressed === 1) {
     volumeDeviceOnMouseWheelDown(Sender);  // resize
 } else {
     if (preferencesMouseWheelScrollingPrefValue.text === "up") {
        prevChunkClick();
     } else {
        nextChunkClick();
     }
 }
}
//=====================
//End function
//=====================






//===================================
// function to make the buttons visible when the mouse is on the playlist
//===================================
function playlistAreaOnMouseEnter(Sender)
{
    //dprint ("%-I-INFO, playlistFrame.onMouseEnter");
     buttonOpacity();
}
//=====================
//End function
//=====================


//===================================
// function to fade the playlist buttons when the mouse is not on the playlist
//===================================
function playlistFrameOnMouseLeave(Sender,Button,Shift,X,Y) {
    //dprint ("%-I-INFO, playlistFrame.onMouseExit");
    if ( preferencesPlayListKeysPrefValue.text === "fade" ) {
        fadeTimer.enabled = true;
    }
    dragDropFlg = 0; // cancelling the drag/dtop flag anywhere I can
}
//=====================
//End function
//=====================

//===================================
// function to fade the playlist buttons when the mouse is not on the playlist
//===================================
function playlistAreaOnMouseLeave(Sender)  {
 dprint ("%-I-INFO, playlistArea.onMouseExit");
 if ( preferencesPlayListKeysPrefValue.text === "fade" ) {
    fadeTimer.enabled = true;
    /*lastChunk.FadeTo(0,20);
    nextChunk.FadeTo(0,20);
    prevChunk.FadeTo(0,20);
    firstChunk.FadeTo(0,20);
    lastChunk.FadeTo(0,20);
    buttonConfig.FadeTo(0,20);
    oButton.FadeTo(0,20);
    sButton.FadeTo(0,20);
    ovalButton.FadeTo(0,20);
    keyf.FadeTo(0,20);
    keyd.FadeTo(0,20);
    keyu.FadeTo(0,20);
    bracket.FadeTo(0,20);
    keyViewScreen.FadeTo(0,20);
    keyFullScreen.FadeTo(0,20);
    */
    dragDropFlg = 0; // cancelling the drag/drop flag anywhere I can
  }
}
//=====================
//End function
//=====================







//=========================================================================
// this function closes the preferences
//=========================================================================
function cancelButton2OnClick(Sender)
{
         preferences02.visible = false;
         widget.WindowZPosition=windowPos;
}
//=====================
//End function
//=====================

function discIconOnClick(Sender)
{
  fontPreferences.visible = false;
  musicPreferences.visible = true;
  commandsPreferences.visible = false;
  configPreferences.visible = false;
  soundPreferences.visible = false;
  videoPreferences.visible = false;

  videoSquare.visible = false;
  fontSquare.visible = false;
  musicSquare.visible = true;
  commandSquare.visible = false;
  configSquare.visible = false;
  soundSquare.visible = false;
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function commandsIconOnClick(Sender)
{
    fontPreferences.visible = false;
  musicPreferences.visible = false;
    commandsPreferences.visible = true;
      configPreferences.visible = false;
        soundPreferences.visible = false;
    videoPreferences.visible = false;

    videoSquare.visible = false;
    fontSquare.visible = false;
    musicSquare.visible = false;
    commandSquare.visible = true;
    configSquare.visible = false;
    soundSquare.visible = false;        
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function soundIconOnClick(Sender)
{
    fontPreferences.visible = false;
    musicPreferences.visible = false;
    commandsPreferences.visible = false;
      configPreferences.visible = false;
        soundPreferences.visible = true;
    videoPreferences.visible = false;

    videoSquare.visible = false;        
    fontSquare.visible = false;
    musicSquare.visible = false;
    commandSquare.visible = false;
    configSquare.visible = false;
    soundSquare.visible = true;        
        
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function fontIconOnClick(Sender)
{
    fontPreferences.visible = true;
    musicPreferences.visible = false;
    commandsPreferences.visible = false;
    configPreferences.visible = false;
    soundPreferences.visible = false;
    videoPreferences.visible = false;
        
    videoSquare.visible = false;
    fontSquare.visible = true;
    musicSquare.visible = false;
    commandSquare.visible = false;
    configSquare.visible = false;
    soundSquare.visible = false;
    
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function configIconOnClick(Sender)
{
    fontPreferences.visible = false;
    musicPreferences.visible = false;
    commandsPreferences.visible = false;
    configPreferences.visible = true;
    soundPreferences.visible = false;  
    videoPreferences.visible = false;

    videoSquare.visible = false;        
    fontSquare.visible = false;
    musicSquare.visible = false;
    commandSquare.visible = false;
    configSquare.visible = true;
    soundSquare.visible = false;
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function cancelButtonOnClick(Sender)
{
 fontPreferences.visible = false;
  musicPreferences.visible = false;
    commandsPreferences.visible = false;
      configPreferences.visible = false;
        soundPreferences.visible = false;
        videoPreferences.visible = false;
        prefsButtons.visible=false;
         widget.WindowZPosition=windowPos;
         keytimer.enabled=true;
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function musicbuttonOnMouseDown(Sender,Button,Shift,X,Y)
{
  var path1 = openFolderDialog("");
  if (path1 != "") {
    preferencesMusicFolderPrefValue.text = path1;
  }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function musicbutton2OnMouseDown(Sender,Button,Shift,X,Y)
{
  var  path2 = openFolderDialog("");
  if (path2 != "") {
  preferencesMusicFolderPref2Value.text = path2;
    }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function musicbutton3OnMouseDown(Sender,Button,Shift,X,Y)
{
  var path3 = openFolderDialog("");
  if (path3 != "") {  
  preferencesMusicFolderPref3Value.text = path3;
    }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function musicbutton4OnMouseDown(Sender,Button,Shift,X,Y)
{
    var path4 = openFolderDialog("");
    if (path4 != "") {
      preferencesMusicFolderPref4Value.text = path4;
    }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function musicbutton5OnMouseDown(Sender,Button,Shift,X,Y)
{
    var path5 = openFolderDialog("");
    if (path5 != "") {
      preferencesMusicFolderPref5Value.text = path5;
    }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function button2OnMouseDown(Sender,Button,Shift,X,Y)
{
        if (preferencesRecurseFoldersPrefValue.text === "enabled" ) {
               preferencesRecurseFoldersPrefValue.text = "disabled" ;
        } else {
               preferencesRecurseFoldersPrefValue.text = "enabled"  ;
        }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function button3OnMouseDown(Sender,Button,Shift,X,Y)
{
          if (preferencesTitlePrefValue.text === "filename only" ) {
               preferencesTitlePrefValue.text = "filename with folder" ;
        } else {
               preferencesTitlePrefValue.text = "filename only"  ;
        }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function volumeProgressbarOnChange(Sender)
{
     var  adjustedVal = volumeProgressbar.percent;
     volumeProgressbar.hint =     "The widget size will be "  + adjustedVal + "%";
     preferencesAutoPlayVolumePrefValue.text =     adjustedVal;
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function button6OnMouseDown(Sender,Button,Shift,X,Y)
{
        if (preferencesStartupPlayStatePrefValue.text === "enabled" ) {
               preferencesStartupPlayStatePrefValue.text = "disabled" ;
        } else {
               preferencesStartupPlayStatePrefValue.text = "enabled"  ;
        }
  
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function button7OnMouseDown(Sender,Button,Shift,X,Y)
{
        preferencesPopupPanelFont.font.family = preferencesPopupPanelFont.text;
        
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function fontProgressbarOnChange(Sender)
{
  fontDefault = parseInt((19 /100 * fontProgressbar.Percent) + 9);
  preferencesPopupPanelFontSizePrefValue.text = fontDefault;
  preferencesPopupPanelFont.font.size = fontDefault;
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function button8OnClick(Sender)
{
          if (preferencesDebugflgPrefValue.text === "1" ) {
               preferencesDebugflgPrefValue.text = "0" ;
               debugDisplay.text = "Debug OFF";
        } else {
               preferencesDebugflgPrefValue.text = "1"  ;
               debugDisplay.text = "Debug ON";
        }
        debugFlg = preferencesDebugflgPrefValue.text;
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function button9OnClick(Sender)
{
        if (preferencesMouseWheelResizingPrefValue.text == "up" ) {
               preferencesMouseWheelResizingPrefValue.text = "down" ;
        } else {
               preferencesMouseWheelResizingPrefValue.text = "up"  ;

        }
}
//=====================
//End function
//=====================



//===================================
// function to check the music folder path
//===================================
function checkPath(){
    dprint ("%-I-INFO, checkPath");
	//preferencesMusicFolderPrefValue.text = "D:\\Music";
	dprint("preferencesMusicFolderPrefValue.text "+preferencesMusicFolderPrefValue.text);
        if (preferencesMusicFolderPrefValue.text == "") {
	      preferencesMusicFolderPrefValue.text = MyMusicPath; 
              //"C:\\Users\\Public\\Music";
	}
        //now restrict the user from selecting the root folders
        restrictRootFolder();
	dprint ("preferencesMusicFolderPrefValue.text "+ preferencesMusicFolderPrefValue.text);
        //preferences.musicFolderPref.value = "D:\\Music";
	path = preferencesMusicFolderPrefValue.text ;
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function button10OnMouseDown(Sender,Button,Shift,X,Y)
{
       if (preferencesHintsPrefValue.text == "enabled" ) {
               preferencesHintsPrefValue.text = "disabled" ;

        } else {
               preferencesHintsPrefValue.text = "enabled"  ;

        }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function keytimerOnUpdate(Sender)
{
//dprint("%KON-I-INFO, keytimerOnUpdate ");

                if (isKeyDown(17)) {
                    // CTRL key
                    //dprint("%KON-I-INFO, pressing CTRL key ");
                    ctrlPressed = 1;
                } else {
                    ctrlPressed = 0;
                }

                if (isKeyDown(40)) {
                    // right volume up
                    dprint("%KON-I-INFO, pressing down key ");
                    sliderSet.left = sliderSet.left - (10 );
                    limitSliderSet();
                }
                if (isKeyDown(38)) {
                    //left volume up
                    dprint("%KON-I-INFO, pressing up key ");
                    sliderSet.left = sliderSet.left + (10 );
                    limitSliderSet();
                }
                if (isKeyDown(78)) {
                    //next track
                    dprint("%KON-I-INFO, pressing N key ");
		    nextTrack();
                }
                if (isKeyDown(66)) {
                    //next track
                    dprint("debugFlg "+ debugFlg);
                    dprint("%KON-I-INFO, pressing B key ");
		    currentButtonStatus = "previous";
                    previousTrack();
                }

                if (isKeyDown(32)) {
                      //play/pause track
                    dprint("%KON-I-INFO, pressing space bar ");
 		    if (pauseButton.visible == false ) {
                        playTrack();
                        pauseButton.visible = true;
                    } else {
                      playButton.src="Resources/play.png";
                      pauseTrack();
                      playButton.visible = true;
                      pauseButton.visible = false;
  	              //buildVitality(currIcon, parseInt(percentTextShadow.text, 10), WMPlayer.settings.mute); // build the dock vitality
                    }
                }

                if (isKeyDown(39)) {
                      //FWD track
                      dprint("%KON-I-INFO, pressing right key ");
                      positionSlider.left = positionSlider.left  + 5 ;
                      constrainPositionSlider();
                }
                if (isKeyDown(37)) {
                      //RWD track
                      dprint("%KON-I-INFO, pressing left key ");
                      positionSlider.left = positionSlider.left - 5 ;
                      constrainPositionSlider();
                }

                if (isKeyDown(114)) {
                      //RWD track
                      dprint("%KON-I-INFO, pressing F3 ");
                      searchSameTrack();
                      //trackSearchLayer.visible = true;
                      //keytimer.enabled = false;
                }

                if (isKeyDown(70)) {
                    if (ctrlPressed === 1) {  //if the user is selecting the control key as well as the F key
                      dprint("%KON-I-INFO, pressing Ctrl+F " );
                      ctrlPressed = 0;
                      //searchForTrack();
                      trackSearchLayer.visible = true;
                      keytimer.enabled = true;
                    }
                }

                if (isKeyDown(88)) {
                    if (ctrlPressed === 1) {  //if the user is selecting the control key as well as the X key
                      dprint("%KON-I-INFO, pressing Ctrl+X " );
                      ctrlPressed = 0;
                      cutTrack();
                    }
                }

                if (isKeyDown(67)) {
                    if (ctrlPressed === 1) {  //if the user is selecting the control key as well as the C key
                      dprint("%KON-I-INFO, pressing Ctrl+C " );
                      ctrlPressed = 0;
                      copyTrack();
                    }
                }

                if (isKeyDown(86)) {
                    if (ctrlPressed === 1) {  //if the user is selecting the control key as well as the V key
                      dprint("%KON-I-INFO, pressing Ctrl+V " );
                      ctrlPressed = 0;
                      pasteTrack();
                    }
                }
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function widgetOnLeave()
{
  keytimer.enabled = false;
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function widgetOnEnter()
{
  // allow the widget to capture keypresseses again only when the two forms are not visible
  if (urlEntryForm.visible === 0 && trackSearchLayer.visible === 0) {
      keytimer.enabled = true;
  }
 dprint("urlEntryForm.visible " + urlEntryForm.visible);
 dprint("trackSearchLayer.visible " + trackSearchLayer.visible);
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function button11OnClick(Sender)
{  
        if (preferencesScrollingPrefValue.text === "enabled" ) {
               preferencesScrollingPrefValue.text = "disabled" ;
        } else {
               preferencesScrollingPrefValue.text = "enabled"  ;
        }
}
//=====================
//End function
//=====================



//===========================================
// function to accept a file on drag and drop
//===========================================
function catchFileDrop(Data) { // expects a bar-separated list of files in Xwidget drop operations
    var dropData = [],
        i,
        dropType,
        validFound = 0,
        f,
        j,
        path2,
        idxFile,
        isFolder2,
        tmpfilePlayList,
        conjoinedPlayList,
        biggerPlayListSize,
        n,
        currentDropPosition;

    //dprint("catchfiledrop - DATA " + Data) ;
    // convert the filelist into an array
    dropData = Data.split('|');
    n = dropData.length;  //instead of system.event.data.length

    dprint("%-I-INFO, catchFileDrop");
    dprint("Reading dropped items: " + (n));
    //only read less than 10,000 individual files
    if (n >= fileCountLimit ) {
	alert('In this drag/drop operation there are more than "' + fileCountLimit + '" files. Please select a much smaller amount!');
	return;
    }

    dprint("dropData[0] " + dropData[0]);
    dprint("dropData[1] " + dropData[1]);
    dprint("%-I-INFO, dropPosition " + dropPosition);
    //dprint("%-I-INFO, dragPosition " + dragPosition);
    //dprint("n " + n);

    // modify the drop position to take into account the page number
    currentDropPosition = dropPosition + (chunkSize * chunkIndex);

    // otherwise dropPostion === 0 from addSingleTrack and playFile(fileName)

    f = dropData[0];
    if (folderExists(f)) {
        dropType = "folder";
        isFolder2 = true;
        //f=f+"\\";
        chosenFolder = f;  //DB05 - moved to here to only show folder selection at the correct time.
        dprint(" f >>>>>>>>>>>>>>>>>>>>>>> "  + f);
        if (confirm2("Dragging this folder " + chosenFolder + String.fromCharCode(13) + String.fromCharCode(13) + "Will replace the current playlist. "  + String.fromCharCode(13) + "Do you want to proceed? "))
        {
	   // do nothing
        } else {
           return;
        }
    } else {
        dropType = "filenames";
        isFolder2 = false;
    }
    
    dprint ("Drop type = " + dropType);

    if (dropType === "folder") {
        //dprint("chosenFolder" +f);
        //dprint("chosenFolder" +chosenFolder);
        // If a folder is dropped, its contents will be added to the list
        if (isFolder2) {
            //add the files to the playlist
            readFolderRecursively(f);
            saveFolder(f);
            updatePlayList();
            setmenu();                        // build the menu
        }
        return; // all the work is done
    }

    if (dropType === "filenames") {
        // dropped file or files  -- could actually be a mixture of files and folders
        //dropType = dropData[0];
        //n = dropData.length;

        // add multiple files to the playlist
        tmpfilePlayList = [];   // new Array(n);
        idxFile = 0;
        IsPlaylist = true;
        for (i = 0; i < n; i += 1) {   // loop starts from one on the Xwidget
            path2 = dropData[i];
            dprint("path2 " + path2 + " ");
            //xwidget does not like .indexOf as per YWE we use validate_filetype function instead
            //if (validTypes.indexOf(xtn(path2)) >= 0) {
            //The indexOf() method returns the position of the first occurrence of a specified value in a string.
            //JScript arrays have no .IndexOf() method so validSuffix cannot be an array of valid suffixes
            if (validate_filetype(path2,validTypes) === true ) {
                validFound = 1;
                //add to the temporary play list
                tmpfilePlayList[idxFile] = new FileMedia(path2);
                dprint("Added " + path2 + " to the play list");
                idxFile += 1;
            }
        }
        if (validFound === 1) {
            // drag and drop on the playlist adds to existing list rather than replace altogether
            if (createNewList === 0) {
                // create a new playlist the current size but with the additional elements added - idxfile + playlist.length
                biggerPlayListSize = idxFile + playListfileCount;
                conjoinedPlayList = []; // new Array(biggerPlayListSize);

                // copy all the old elements to the new playlist up to the point where the drop has occurred - dropPosition
                for (i = 0; i < currentDropPosition; i += 1) {   // loop from 0 to the drop point
                    conjoinedPlayList[i] = thePlayList[i];
                    //dprint("*********** 1 conjoinedPlayList[" + i + "] " + conjoinedPlayList[i].sourceURL);
                }

                //if (n == 1) {  // single file
                //  conjoinedPlayList[dropPosition] = tmpfilePlayList[j];
                //} else {

                // drop the new elements at this point - idxfile is the count of the valid items
                j = 0;
                for (i = currentDropPosition; i < (currentDropPosition + idxFile); i += 1) {
                    conjoinedPlayList[i] = tmpfilePlayList[j];
                    j += 1;
                    //dprint("*********** 2 conjoinedPlayList[" + i + "] " + conjoinedPlayList[i].sourceURL);
                }


                // copy the rest of the old elements to the new playlist after the new items have been dropped

                j = currentDropPosition;
                for (i = currentDropPosition + idxFile; i < biggerPlayListSize; i += 1) {
                    if (thePlayList[i] !== null) {
                        conjoinedPlayList[i] = thePlayList[j];
                        //conjoinedPlayList[i] = "";
                        j += 1;
                        //dprint("*********** 3 conjoinedPlayList[" + i + "] " +conjoinedPlayList[i].sourceURL);
                    }
                }

                //dprint("*********** playListfileCount " +playListfileCount);
                playListfileCount = biggerPlayListSize;
	//dprint("4>>>>>>>>>>>>>>Filesystem recursive search file count " +playListfileCount);

                //add to the final play list
                for (i = 0; i < biggerPlayListSize; i += 1) {
                    if (conjoinedPlayList[i] !== null) {
                        thePlayList[i] = conjoinedPlayList[i];
                        //dprint("*********** 4 thePlayList[i] " +thePlayList[i].sourceURL);
                    }
                }

                dprint("playMedia Call no. 8");
                //playMedia(0); // play from the first track in the WMP playlist
                //chunkIndex = 0;
                //chunkIndex = Math.floor(playIndex / chunkSize);

                updatePlayList();
            }
        } else {
		alert('That selection does not contain a music file that the media player can use.');
        }
    }
    //dropPosition = 0;
}

//=====================
//End function
//=====================

//===========================================
// Functions that capture an external drag/drop event ONLY
//===========================================
function playListText11OnDragDrop(Sender,Data,Point)
{
  dropPosition = 11;
  catchFileDrop(Data);
}

function playListText10OnDragDrop(Sender,Data,Point)
{
  dropPosition = 10;
  catchFileDrop(Data);
}

function playListText9OnDragDrop(Sender,Data,Point)
{
  dropPosition = 9;
  catchFileDrop(Data);  
}

function playListText8OnDragDrop(Sender,Data,Point)
{
  dropPosition = 8;
  catchFileDrop(Data);
}

function playListText7OnDragDrop(Sender,Data,Point)
{
  dropPosition = 7;
  catchFileDrop(Data);
}

function playListText6OnDragDrop(Sender,Data,Point)
{
  dropPosition = 6;
  catchFileDrop(Data);
}

function playListText5OnDragDrop(Sender,Data,Point)
{
  dropPosition = 5;
  catchFileDrop(Data);
}

function playListText4OnDragDrop(Sender,Data,Point)
{
  dropPosition = 4;
  catchFileDrop(Data);
}

function playListText3OnDragDrop(Sender,Data,Point)
{
  dropPosition = 3;
  catchFileDrop(Data);
}

function playListText2OnDragDrop(Sender,Data,Point)
{
  dropPosition = 2;
  catchFileDrop(Data);
}

function playListText1OnDragDrop(Sender,Data,Point)
{
  dropPosition = 1;
  catchFileDrop(Data);
}

function playListText0OnDragDrop(Sender,Data,Point)
{
  dropPosition = 0;
  catchFileDrop(Data);
}
//=====================
//End function
//=====================

//===========================================
// Function that...
//===========================================
function preferencesPopupPanelFontOnMouseWheelDown(Sender)
{
      //dprint ("%-I-INFO, preferencesPopupPanelFontOnMouseWheelDown");     
       currentFontPos = currentFontPos + 1;
       if (currentFontPos >= fontArray.length ) {currentFontPos = fontArray.length};
       if (fontArray[currentFontPos] != null) {
        preferencesPopupPanelFont.text = fontArray[currentFontPos];
        preferencesPopupPanelFont.font.Family = preferencesPopupPanelFont.text;
       }
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function preferencesPopupPanelFontOnMouseWheelUp(Sender)
{
       currentFontPos = currentFontPos - 1;
       if (currentFontPos <=0 ) {currentFontPos = 0};
       if (fontArray[currentFontPos] != null) {
          preferencesPopupPanelFont.text = fontArray[currentFontPos];
          preferencesPopupPanelFont.font.Family = preferencesPopupPanelFont.text;
       }
}
//=====================
//End functions
//=====================

//===========================================
// Function that...
//===========================================
function preferencesPopupPanelFontOnKeyDown(Sender,Key,KeyChar,Shift)
{
  if (Key == 13) {
     button7OnMouseDown();
  };
}
//=====================
//End functions
//=====================



//==============================================================
// this function restricts the chosen folder from choosing the root
//==============================================================
function restrictRootFolder() {
    var a, volscnt;  
    var vols = filesystemVolumes();       //var vols = filesystem.volumes;
    
    //dprint (" drives = "+ drives);

    //count the drive volumes, create new images for each drive
    for (a in vols) {
        if (vols.hasOwnProperty(a)) {
            volscnt = Number(a);
            //nn =  vols[a].substr(0,2)  ;
	    dprint ("drives available "+vols[a].substr(0,2) );
            if (preferencesMusicFolderPrefValue.text == vols[a].substr(0,2)) {
		 dprint ("restricting access to the root");
        	 preferencesMusicFolderPrefValue.text = MyMusicPath; 
                 //"C:\\Users\\Public\\Music";
                 //C:\\Documents and Settings\\All Users\\Documents\\My Music";
            }
        }
    }
}
//=====================
//End function
//=====================





function widgetOnAppDeactivate()
{
    dprint ("App deactivated");
}

function widgetOnWidgetDeactivate()
{
    dprint ("widget deactivated");
}




//==============================================================
// this function is the ActiveX version of filesystem.volumes function;
//==============================================================
function filesystemVolumes() {
    var nobj, result, n, e, x;
    result = "";
    nobj = new ActiveXObject("Scripting.FileSystemObject");
    e = new Enumerator(nobj.Drives);
    for (; !e.atEnd(); e.moveNext()) {
        x = e.item();
        result = ''+result + x.DriveLetter+':';
        result += " - ";
        if (x.DriveType == 3) n = x.ShareName;
        else if (x.IsReady)
        n = x.VolumeName;
    else n = "(Not ready)"; result += n + "|";
  }
  // change the string to an array
  result = result.split("|");
  return(result);
}
//=====================
//End function
//=====================

//=====================
// the busy timer changes the busy icon
//=====================
function busyTimerOnUpdate(Sender)
{
       busy.visible = true;
       busyBlur.visible = true;
       busyCounter = busyCounter + 1 ;
       if (busyCounter >= 7) {busyCounter = 1};
       busy.src = "busy-F" + busyCounter + "-32x32x24.png";

}
//=====================
//End function
//=====================


//=================================
// Function to open a file
//=================================
function busyOnClick(Sender)
{
      busyStop();
}
//=================================
// end function
//=================================



//=================================
// Function to
//=================================
function tapOnMouseDown(Sender,Button,Shift,X,Y)
{
    dprint ("%-I-INFO, tap.onMouseDown");
    PlaySound(steamSound);
    if (preferencesHintsPrefValue.text == "enabled") {
          preferencesHintsPrefValue.text = "disabled";
    } else {
          preferencesHintsPrefValue.text = "enabled";      
    }
    settooltip();
}
//=================================
// end function
//=================================





//=================================
// Function to
//=================================
function widgetOnClose()
{   SavePrefs();
    dprint("************ Widget disconnecting WMPlayer.************");
    sliderTimer.enabled=false;
    positionTimer.enabled=false;
    WMPlayer = null;
    objShell = null;
    nobj = null;
    fso = null;
    CollectGarbage();  
}
//=================================
// end function
//=================================





//=================================
// Function to check the state of the ActiveX object
//=================================
function wmpCheckCoreOnUpdate(Sender)
{
   if (WMPlayer == null) {
     //  checking ActiveX access to the windows media player every 2 secs
     WMPlayer = new ActiveXObject("WMPlayer.OCX.7");
     dprint("************IMPORTANT Widget reconnected WMPlayer.************");
     //alert("IMPORTANT Widget reconnected WMPlayer.");
  }
}
//=================================
// end function
//=================================


//=================================
// Function to clear the tooltips
//=================================
function clearPlayListHints()
{
                playListTitle.hint =  "";
		playListText0.hint =  "";
		playListText1.hint =  "";
		playListText2.hint =  "";
		playListText3.hint =  "";
		playListText4.hint =  "";
		playListText5.hint =  "";
		playListText6.hint =  "";
		playListText7.hint =  "";
		playListText8.hint =  "";
		playListText9.hint =  "";
		playListText10.hint =  "";
		playListText11.hint =  "";
}
//=================================
// end function
//=================================





//======================================================================================
// END mediaPlayer.js
//======================================================================================



function code(e) {
    e = e || window.event;
    return(e.keyCode || e.which);
}





//======================================================================
// Function to check the volume level set by other tools, run by a timer
// this timer is a little slow as Xwidgets does not allow a timer less than 1 second in duration
//======================================================================
function checkTimerOnUpdate(Sender) {

 if (oldVol != WMPlayer.settings.volume) {

	sliderSet.left = (bar.left + 25  + (WMPlayer.settings.volume )) ;
        stretchCable();
	oldVol = WMPlayer.settings.volume;
        //buildVitality(currIcon, parseInt(playercontrolcore1.volume *6.25));    // build the dock vitality
 }
}
//=====================
//End function
//=====================



//==============================
// reload after sleep
//==============================
//widget.onWakeFromSleep = function () {
//	dprint("onWakeFromSleep");
//	reloadWidget();
//};


// timer to check sleep once a minute
// sets a value, check the value and if the difference is
// greater than three minutes then assume the PC has been
// asleep and restart the widget.
//==============================
// reload after sleep
//==============================
function sleepTimerOnUpdate(Sender)
{
    var theDate = new Date();
    secsDif = parseInt(theDate.getTime() / 1000, 10) - parseInt((savedTime) / 1000, 10);
    
    //dprint("secsDif "+secsDif);
    if (secsDif >= 60) {      // 1 mins pause causes a restart
        dprint("Running the sleep timer - the difference is an abnormal " + secsDif + " secs");
        //alert("Running the sleep timer - the difference is an abnormal " + secsDif + " secs");

        savedTime = new Date();
        sleepTimer.enabled = false;
        //widget.cmd("!Reload");   // does not work FFS
        widget.ForceToFround();
        wsc.SendKeys("{f5}");
        
    } else {
        //dprint("Running the sleep timer - the difference is " + secsDif + " secs");
        savedTime = new Date();
    }
}
//=====================
//End function
//=====================




//===================================
// function to install the font
//===================================
function installFont() {

  //var extPath = widget.extractFile( "Centurion Light SF.ttf" );

	if (confirm2("The widget cannot install the font as it does not have the privileges to do so. You will have to install it yourself by double clicking on it in Windows File Explorer, then clicking install. I will open that folder now. "))
        {
		var systemWidgetDataFolder = WidgetPath; 
                //"\\Program Files (x86)\\XWidget\\AppData\\Widgets\\xwidget steampunk mediaplayer xwidget\\resources";

                //xwidget steampunk mediaplayer xwidget";
                //+"/Centurion Light SF.ttf";
                if (folderExists(systemWidgetDataFolder) )   {
			open(systemWidgetDataFolder);
		}
        }

  /*
  // no longer works under Windows 7 and above for a normal user.
  var objShell = COM.createObject("Shell.Application");
  COM.connectObject(objShell, "SHE_");
  objFolder = objShell.Namespace(system.widgetDataFolder);
  objFolderItem = objFolder.ParseName("Centurion Light SF.ttf");
  objFolderItem.InvokeVerb("Install");
  */
};
//=====================
//End function
//=====================





//===================================
// functions group to make the deletion taps appear
//===================================
function deleteButton0OnMouseEnter(Sender,Button,Shift,X,Y) {
        // the trim is required as the playListText0 is padded with spaces
        if (trim(playListText0.text) != "") {
          deleteButton0.opacity = "1";
          deleteButton0.hint = "Click to delete track 0 - " + playListText0.text;
        } else {
          deleteButton0.hint = "";
        }
}
function deleteButton1OnMouseEnter(Sender)
{
        if (trim(playListText1.text) != "") {
          deleteButton1.opacity = "1";
          deleteButton1.hint = "Click to delete track 1 - " + playListText1.text;
        } else {
          deleteButton1.hint = "";
        }
}
function deleteButton2OnMouseEnter(Sender)
{
        if (trim(playListText2.text) != "") {
          deleteButton2.opacity = "1";
          deleteButton2.hint = "Click to delete track 2 - " + playListText2.text;
        } else {
          deleteButton2.hint = "";
        }
}
function deleteButton3OnMouseEnter(Sender)
{
        if (trim(playListText3.text) != "") {
          deleteButton3.opacity = "1";
          deleteButton3.hint = "Click to delete track 3 - " + playListText3.text;
        } else {
          deleteButton3.hint = "";
        }
}
function deleteButton4OnMouseEnter(Sender)
{
        if (trim(playListText4.text) != "") {
          deleteButton4.opacity = "1";
          deleteButton4.hint = "Click to delete track 4 - " + playListText4.text;
        } else {
          deleteButton4.hint = "";
        }
}
function deleteButton5OnMouseEnter(Sender)
{
        if (trim(playListText5.text) != "") {
          deleteButton5.opacity = "1";
          deleteButton5.hint = "Click to delete track 5 - " + playListText5.text;
        } else {
          deleteButton5.hint = "";
        }
}
function deleteButton6OnMouseEnter(Sender)
{
        if (trim(playListText6.text) != "") {
          deleteButton6.opacity = "1";
          deleteButton6.hint = "Click to delete track 6 - " + playListText6.text;
        } else {
          deleteButton6.hint = "";
        }
}
function deleteButton7OnMouseEnter(Sender)
{
        if (trim(playListText7.text) != "") {
          deleteButton7.opacity = "1";
          deleteButton7.hint = "Click to delete track 7 - " + playListText7.text;
        } else {
          deleteButton7.hint = "";
        }
}
function deleteButton8OnMouseEnter(Sender)
{
        if (trim(playListText8.text) != "") {
          deleteButton8.opacity = "1";
          deleteButton8.hint = "Click to delete track 8 - " + playListText8.text;
        } else {
          deleteButton8.hint = "";
        }
}
function deleteButton9OnMouseEnter(Sender)
{
        if (trim(playListText9.text) != "") {
          deleteButton9.opacity = "1";
          deleteButton9.hint = "Click to delete track 9 - " + playListText9.text;
        } else {
          deleteButton9.hint = "";
        }
}
function deleteButton10OnMouseEnter(Sender)
{
        if (trim(playListText10.text) != "") {
          deleteButton10.opacity = "1";
          deleteButton10.hint = "Click to delete track 10 - " + playListText10.text;
        } else {
          deleteButton10.hint = "";
        }
}
function deleteButton11OnMouseEnter(Sender)
{
        if (trim(playListText11.text) != "") {
          deleteButton11.opacity = "1";
          deleteButton11.hint = "Click to delete track 11 - " + playListText11.text;
        } else {
          deleteButton11.hint = "";
        }
}
//=====================
//End functions group
//=====================






//===================================
// functions group to make the deletion taps disappear
//===================================

function deleteButton0OnMouseLeave(Sender)
{
          deleteButton0.opacity="0.01";
}
function deleteButton1OnMouseLeave(Sender)
{
          deleteButton1.opacity="0.01";
}
function deleteButton2OnMouseLeave(Sender)
{
          deleteButton2.opacity="0.01";
}
function deleteButton3OnMouseLeave(Sender)
{
          deleteButton3.opacity="0.01";
}
function deleteButton4OnMouseLeave(Sender)
{
          deleteButton4.opacity="0.01";
}
function deleteButton5OnMouseLeave(Sender)
{
          deleteButton5.opacity="0.01";
}
function deleteButton6OnMouseLeave(Sender)
{
          deleteButton6.opacity="0.01";
}
function deleteButton7OnMouseLeave(Sender)
{
          deleteButton7.opacity="0.01";
}

function deleteButton8OnMouseLeave(Sender)
{
          deleteButton8.opacity="0.01";
}
function deleteButton9OnMouseLeave(Sender)
{
          deleteButton9.opacity="0.01";
}

function deleteButton10OnMouseLeave(Sender)
{
          deleteButton10.opacity="0.01";
}
function deleteButton11OnMouseLeave(Sender)
{
          deleteButton11.opacity="0.01";
}
//=====================
//End functions group
//=====================


//=====================
// these functions
//=====================
function deleteButton0OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 0;
            if (trim(playListText0.text) != "") {
               if (confirm2("Removing this track from the playlist " + playListText0.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
               {
                  deleteTrack (trackNoToDelete);
               }
            }
}
function deleteButton1OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 1;
            if (trim(playListText1.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText1.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton2OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 2;
            if (trim(playListText2.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText2.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton3OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 3;
            if (trim(playListText3.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText3.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton4OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 4;
            if (trim(playListText4.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText4.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton5OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 5;
            if (trim(playListText5.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText5.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton6OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 6;
            if (trim(playListText6.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText6.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton7OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 7;
            if (trim(playListText7.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText6.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton8OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 8;
            if (trim(playListText8.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText8.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton9OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete = 9;
            if (trim(playListText9.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText9.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton10OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete =10;
            if (trim(playListText10.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText10.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
function deleteButton11OnMouseDown(Sender,Button,Shift,X,Y)
{
            trackNoToDelete =11;
            if (trim(playListText11.text) != "") {
              if (confirm2("Removing this track from the playlist " + playListText11.text + String.fromCharCode(13) + String.fromCharCode(13) + " Are you sure?  "))
              {
                deleteTrack (trackNoToDelete);
              }
            }
}
//=================================
// end functions
//=================================



//===================================
// function to delete a selected track
//===================================
function deleteTrack(trackNoToDelete) {
 dprint("%deleteTrack trackNoToDelete "+trackNoToDelete);
    // modify the drop position to take into account the page number
    trackNoToDelete = trackNoToDelete + (12 * chunkIndex);

    idxFile = trackNoToDelete ;

    // create a new playlist the current size but with the element removed
    newPlayListSize = thePlayList.length - 1;
    var denudedPlayList = new Array(newPlayListSize);

//dprint("%deleteTrack newPlayListSize "+newPlayListSize);

    // copy all the old elements to the new playlist up to the point where the deletion has occurred - trackNoToDelete
    for(var i = 0; i < trackNoToDelete; i++) {   // loop from 0 to the drop point
            denudedPlayList[i] = thePlayList[i];
	    //dprint("*********** 1 denudedPlayList[" + i + "] " + denudedPlayList[i].sourceURL);
    }
			    // copy the rest of the old elements to the new playlist after the new items have been dropped
    j = trackNoToDelete+1;
    for(var i = trackNoToDelete ; i <= newPlayListSize; i++) {
            if (thePlayList[i]!= null) {
               denudedPlayList[i] = thePlayList[j];
               //denudedPlayList[i] = "";
               j=j+1;
               if ( j <10 ) {
                  //dprint("*********** 2 denudedPlayList[" + i + "] " +denudedPlayList[i].sourceURL);
               }
            };
    }

    //dprint("*********** playListfileCount " +playListfileCount);
    playListfileCount = newPlayListSize;
	//dprint("5>>>>>>>>>>>>>>Filesystem recursive search file count " +playListfileCount);

                            //add to the final play list
    			    for(var i = 0 ; i <= newPlayListSize; i++) {
    			        if (denudedPlayList[i]!= null) {
                                       thePlayList[i] = denudedPlayList[i];
                                       //dprint("*********** 4 thePlayList[i] " +thePlayList[i].sourceURL);
                                };
    			    }

                            dprint ("Playmedia Call no. 8");
    			    playMedia(0); // play from the first track in the WMP playlist
    			    updatePlayList();


}
//=====================
//End function
//=====================       


//=======================
// bottom key face toggle
//=======================
function buttonConfigOnMouseDown(Sender,Button,Shift,X,Y)
{
    PlaySound(lock);
    if ( preferencesPlayListKeysPrefValue.text === "fade" ) {
           preferencesPlayListKeysPrefValue.text = "solid";
           fadeTimer.enabled = false;
    } else {
           preferencesPlayListKeysPrefValue.text = "fade";
           fadeTimer.enabled = true;
    }

}

//=====================
//End function
//=====================



//============================================
// function to conditionally print diagnostics
//============================================
function dprint(s) {
	if (debugFlg === "1") {
		print(s);
	}
	//dprint(s);
}
//=====================
//End function
//=====================




//============================================
// xwidget does not like .indexOf as per YWE we use validate_filetype function instead
//============================================        
function validate_filetype(fileName,validSuffixes)
{     
    // validTypes is now a string and not an array
    var allowed_extensions = validSuffixes.split(','); // split function will make an array from a string
    file_extension = fileName.split('.').pop(); // split function will split the filename by dot(.), and pop function will pop the last element from the array which will give you the extension as well. If there will be no extension then it will return the filename.

    for(var i = 0; i < allowed_extensions.length; i++)
    {
        dprint("allowed_extensions[i] "+ allowed_extensions[i]);
        if(allowed_extensions[i]==file_extension.toLowerCase())
        {
            dprint("return true");
            return true; // valid file extension
        }
    }
                //dprint("return false");
    return false;
}
//=====================
//End function
//=====================

//=========================================================================
// this function opens the about us image
//=========================================================================
function menuitem9OnClick() {

         windowPos = widget.WindowZPosition;

         //aboutUs.visible = true; // no  longer required
         // this does not work as specified in the auto complete help but is need to counter the fade out.
         aboutUs.FadeToVisible(50,3);  // the alpha is ignored as is the duration

         //aboutUs.FadeTo(100,1); // this does not actually work but is need to counter the fade out.
         // it would be nice if this worked but it only displays the layer within the widget's
         // boundaries
         //aboutUs.left= (ScreenWidth /2) - aboutUsImage.Width;
         aboutUs.top = (ScreenHeight /2) - aboutUsImage.Height;
         widget.WindowZPosition=0;

}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function menuitem26OnClick(Sender)
{
    	 /*windowPos = widget.WindowZPosition;
         helpImage.visible = true;
         widget.WindowZPosition=1;
         if (preferencesSoundprefValue.text === "enabled") {
		PlaySound(lock);
	 }
	 */
	helpScreen(); 
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function autoPlayLugEnabledOnMouseUp(Sender,Button,Shift,X,Y)
{
  toggleAutoPlay();
}



//===================================
// function to toggle the auto play state
//===================================
function toggleAutoPlay() {
    if (preferencesAutoPlayStatePrefValue.text === "disabled") {
        autoPlayLug.visible = false;
        autoPlayLugEnabled.visible = true;
        preferencesAutoPlayStatePrefValue.text = "enabled";
    } else {
        autoPlayLug.visible = true;
        autoPlayLugEnabled.visible = false;
        preferencesAutoPlayStatePrefValue.text = "disabled";
    }

    if (preferencesSoundprefValue.text === "enabled") {
        playSound(lock);
    }
}
//=====================
//End function
//=====================

 

//=================================
// Function to select the plain playlist area
//=================================
function playListTapOnMouseDown(Sender,Button,Shift,X,Y)
{
    dprint ("%-I-INFO, playListTap.onMouseDown");
    PlaySound(steamSound);
    dprint("playlistArea "+ playlistArea.src);
    if (preferencesPlaylistFormatPrefValue.text === "xml") {
          preferencesPlaylistFormatPrefValue.text = "xspf";
            oButton.hint = "Open an XSPF formatted playlist.";
            sButton.hint = "Save a playlist in XSPF format.";
            sButton.opacity = .01;
            oButton.opacity = .01;
            playListTap.hint = "Click to change the playlist format to XML.";
    } else {
          preferencesPlaylistFormatPrefValue.text = "xml";
            oButton.hint = "Open an XML formatted playlist.";
            sButton.hint = "Save a playlist in XML format.";
            sButton.opacity = 1;
            oButton.opacity = 1;
            playListTap.hint = "Click to change the playlist format to XSPF.";
    }
    dprint("playlistFormatPref "+ preferencesPlaylistFormatPrefValue.text);
}
//=================================
// end function
//=================================


//=================================
// Function to search for tracks
//=================================
function ovalButtonOnMouseDown(Sender,Button,Shift,X,Y){
    if (preferencesSoundprefValue.text === "enabled") {
       PlaySound(winding);
    }
    trackSearchLayer.visible = true;
    keytimer.enabled = false;
    //     searchForTrack(); // this is now called within the trackSearchLayer
};
//=================================
// end function
//=================================



//===================================
// function to search for a particular track name
//===================================
function searchForTrack() {
    // CTRL+F to search
    // loop through the tracknames as displayed in the playlist
    var trackExtracted, stringPosition, res, i;
    
    res = searchText.text;
    if ((res === null) || (res === "")) {
        return;
    }
    
    //mainWindow.focus();
    searchString = res;
    searchStringPosition = 0;
    searchString = searchString.toLowerCase();

    //dprint("searchString: " + searchString);
    dprint("playListfileCount: " + playListfileCount);

    for (i = 0; i < playListfileCount; i += 1) {
        trackExtracted = getFileOnly(thePlayList[i].sourceURL);
        trackExtracted = trackExtracted.toLowerCase();
        stringPosition = trackExtracted.lastIndexOf(searchString);
        if (stringPosition >= 0) {
            //dprint("trackExtracted: " + trackExtracted);
            //dprint("stringPosition: " + stringPosition);
            playIndex = i;
            searchStringPosition = i;
            chunkIndex = Math.floor(playIndex / chunkSize);
            updatePlayList();
            busyStop();    // stops any busy timer that may be running when each track is selected
            //playMedia(playIndex);       dean - this needs to be fixed
            return;
        }
        searchStringPosition = 0;
    }
    if (searchStringPosition === 0) {
        alert("There are no occurrences of " + searchString + " in your current playlist, " + String.fromCharCode(13) + "press CTRL+F to perform a new search.");
        //mainWindow.focus();
    }
}
//=====================
//End function
//=====================


//===================================
// function to search for a particular track name
//===================================
function searchSameTrack() {
    // F3 to search
    // loop through the tracknames as displayed in the playlist
    // uses searchString and searchStringPosition to continue the search
    var trackExtracted, stringPosition, i;

    if ((searchString === null) || (searchString === "")) {
        return;
    }
    for (i = searchStringPosition + 1; i < playListfileCount; i += 1) {
        trackExtracted = getFileOnly(thePlayList[i].sourceURL);
        trackExtracted = trackExtracted.toLowerCase();
        stringPosition = trackExtracted.lastIndexOf(searchString);
        if (stringPosition >= 0) {
            //dprint("trackExtracted: " + trackExtracted);
            //dprint("stringPosition: " + stringPosition);
            playIndex = i;
            searchStringPosition = i;
            chunkIndex = Math.floor(playIndex / chunkSize);
            updatePlayList();
            busyStop();    // stops any busy timer that may be running when each track is selected
            //playMedia(playIndex);       dean - this needs to be fixed
            return;
        }
        searchStringPosition = 0;
    }
    if (searchStringPosition === 0) {
        alert("There are no more occurrences of " + searchString + String.fromCharCode(13) + " in your current playlist, press F3 to search from the top or CTRL+F to perform a new search.");
        //widget.ForceToFround();
        //attempt to cause the widget to gain focus - non functional
    }
}
//=====================
//End function
//=====================



//===================================
// function to trigger a search and close the window
//===================================
function searchbuttonOnMouseUp(Sender,Button,Shift,X,Y)
{
      trackSearchLayer.visible = false;
      searchForTrack();
      keytimer.enabled = true; // to allow the keys to be intercepted again
}
//=====================
//End function
//=====================


//===================================
// function to cancel the search
//===================================
function trackSearchCancelButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
    trackSearchLayer.visible = false;
      keytimer.enabled = true; // to allow the keys to be intercepted again
}
//=====================
//End function
//=====================


//===================================
// function to cancel the search
//===================================
function xButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
    trackSearchLayer.visible = false;
      keytimer.enabled = true; // to allow the keys to be intercepted again
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keydOnMouseDown(Sender,Button,Shift,X,Y)
{
  openFolderToPlay();
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keydOnMouseEnter(Sender)
{
    if (preferencesSoundprefValue.text === "enabled") {
        playSound(slidingClunk);
    }
    keyd.src = "keydHovered.png";
    dragDropFlg = 0; // cancelling the drag/dtop flag anywhere I can
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keydOnMouseLeave(Sender)
{
      keyd.src = "keyd.png";
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keyfOnMouseDown(Sender,Button,Shift,X,Y)
{
      addSingleTrack("local");
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keyfOnMouseEnter(Sender)
{
    if (preferencesSoundprefValue.text === "enabled") {
        playSound(slidingClunk);
    }
    keyf.src = "keyfHovered.png";
    dragDropFlg = 0; // cancelling the drag/dtop flag anywhere I can

}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keyfOnMouseLeave(Sender)
{
      keyf.src = "keyf.png";

}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keyFullScreenOnMouseUp(Sender,Button,Shift,X,Y)
{
    if (preferencesFullscreenPrefValue.text === "1") {
        preferencesFullscreenPrefValue.text = "0";
        fullScreenPrefDisplay.text = "disabled";
        keyFullScreen.hint = "external player full screen mode is disabled";
        keyFullScreen.src = "indicatorRod.png";
    } else {
        preferencesFullscreenPrefValue.text = "1";
        fullScreenPrefDisplay.text = "enabled";
        keyFullScreen.hint = "pulled out - external player full screen mode is enabled";
        keyFullScreen.src = "indicatorRodOut.png";
    }
    if (preferencesSoundprefValue.text === "enabled") {
        playSound(steamSound);
    }
    if (preferencesHintsPrefValue.text !== "enabled") {
        keyFullScreen.hint = "";
    }
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function keyViewScreenOnMouseUp(Sender,Button,Shift,X,Y)
{
        dprint("pressed ");
        if (preferencesWmpAllowPrefValue.text === "1") {
            preferencesWmpAllowPrefValue.text = "0";
            WmpAllowPrefDisplay.text = "disabled";
            keyViewScreen.src = "indicatorRod.png";
            keyViewScreen.hint = "external player is disabled";
            dprint("keyViewScreen.src " + keyViewScreen.src);     // this keeps reporting undefined
        } else {
            preferencesWmpAllowPrefValue.text = "1";
            WmpAllowPrefDisplay.text = "enabled";
            keyViewScreen.src = "indicatorRodOut.png";
            keyViewScreen.hint = "pulled out - external player is enabled";
            dprint("keyViewScreen.src " + keyViewScreen.src);      // this keeps reporting undefined
        }
        dprint("preferencesWmpAllowPrefValue.text " + preferencesWmpAllowPrefValue.text);

        wmpAllowApp = parseFloat(preferencesWmpAllowPrefValue.text);
    if (preferencesSoundprefValue.text === "enabled") {
        playSound(steamSound);
    }
    if (preferencesHintsPrefValue.text !== "enabled") {
        keyViewScreen.hint = "";
    }
  
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function menuitem27OnClick(Sender)
{
          OpenMediaLocation();
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function menuitem28OnClick(Sender)
{
    trackSearchLayer.visible = true;
    keytimer.enabled = false;
    //     searchForTrack(); // this is now called within the trackSearchLayer
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function menuitem30OnClick(Sender)
{
  facebookChat();
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function mediaPlaylistHelpOnClick(Sender)
{
         helpLayer2.visible = false;
         if (preferencesSoundprefValue.text === "enabled") {
                PlaySound(lock);
         }
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function textLinktoHelp1OnMouseDown(Sender,Button,Shift,X,Y)
{
        if (preferencesSoundprefValue.text === "enabled") {
                PlaySound(steamSound);
        }
        helpLayer1.visible = false;
  	helpLayer2.visible = true;
}
//=================================
// end function
//=================================

//=====================
// this function
//=====================
function textLinktoHelp2OnMouseDown(Sender,Button,Shift,X,Y)
{
        if (preferencesSoundprefValue.text === "enabled") {
                PlaySound(steamSound);
        }
  	helpLayer1.visible = true;
  	helpLayer2.visible = false;  	
}
//=================================
// end function
//=================================

//=====================
// the busy timer changes the busy icon on startup
//=====================
function busyIconStartupTimerOnUpdate(Sender)
{
    mediapopupplaque.visible = true;
    busyTimer.enabled = true;
    startupTimeout = startupTimeout + 1;
    //dprint("startupTimeout " + startupTimeout);
    if (startupTimeout >= 35) {
        busyStop();
        busyIconStartupTimer.enabled = false;
        mediapopupplaque.visible = false;
    }  
}
//=================================
// end function
//=================================


//============================================
// function to
//============================================
function videoIconOnClick(Sender)
{
    fontPreferences.visible = false;
    musicPreferences.visible = false;
    commandsPreferences.visible = false;
    configPreferences.visible = false;
    soundPreferences.visible = false;
    videoPreferences.visible = true;

    videoSquare.visible = true;
    fontSquare.visible = false;
    musicSquare.visible = false;
    commandSquare.visible = false;
    configSquare.visible = false;
    soundSquare.visible = false;
}
//=================================
// end function
//=================================



//============================================
// function to
//============================================
function fullScreenButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
  keyFullScreenOnMouseUp();
  /*
  if (preferencesFullscreenPrefValue.text === "1") {
     fullScreenPrefDisplay.text = "disabled";
     preferencesFullscreenPrefValue.text = "0";
  } else {
     fullScreenPrefDisplay.text = "enabled";
     preferencesFullscreenPrefValue.text = "1";
  }
  */
}
//=================================
// end function
//=================================


//============================================
// function to
//============================================
function externalPlayerButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
  keyViewScreenOnMouseUp();

  /*
  if (preferencesWmpAllowPrefValue.text === "1") {
     WmpAllowPrefDisplay.text = "disabled";
     preferencesWmpAllowPrefValue.text = "0";
  } else {
     WmpAllowPrefDisplay.text = "enabled";
     preferencesWmpAllowPrefValue.text = "1";
  }
  */
}
//=================================
// end function
//=================================


//=================================
// Function to
//=================================
function WMPLocateButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
          var validSuffix = ".exe";
          var WMPfilename;
          WMPfilename = openFileDialog("");
          if ( WMPfilename == null ) {
             return;
          }

          if (validSuffix.indexOf(xtn(WMPfilename)) === -1) {
             return;
          }
          preferencesWMPApplicationPrefValue.text = WMPfilename;
}
//=================================
// end function
//=================================


//=================================
// Function to check the fullScreen value and set the toggle
//=================================
function checkFullScreen() {
  if (preferencesFullscreenPrefValue.text === "1") {
        keyFullScreen.hint = "pulled out - external video full screen mode is enabled";
        keyFullScreen.src = "indicatorRodOut.png";
        fullScreenPrefDisplay.text = "enabled";
    } else {
        keyFullScreen.hint = "external video full screen mode is disabled";
        keyFullScreen.src = "indicatorRod.png";
        fullScreenPrefDisplay.text = "disabled";
    }
    if (preferencesSoundprefValue.text === "enabled") {
        playSound(steamSound);
    }
    if (preferencesHintsPrefValue.text !== "enabled") {
        keyFullScreen.hint = "";
    }
}
//=================================
// end function
//=================================

//=================================
// Function to check the keyViewScreen value and set the toggle
//=================================
function checkViewScreen() {
    if (preferencesWmpAllowPrefValue.text === "1") {
        keyViewScreen.hint = "pulled out - external video is enabled";
        keyViewScreen.src = "indicatorRodOut.png";
        WmpAllowPrefDisplay.text = "enabled";
    } else {
        keyViewScreen.hint = "external video is disabled";
        keyViewScreen.src = "indicatorRod.png";
        WmpAllowPrefDisplay.text = "disabled";
    }
    wmpAllowApp = parseFloat(preferencesWmpAllowPrefValue.text);

    if (preferencesSoundprefValue.text === "enabled") {
        playSound(steamSound);
    }
    if (preferencesHintsPrefValue.text  !== "enabled") {
        keyViewScreen.hint = "";
    }
}
//=================================
// end function
//=================================



//=====================================
// function to play audio or video file
//=====================================
function masterPlay() {
        var video = false;

        if (validate_filetype(WMPlayer.URL,videoTypes) === true ) {
            video = true;
        }
        var fullscreen = (preferencesFullscreenPrefValue.text === "1");
        // on Windows even though wmpAllowApp was zero it was still causing the external player to run
        // this is probably due to    === "1"
        if ((video && wmpAllowApp ) || (ctrlPressed === 1)) {
            dprint("video "+video );
            dprint("wmpAllowApp "+wmpAllowApp );
            dprint("preferences.wmpAllowPref.value "+preferencesWmpAllowPrefValue.text );
            dprint("ctrlPressed "+ ctrlPressed);
            ctrlPressed = 0;
            pauseTimer.enabled = true;              // press the pause button    dean
            playInWMPApp(WMPlayer.URL, fullscreen); // play in WMP App
        } else {
            WMPlayer.controls.play();
        }
}
//=====================
//End function
//=====================


//=================================================================
// these functions are used to run a video file in the WMPlayer App
//=================================================================
var openFileInApplicationResult = "";

openFileInApplication = function (file, application, params) {
    function esc(path) {
        return path.replace(/([\W])/g, "\\$1");
    }
function quotePath(path) {
	//return "\"" + convertPathToPlatform(path).replace(/\"/g, "\\\"") + "\"";   //nyi
	return "\"" + path.replace(/\"/g, "\\\"") + "\"";
}
    var command;
    var result;

    if (application) {
        dprint("opening file " + file + " in application " + application);
            if (params) {
                dprint("params: " + params);
                params = " " + params;
            } else {
                params = "";
            }
            command = quotePath(application) + " " + quotePath(file) + params;
        dprint("openFileInApplication:command " + command);
        //runCommandInBg(command, "openFileInApplicationResult");
    //var command = quotePath(preferencesWMPApplicationPrefValue.text) + " " + quotePath(file) + params;
        run (command);

    } else {
        dprint("opening file " + file + " in default application");
        //result = filesystem.open(file);
        result = (result)
            ? "OK"
            : "Failed";
        dprint("openFileInApplication:result: " + result);
    }
};
//=====================
//End functions
//=====================



//=====================================
// function to play video file
//=====================================
function playInWMPApp(file, fullscreen) {
    var params = "";
    var command = "";

    if (fullscreen) {
        params = "/fullscreen";
    }

    openFileInApplication(file, preferencesWMPApplicationPrefValue.text, params);

    //var command = quotePath(preferencesWMPApplicationPrefValue.text) + " " + quotePath(file) + params;
    //run (command);
}
//=====================
//End functions
//=====================


//=====================
// Function for
//=====================
function pauseTimerOnUpdate(Sender)
{
    pauseTimer.enabled = false;
    startupFlg = 0;     // same as pauseButton.onMouseUp()
    pauseTrack();
    playButton.visible = true;
    pauseButton.visible = false;
    //buildVitality(currIcon, parseInt(percentTextShadow.text, 10), WMPlayer.settings.mute); // build the dock vitality
}
//=====================
//End functions
//=====================


//=====================
// Function to do a local drop ONLY
//=====================
function playListTextOnMouseUp() {
     var deletePosition;
     dprint("1 dragDropFlg " + dragDropFlg);
     //dprint("trackClickedFlg " + trackClickedFlg);

     if (trackClickedFlg === 1 && (dragPosition === dropPosition)) {
          dragDropFlg = 0;
     }

       if (dragPosition != dropPosition) {
           if (dragDropFlg === 1 && trackClickedFlg === 1) {  // this is instead of a drag indicator as the drag event always occurs
                //dprint("%-I-INFO, >>>>>>>>>>>>>>>>>> DROPPING to dragPosition " + dragPosition);
                if (dragPosition > dropPosition) {  // dragging upward
                    deletePosition = dragPosition + 1; // takes it in absolute value and calculates the relative position itself
                } else {  // dragging downward
                    deletePosition = dragPosition;
                    dropPosition = dropPosition; // this allows the track to be dropped at the expected track location
                }
                // use current catch drop to drag to new position using details supplied
                catchFileDrop(fullTrackNameToDrop);  // we calculate it ourselves here
                //deleteTrack(deletePosition);  // use current track deletion routine to delete the old track from the play list

                trackClickedFlg = 0;
                dragDropFlg = 0;       // cancel the internal drop
            }
       }
       
       dragDropFlg = 0;       // cancel the internal drop
       dprint("2 dragDropFlg " + dragDropFlg);
       //highlightPlayingTrack();

}
//=====================
//End function
//=====================


//=====================
// Functions to do a local drop using mouseUp
//=====================
function playListText0OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText1OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText2OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText3OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText4OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText5OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText6OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText7OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText8OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText9OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText10OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
function playListText11OnMouseUp(Sender,Data,Point)
{
  playListTextOnMouseUp();
}
//=====================
//End functions
//=====================



//=====================
//cancelling the drag/drop flag anywhere I can
//=====================
function keyViewScreenOnMouseEnter(Sender)
{
        dragDropFlg = 0;

}
//=====================
//End function
//=====================


//=====================
//cancelling the drag/drop flag anywhere I can
//=====================
function keyFullScreenOnMouseEnter(Sender)
{
        dragDropFlg = 0;
}
//=====================
//End functions
//=====================


//=====================
// this function
//=====================
function keyuOnMouseEnter(Sender)
{
     if (preferencesSoundprefValue.text === "enabled") {
        playSound(slidingClunk);
    }
    keyu.src = "keyuHovered.png";
    dragDropFlg = 0; // cancelling the drag/dtop flag anywhere I can

}
//=================================
// end function
//=================================


//=====================
// this function
//=====================
function keyuOnMouseLeave(Sender)
{
        keyu.src = "keyu.png";
}
//=================================
// end function
//=================================
                          

//=====================
// this function
//=====================
function keyuOnMouseDown(Sender,Button,Shift,X,Y)
{
  urlEntryForm.visible = true;
  keytimer.enabled = false; // to stop the widget from intercepting ctrl keypresses

}
//=================================
// end function
//=================================



//===============================================================
// this function catches ctrl+x
//===============================================================
function cutTrack() {
    //dprint("dragPosition "+ dragPosition);
    dprint("cutting " + fullTrackName[dragPosition + (chunkSize * chunkIndex)]);
    savFullTrackName = fullTrackName[dragPosition + (chunkSize * chunkIndex)];
    deleteTrack(dragPosition);
}
//=====================
//End function
//=====================


//===============================================================
// this function catches ctrl+c
//===============================================================
function copyTrack() {
    //dprint("dragPosition "+ dragPosition);
    dprint("copying " + fullTrackName[dragPosition + (chunkSize * chunkIndex)]);
    savFullTrackName = fullTrackName[dragPosition + (chunkSize * chunkIndex)];
}
//=====================
//End function
//=====================


//===============================================================
// this function catches ctrl+v
//===============================================================
function pasteTrack() {
    dprint("chunkSize "+ chunkSize);
    dprint("chunkIndex "+ chunkIndex);
    dprint("pasteing " + savFullTrackName);
    // we calculate it ourselves here
    catchFileDrop(savFullTrackName);
}
//=====================
//End function
//=====================


//=====================
//URL form functions for the URL buttons on the URL form
//=====================
function URLxButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
  urlEntryForm.visible = false;
  keytimer.enabled = true; // to allow the keys to be intercepted again
}
//=====================
//End function
//=====================

//=====================
//URL form functions to
//=====================
function URLSearchCancelButtonOnMouseUp(Sender,Button,Shift,X,Y)
{
    if (preferencesSoundprefValue.text === "enabled") {
       PlaySound(winding);
    }
  urlEntryForm.visible = false;
  keytimer.enabled = true; // to allow the keys to be intercepted again
}
//=====================
//End function
//=====================

//=====================
//URL form functions to
//=====================
function URLbuttonOnMouseUp(Sender,Button,Shift,X,Y)
{
      //http://www.kozco.com/tech/piano2.wav
      keytimer.enabled = true; // to allow the keys to be intercepted again
      urlEntryForm.visible = false;
      busyTimer.enabled = true;
      addSingleTrack("url");
}
//=====================
//End function
//=====================

//=====================
//Preference functions to
//=====================
function buttonPlaylistOnClick(Sender)
{
          if (preferencesMouseWheelScrollingPrefValue.text == "up" ) {
               preferencesMouseWheelScrollingPrefValue.text = "down" ;
        } else {
               preferencesMouseWheelScrollingPrefValue.text = "up"  ;
        }
}
//=====================
//End function
//=====================

//=====================
//Preference functions to
//=====================
function buttonPlayListKeysOnClick(Sender)
{
        if (preferencesPlayListKeysPrefValue.text == "fade" ) {
               preferencesPlayListKeysPrefValue.text = "solid" ;
               fadeTimer.enabled = false;
        } else {
               preferencesPlayListKeysPrefValue.text = "fade"  ;
               fadeTimer.enabled = true;
        }
}
//=====================
//End function
//=====================


//=====================
//URL form functions to
//=====================
function URLsearchTextOnKeyDown(Sender,Key,KeyChar,Shift)
{
  dprint("Key " + Key);
  dprint("KeyChar " + KeyChar);
  if (Key === 13) {
        URLbuttonOnMouseUp();
  } 
}
//=====================
//End function
//=====================

//===================================
// function to slide the volume slider
//===================================
function pipesOnMouseDown(Sender,Button,Shift,X,Y) {

};
//=====================
//End function
//=====================





//===========================================
// YWE function split to resize using mousewheel UP + CTRL key as per Firefox
//===========================================
function volumeDeviceOnMouseWheelUp(Sender,Key,KeyChar,Shift)
{
 if (ctrlPressed === 1) {
   //dprint("here!");
         Scale = Number(preferencessizePrefvalue.percent);
         size = Scale;
         step = Math.round((maxLength - minLength) / (ticks - 1));
	        if ( preferencesMouseWheelResizingPrefValue.text == "up" ) {
                   size -= step;
	           if (size > maxLength) {
	              size = maxLength;
	           }
                } else {
                   size += step;
                   if (size < minLength) {
	               size = minLength;
                   }
                 }

     //volumeDevice.scaleto(size/100,size/100,0.0000000001,"topleft");
     Scale = size;
     preferencessizePrefvalue.percent = Scale ;
     resize();
 }else{
      sliderSetOnMouseWheelUp(Sender)
 }
}
//=====================
//End function
//=====================

//===========================================
// YWE function split to resize using mousewheel DOWN + CTRL key as per Firefox
//===========================================
function volumeDeviceOnMouseWheelDown(Sender,Key,KeyChar,Shift)
{
 if (ctrlPressed === 1) {
         //dprint("here!");
         Scale = Number(preferencessizePrefvalue.percent);
         size = Scale;
         step = Math.round((maxLength - minLength) / (ticks - 1));
	        if ( preferencesMouseWheelResizingPrefValue.text == "up" ) {
                   size += step;
                   if (size < minLength) {
	               size = minLength;
                   }
                } else {
                   size -= step;
	           if (size > maxLength) {
	              size = maxLength;
	           }
                }

     //volumeDevice.scaleto(size/100,size/100,0.0000000001,"topleft");
     //Scale = size;
     //preferencessizePrefvalue.percent = Scale ;
     Scale = size;
     preferencessizePrefvalue.percent = Scale ;
     resize();
 }else{
      sliderSetOnMouseWheelDown(Sender)
 }
}
//=====================
//End function
//=====================





//=====================
//Preference function to toggle the autoplay state
//=====================
function ATSButtonOnMouseDown(Sender,Button,Shift,X,Y)
{
  toggleAutoPlay();
  /*
        if (preferencesAutoPlayStatePrefValue.text === "enabled" ) {
               preferencesAutoPlayStatePrefValue.text = "disabled" ;
        } else {
               preferencesAutoPlayStatePrefValue.text = "enabled"  ;
        }
  */
}
//=====================
//End function
//=====================




function playListPageOnMouseEnter(Sender)
{
  playListPageBright.visible = true;
}

function playListPageOnMouseLeave(Sender)
{
    playListPageBright.visible = false;
}

//=================================
// timer to fade the buttons
//=================================
function fadeTimerOnUpdate(Sender)
{
    nextChunk.opacity = nextChunk.opacity - 0.01;
    prevChunk.opacity = nextChunk.opacity - 0.01;
    firstChunk.opacity = nextChunk.opacity - 0.01;
    lastChunk.opacity = nextChunk.opacity - 0.01;
    buttonConfig.opacity = buttonConfig.opacity - 0.01;
    keyu.opacity = keyu.opacity - 0.01;
    keyf.opacity = keyf.opacity - 0.01;
    keyd.opacity = keyd.opacity - 0.01;
    if (preferencesPlaylistFormatPrefValue.text === "xml") {
        oButton.opacity = oButton.opacity - 0.01;
        sButton.opacity = sButton.opacity - 0.01;
    }
    ovalButton.opacity = ovalButton.opacity - 0.01;
    if (nextChunk.opacity <= 0) {
        fadeTimer.enabled = false;
    }
    keyViewScreen.opacity = keyViewScreen.opacity - 0.01;
    keyFullScreen.opacity = keyFullScreen.opacity - 0.01;
    bracket.opacity = bracket.opacity - 0.01;
}
//=====================
//End function
//=====================

//===============================================================
// this function slides the knob to clear the playlist
//===============================================================
function playListSliderOnMouseDown(Sender,Button,Shift,X,Y)
{
    playlistSliderClicked = true;
    pdx = X;
    pdy = Y;    
}

//=====================
//End function
//=====================

//===========================================
// Function to slide the playlist slider - emulates the onMouseDrag function
//===========================================
function playListSlideronMouseMove(Sender,Shift,X,Y,Dx,Dy) {
  if(playlistSliderClicked === true)
  {
    Sender.top = Sender.top + Y - pdy;
    if (Sender.top >= 200) { //568
        playListSlider.top = 200;
        playlistSliderDragged = true;
        playListSliderOnMouseUp();
    }
    if (Sender.top <= 16) { //262
        playListSlider.top = 16;
    }
  }
}
//=====================
//End function
//=====================


//===========================================
// Function to try to keep the playlist slider in synch with the cursor
//===========================================
function playListSliderOnMouseLeave(Sender,Shift,X,Y,Dx,Dy)
{
  if(playlistSliderClicked === true)
  {
    Sender.top = Sender.top + Y - pdy;
  }
}
//=====================
//End function
//=====================


//=====================
// this function
//=====================
function playListSliderOnMouseUp(Sender,Button,Shift,X,Y)
{
  playListSlider.top = 16 ;
  playlistSliderClicked = false;
  if (preferencesSoundprefValue.text === "enabled") {
      playSound(lock);
  }
  if (playlistSliderDragged === true ) {
	if (confirm2("Clear the current playlist, are you sure? " ))
        {
	    clearPlayList();
            alert("Playlist cleared.");
        }
        playlistSliderDragged = false;
  }
}
//=====================
//End function
//=====================


//=====================
// this function caters for a CR keypress when using the search form text entry
//=====================
function searchTextOnKeyDown(Sender,Key,KeyChar,Shift)
{
  dprint("Key " + Key);
  dprint("KeyChar " + KeyChar);
  if (Key === 13) {
        searchbuttonOnMouseUp();
  }
}
//=====================
//End function
//=====================




//===========================================================================
// To be carried over from the yahoo widget
//===========================================================================
// up and down images for font selection - done
// double click error - fixed
// savefile xml, modified to use newline as a delineator - done
// readSiteRecords to handle xpsf files - done
// delete button reset during drags not working perfectly - fixed
// capitalisation during drags - fixed
// grey highlight on dragging - fixed
// savefile xpsf, modified to use within writefile - done
// change the first/last button code to test for actual last tracks as per YWE - easy
// first/last button code bug - chunks - fixed
// new switch to allow xpsf files to be saved top left red tap - implemented
// xml/ xpsf tooltips change on all relevant buttons
// capture ctrl - done
// new U side button to open a URL - wip
// add a rotating timer to the URL search after play
// change URL Search button to download and play
// add the enter key play after a valid URL entered
// two additional prefs functions - fade and resizing
// additional prefs functions - autoplay - added
// key fade functionality fixed by reverting to the timer method used in the YWE version
// additional prefs save and initialise for fade - added
// lighting the back of the page number   - easy
// resizing now corrected and enabled with a CTRL press as per the YWE version
// add search box - done -  code for search to be completed
// function to save the last used music folder path - number 4
// add a tooltip to the clear playlist drop down
// after clearing the playlist - right clicking on the playlist only - partlyselectedtrack error 3517 in Xwidget only
// if the drag and drop point is the same the onMouseUp should clear the track-hover, the bug is the same on the YWE version
// key fade optimised to use less cpu
// dragging internally, seems to be working - but not downward drags
// ctrl+c + ctrl+v - working as expected
// test external dragging - single and multiple files good
// test external dragging - folders
// when opening a folder by dragging/dropping - alert that this will replace the current play list
// ctrl+x & ctrl+v - not allowing a paste afterward
// after clearing the playlist, right clicking causes repopulation of the same playlist. Xwidget engine bug.
// fixed the debugflg setting
// scrollwheel direction - volume, resizing and playlist test and correct
// scrollwheel direction - volume, resizing and playlist saving and re-opening prefs

// Note:
// 1. after opening a fileopen dialog box xwidget responds with a "" and not null if cancelled
// 2. if a string is undefined, then a lowercase function will fail with an undefined object error, YWE is not so picky
// 3. If you do a right click on an object that has the OnMouseDown event captured then both left mouse clicks and right mouse clicks mistakenly generate an event.

// TBD

// autoplay code - wip and test - still playing after an internal drag/drop operation
// need to highlight the currently playing track after an internal drag/drop that alters the playlist structure

// url form for the U side button - done - code yet to be completed - playlist bug
// take the code directly from the YWE version

// http://www.largesound.com/ashborytour/sound/brobob.mp3
// eg. http://www.kozco.com/tech/piano2.wav


// function descriptions
// order the functions as per the Ywidget   - tedious


